/* DeltaUpdater.c generated by valac 0.22.1, the Vala compiler
 * generated from DeltaUpdater.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gtk/gtk.h>


#define TYPE_DELTA_UPDATER (delta_updater_get_type ())
#define DELTA_UPDATER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELTA_UPDATER, DeltaUpdater))
#define DELTA_UPDATER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELTA_UPDATER, DeltaUpdaterClass))
#define IS_DELTA_UPDATER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELTA_UPDATER))
#define IS_DELTA_UPDATER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELTA_UPDATER))
#define DELTA_UPDATER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELTA_UPDATER, DeltaUpdaterClass))

typedef struct _DeltaUpdater DeltaUpdater;
typedef struct _DeltaUpdaterClass DeltaUpdaterClass;
typedef struct _DeltaUpdaterPrivate DeltaUpdaterPrivate;

#define TYPE_WEAK_REF (weak_ref_get_type ())
#define WEAK_REF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WEAK_REF, WeakRef))
#define WEAK_REF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WEAK_REF, WeakRefClass))
#define IS_WEAK_REF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WEAK_REF))
#define IS_WEAK_REF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WEAK_REF))
#define WEAK_REF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WEAK_REF, WeakRefClass))

typedef struct _WeakRef WeakRef;
typedef struct _WeakRefClass WeakRefClass;

#define TYPE_ITWITTER_ITEM (itwitter_item_get_type ())
#define ITWITTER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ITWITTER_ITEM, ITwitterItem))
#define IS_ITWITTER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ITWITTER_ITEM))
#define ITWITTER_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ITWITTER_ITEM, ITwitterItemIface))

typedef struct _ITwitterItem ITwitterItem;
typedef struct _ITwitterItemIface ITwitterItemIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _DeltaUpdater {
	GObject parent_instance;
	DeltaUpdaterPrivate * priv;
};

struct _DeltaUpdaterClass {
	GObjectClass parent_class;
};

struct _ITwitterItemIface {
	GTypeInterface parent_iface;
	gint (*update_time_delta) (ITwitterItem* self, GDateTime* now);
	gint64 (*get_sort_factor) (ITwitterItem* self);
	gboolean (*get_seen) (ITwitterItem* self);
	void (*set_seen) (ITwitterItem* self, gboolean value);
};

struct _DeltaUpdaterPrivate {
	GeeArrayList* minutely;
	GeeArrayList* hourly;
	guint minutely_id;
	guint hourly_id;
};


static gpointer delta_updater_parent_class = NULL;

GType delta_updater_get_type (void) G_GNUC_CONST;
GType weak_ref_get_type (void) G_GNUC_CONST;
GType itwitter_item_get_type (void) G_GNUC_CONST;
#define DELTA_UPDATER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DELTA_UPDATER, DeltaUpdaterPrivate))
enum  {
	DELTA_UPDATER_DUMMY_PROPERTY
};
DeltaUpdater* delta_updater_new (void);
DeltaUpdater* delta_updater_construct (GType object_type);
static gboolean __lambda34_ (DeltaUpdater* self);
gpointer weak_ref_get (WeakRef* self);
gint itwitter_item_update_time_delta (ITwitterItem* self, GDateTime* now);
static gboolean ___lambda34__gsource_func (gpointer self);
static gboolean __lambda35_ (DeltaUpdater* self);
static gboolean ___lambda35__gsource_func (gpointer self);
void delta_updater_add (DeltaUpdater* self, ITwitterItem* entry);
gint64 itwitter_item_get_sort_factor (ITwitterItem* self);
WeakRef* weak_ref_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer obj);
WeakRef* weak_ref_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer obj);
static void delta_updater_finalize (GObject* obj);


static gboolean __lambda34_ (DeltaUpdater* self) {
	gboolean result = FALSE;
	{
		gint i = 0;
		gint size = 0;
		GeeArrayList* _tmp0_ = NULL;
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		i = 0;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp0_ = self->priv->minutely;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp2_ = _tmp1_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		size = _tmp2_;
#line 126 "DeltaUpdater.c"
		{
			gboolean _tmp3_ = FALSE;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			_tmp3_ = TRUE;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			while (TRUE) {
#line 133 "DeltaUpdater.c"
				gboolean _tmp4_ = FALSE;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				WeakRef* item_ref = NULL;
				GeeArrayList* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gpointer _tmp10_ = NULL;
				ITwitterItem* item = NULL;
				GeeArrayList* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gpointer _tmp13_ = NULL;
				WeakRef* _tmp14_ = NULL;
				gpointer _tmp15_ = NULL;
				ITwitterItem* _tmp16_ = NULL;
				ITwitterItem* _tmp17_ = NULL;
				gint seconds = 0;
				ITwitterItem* _tmp21_ = NULL;
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp4_ = _tmp3_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (!_tmp4_) {
#line 157 "DeltaUpdater.c"
					gint _tmp5_ = 0;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp5_ = i;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					i = _tmp5_ + 1;
#line 163 "DeltaUpdater.c"
				}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp3_ = FALSE;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp6_ = i;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp7_ = size;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					break;
#line 175 "DeltaUpdater.c"
				}
#line 29 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp8_ = self->priv->minutely;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp9_ = i;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp10_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp9_);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				item_ref = (WeakRef*) _tmp10_;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp11_ = self->priv->minutely;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp12_ = i;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp13_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp12_);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp14_ = (WeakRef*) _tmp13_;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp15_ = weak_ref_get (_tmp14_);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp16_ = (ITwitterItem*) _tmp15_;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_g_object_unref0 (_tmp14_);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				item = _tmp16_;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp17_ = item;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (_tmp17_ == NULL) {
#line 205 "DeltaUpdater.c"
					GeeArrayList* _tmp18_ = NULL;
					WeakRef* _tmp19_ = NULL;
					gint _tmp20_ = 0;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp18_ = self->priv->minutely;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp19_ = item_ref;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp20_ = size;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					size = _tmp20_ - 1;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_g_object_unref0 (item);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_g_object_unref0 (item_ref);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					continue;
#line 225 "DeltaUpdater.c"
				}
#line 36 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp21_ = item;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp22_ = itwitter_item_update_time_delta (_tmp21_, NULL);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				seconds = _tmp22_;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp23_ = seconds;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (_tmp23_ >= 3600) {
#line 237 "DeltaUpdater.c"
					GeeArrayList* _tmp24_ = NULL;
					WeakRef* _tmp25_ = NULL;
					GeeArrayList* _tmp26_ = NULL;
					WeakRef* _tmp27_ = NULL;
					gint _tmp28_ = 0;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp24_ = self->priv->minutely;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp25_ = item_ref;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp25_);
#line 39 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp26_ = self->priv->hourly;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp27_ = item_ref;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp27_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp28_ = size;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					size = _tmp28_ - 1;
#line 259 "DeltaUpdater.c"
				}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_g_object_unref0 (item);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_g_object_unref0 (item_ref);
#line 265 "DeltaUpdater.c"
			}
		}
	}
#line 43 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	result = TRUE;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	return result;
#line 273 "DeltaUpdater.c"
}


static gboolean ___lambda34__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda34_ (self);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	return result;
#line 282 "DeltaUpdater.c"
}


static gboolean __lambda35_ (DeltaUpdater* self) {
	gboolean result = FALSE;
	{
		gint i = 0;
		gint size = 0;
		GeeArrayList* _tmp0_ = NULL;
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		i = 0;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp0_ = self->priv->hourly;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp2_ = _tmp1_;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		size = _tmp2_;
#line 304 "DeltaUpdater.c"
		{
			gboolean _tmp3_ = FALSE;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			_tmp3_ = TRUE;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			while (TRUE) {
#line 311 "DeltaUpdater.c"
				gboolean _tmp4_ = FALSE;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				WeakRef* item_ref = NULL;
				GeeArrayList* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gpointer _tmp10_ = NULL;
				WeakRef* _tmp11_ = NULL;
				gpointer _tmp12_ = NULL;
				ITwitterItem* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				WeakRef* _tmp18_ = NULL;
				gpointer _tmp19_ = NULL;
				ITwitterItem* _tmp20_ = NULL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp4_ = _tmp3_;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (!_tmp4_) {
#line 330 "DeltaUpdater.c"
					gint _tmp5_ = 0;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp5_ = i;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					i = _tmp5_ + 1;
#line 336 "DeltaUpdater.c"
				}
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp3_ = FALSE;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp6_ = i;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp7_ = size;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					break;
#line 348 "DeltaUpdater.c"
				}
#line 48 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp8_ = self->priv->hourly;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp9_ = i;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp10_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp9_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				item_ref = (WeakRef*) _tmp10_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp11_ = item_ref;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp12_ = weak_ref_get (_tmp11_);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp13_ = (ITwitterItem*) _tmp12_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp14_ = _tmp13_ == NULL;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_g_object_unref0 (_tmp13_);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				if (_tmp14_) {
#line 370 "DeltaUpdater.c"
					GeeArrayList* _tmp15_ = NULL;
					WeakRef* _tmp16_ = NULL;
					gint _tmp17_ = 0;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp15_ = self->priv->hourly;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp16_ = item_ref;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp16_);
#line 51 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_tmp17_ = size;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					size = _tmp17_ - 1;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					_g_object_unref0 (item_ref);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
					continue;
#line 388 "DeltaUpdater.c"
				}
#line 54 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp18_ = item_ref;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp19_ = weak_ref_get (_tmp18_);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_tmp20_ = (ITwitterItem*) _tmp19_;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				itwitter_item_update_time_delta (_tmp20_, NULL);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_g_object_unref0 (_tmp20_);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
				_g_object_unref0 (item_ref);
#line 402 "DeltaUpdater.c"
			}
		}
	}
#line 56 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	result = TRUE;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	return result;
#line 410 "DeltaUpdater.c"
}


static gboolean ___lambda35__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda35_ (self);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	return result;
#line 419 "DeltaUpdater.c"
}


DeltaUpdater* delta_updater_construct (GType object_type) {
	DeltaUpdater * self = NULL;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 26 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self = (DeltaUpdater*) g_object_new (object_type, NULL);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (60 * 1000), ___lambda34__gsource_func, g_object_ref (self), g_object_unref);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self->priv->minutely_id = _tmp0_;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp1_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((60 * 60) * 1000), ___lambda35__gsource_func, g_object_ref (self), g_object_unref);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self->priv->hourly_id = _tmp1_;
#line 26 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	return self;
#line 439 "DeltaUpdater.c"
}


DeltaUpdater* delta_updater_new (void) {
#line 26 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	return delta_updater_construct (TYPE_DELTA_UPDATER);
#line 446 "DeltaUpdater.c"
}


void delta_updater_add (DeltaUpdater* self, ITwitterItem* entry) {
	GDateTime* now = NULL;
	GDateTime* _tmp0_ = NULL;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_ = NULL;
	ITwitterItem* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	gint64 _tmp4_ = 0LL;
	GDateTime* _tmp5_ = NULL;
	GDateTime* _tmp6_ = NULL;
	GTimeSpan _tmp7_ = 0LL;
	GTimeSpan _tmp8_ = 0LL;
	gint seconds = 0;
	GTimeSpan _tmp9_ = 0LL;
	WeakRef* r = NULL;
	ITwitterItem* _tmp10_ = NULL;
	WeakRef* _tmp11_ = NULL;
	gint _tmp12_ = 0;
#line 67 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	g_return_if_fail (IS_DELTA_UPDATER (self));
#line 67 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	g_return_if_fail (IS_ITWITTER_ITEM (entry));
#line 69 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 69 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	now = _tmp0_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp1_ = now;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp2_ = entry;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp3_ = itwitter_item_get_sort_factor (_tmp2_);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp4_ = _tmp3_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp5_ = g_date_time_new_from_unix_local (_tmp4_);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp6_ = _tmp5_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp7_ = g_date_time_difference (_tmp1_, _tmp6_);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp8_ = _tmp7_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_g_date_time_unref0 (_tmp6_);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	diff = _tmp8_;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp9_ = diff;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	seconds = (gint) ((_tmp9_ / 1000.0) / 1000.0);
#line 76 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp10_ = entry;
#line 76 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp11_ = weak_ref_new (TYPE_ITWITTER_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp10_);
#line 76 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	r = _tmp11_;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp12_ = seconds;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	if (_tmp12_ < 3600) {
#line 510 "DeltaUpdater.c"
		GeeArrayList* _tmp13_ = NULL;
		WeakRef* _tmp14_ = NULL;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp13_ = self->priv->minutely;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp14_ = r;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 519 "DeltaUpdater.c"
	} else {
		gint _tmp15_ = 0;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		_tmp15_ = seconds;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
		if (_tmp15_ < ((60 * 60) * 24)) {
#line 526 "DeltaUpdater.c"
			GeeArrayList* _tmp16_ = NULL;
			WeakRef* _tmp17_ = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			_tmp16_ = self->priv->hourly;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			_tmp17_ = r;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp17_);
#line 535 "DeltaUpdater.c"
		}
	}
#line 67 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_g_object_unref0 (r);
#line 67 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_g_date_time_unref0 (now);
#line 542 "DeltaUpdater.c"
}


static void delta_updater_class_init (DeltaUpdaterClass * klass) {
#line 20 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	delta_updater_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	g_type_class_add_private (klass, sizeof (DeltaUpdaterPrivate));
#line 20 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	G_OBJECT_CLASS (klass)->finalize = delta_updater_finalize;
#line 553 "DeltaUpdater.c"
}


static void delta_updater_instance_init (DeltaUpdater * self) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self->priv = DELTA_UPDATER_GET_PRIVATE (self);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp0_ = gee_array_list_new (TYPE_WEAK_REF, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self->priv->minutely = _tmp0_;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp1_ = gee_array_list_new (TYPE_WEAK_REF, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self->priv->hourly = _tmp1_;
#line 570 "DeltaUpdater.c"
}


static void delta_updater_finalize (GObject* obj) {
	DeltaUpdater * self;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELTA_UPDATER, DeltaUpdater);
#line 61 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp0_ = self->priv->minutely_id;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	g_source_remove (_tmp0_);
#line 62 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_tmp1_ = self->priv->hourly_id;
#line 62 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	g_source_remove (_tmp1_);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_g_object_unref0 (self->priv->minutely);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	_g_object_unref0 (self->priv->hourly);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/DeltaUpdater.vala"
	G_OBJECT_CLASS (delta_updater_parent_class)->finalize (obj);
#line 594 "DeltaUpdater.c"
}


GType delta_updater_get_type (void) {
	static volatile gsize delta_updater_type_id__volatile = 0;
	if (g_once_init_enter (&delta_updater_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DeltaUpdaterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delta_updater_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DeltaUpdater), 0, (GInstanceInitFunc) delta_updater_instance_init, NULL };
		GType delta_updater_type_id;
		delta_updater_type_id = g_type_register_static (G_TYPE_OBJECT, "DeltaUpdater", &g_define_type_info, 0);
		g_once_init_leave (&delta_updater_type_id__volatile, delta_updater_type_id);
	}
	return delta_updater_type_id__volatile;
}



