/* Filter.c generated by valac 0.22.1, the Vala compiler
 * generated from Filter.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_FILTER (filter_get_type ())
#define FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILTER, Filter))
#define FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILTER, FilterClass))
#define IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILTER))
#define IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILTER))
#define FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILTER, FilterClass))

typedef struct _Filter Filter;
typedef struct _FilterClass FilterClass;
typedef struct _FilterPrivate FilterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Filter {
	GObject parent_instance;
	FilterPrivate * priv;
};

struct _FilterClass {
	GObjectClass parent_class;
};

struct _FilterPrivate {
	gint _block_count;
	gchar* _content;
	gint _id;
	GRegex* regex;
};


static gpointer filter_parent_class = NULL;

GType filter_get_type (void) G_GNUC_CONST;
#define FILTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILTER, FilterPrivate))
enum  {
	FILTER_DUMMY_PROPERTY,
	FILTER_BLOCK_COUNT,
	FILTER_CONTENT,
	FILTER_ID
};
Filter* filter_new (const gchar* expression);
Filter* filter_construct (GType object_type, const gchar* expression);
void filter_set_content (Filter* self, const gchar* value);
void filter_reset (Filter* self, const gchar* expression);
gboolean filter_matches (Filter* self, const gchar* test_text);
gint filter_get_block_count (Filter* self);
void filter_set_block_count (Filter* self, gint value);
const gchar* filter_get_content (Filter* self);
gint filter_get_id (Filter* self);
void filter_set_id (Filter* self, gint value);
static void filter_finalize (GObject* obj);
static void _vala_filter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_filter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


Filter* filter_construct (GType object_type, const gchar* expression) {
	Filter * self = NULL;
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_val_if_fail (expression != NULL, NULL);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	self = (Filter*) g_object_new (object_type, NULL);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = expression;
#line 25 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	filter_set_content (self, _tmp0_);
#line 96 "Filter.c"
	{
		GRegex* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp2_ = expression;
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp1_ = _tmp3_;
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		if (_inner_error_ != NULL) {
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 111 "Filter.c"
				goto __catch74_g_regex_error;
			}
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			g_clear_error (&_inner_error_);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			return NULL;
#line 120 "Filter.c"
		}
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_g_regex_unref0 (self->priv->regex);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		self->priv->regex = _tmp1_;
#line 126 "Filter.c"
	}
	goto __finally74;
	__catch74_g_regex_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		e = _inner_error_;
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_inner_error_ = NULL;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp4_ = expression;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp5_ = e;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp6_ = _tmp5_->message;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_warning ("Filter.vala:29: Regex error for `%s`: %s", _tmp4_, _tmp6_);
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_g_error_free0 (e);
#line 149 "Filter.c"
	}
	__finally74:
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	if (_inner_error_ != NULL) {
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_clear_error (&_inner_error_);
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		return NULL;
#line 160 "Filter.c"
	}
#line 24 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	return self;
#line 164 "Filter.c"
}


Filter* filter_new (const gchar* expression) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	return filter_construct (TYPE_FILTER, expression);
#line 171 "Filter.c"
}


/**
   * (Re)Set the Filter's regular expression to the given one.
   *
   * @param expression The new expression.
   */
void filter_reset (Filter* self, const gchar* expression) {
	const gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_if_fail (IS_FILTER (self));
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_if_fail (expression != NULL);
#line 187 "Filter.c"
	{
		GRegex* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		GRegex* _tmp2_ = NULL;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp1_ = expression;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp0_ = _tmp2_;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		if (_inner_error_ != NULL) {
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 202 "Filter.c"
				goto __catch75_g_regex_error;
			}
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			g_clear_error (&_inner_error_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
			return;
#line 211 "Filter.c"
		}
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_g_regex_unref0 (self->priv->regex);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		self->priv->regex = _tmp0_;
#line 217 "Filter.c"
	}
	goto __finally75;
	__catch75_g_regex_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		e = _inner_error_;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_inner_error_ = NULL;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp3_ = expression;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp4_ = e;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_tmp5_ = _tmp4_->message;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_warning ("Filter.vala:42: Regex error for `%s`: %s", _tmp3_, _tmp5_);
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		_g_error_free0 (e);
#line 240 "Filter.c"
	}
	__finally75:
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	if (_inner_error_ != NULL) {
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_clear_error (&_inner_error_);
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		return;
#line 251 "Filter.c"
	}
#line 44 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp6_ = expression;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	filter_set_content (self, _tmp6_);
#line 257 "Filter.c"
}


gboolean filter_matches (Filter* self, const gchar* test_text) {
	gboolean result = FALSE;
	GRegex* _tmp0_ = NULL;
	GRegex* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_val_if_fail (IS_FILTER (self), FALSE);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_val_if_fail (test_text != NULL, FALSE);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = self->priv->regex;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	if (_tmp0_ == NULL) {
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		result = FALSE;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		return result;
#line 279 "Filter.c"
	}
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp1_ = self->priv->regex;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp2_ = test_text;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp3_ = g_regex_match (_tmp1_, _tmp2_, 0, NULL);
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	result = _tmp3_;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	return result;
#line 291 "Filter.c"
}


gint filter_get_block_count (Filter* self) {
	gint result;
	gint _tmp0_ = 0;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_val_if_fail (IS_FILTER (self), 0);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = self->priv->_block_count;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	result = _tmp0_;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	return result;
#line 306 "Filter.c"
}


void filter_set_block_count (Filter* self, gint value) {
	gint _tmp0_ = 0;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_if_fail (IS_FILTER (self));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = value;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	self->priv->_block_count = _tmp0_;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_object_notify ((GObject *) self, "block-count");
#line 320 "Filter.c"
}


const gchar* filter_get_content (Filter* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_val_if_fail (IS_FILTER (self), NULL);
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = self->priv->_content;
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	result = _tmp0_;
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	return result;
#line 335 "Filter.c"
}


void filter_set_content (Filter* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_if_fail (IS_FILTER (self));
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = value;
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_g_free0 (self->priv->_content);
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	self->priv->_content = _tmp1_;
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_object_notify ((GObject *) self, "content");
#line 354 "Filter.c"
}


gint filter_get_id (Filter* self) {
	gint result;
	gint _tmp0_ = 0;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_val_if_fail (IS_FILTER (self), 0);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = self->priv->_id;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	result = _tmp0_;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	return result;
#line 369 "Filter.c"
}


void filter_set_id (Filter* self, gint value) {
	gint _tmp0_ = 0;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_return_if_fail (IS_FILTER (self));
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_tmp0_ = value;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	self->priv->_id = _tmp0_;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_object_notify ((GObject *) self, "id");
#line 383 "Filter.c"
}


static void filter_class_init (FilterClass * klass) {
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	filter_parent_class = g_type_class_peek_parent (klass);
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_type_class_add_private (klass, sizeof (FilterPrivate));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_filter_get_property;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_filter_set_property;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	G_OBJECT_CLASS (klass)->finalize = filter_finalize;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_BLOCK_COUNT, g_param_spec_int ("block-count", "block-count", "block-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_CONTENT, g_param_spec_string ("content", "content", "content", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_ID, g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 404 "Filter.c"
}


static void filter_instance_init (Filter * self) {
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	self->priv = FILTER_GET_PRIVATE (self);
#line 411 "Filter.c"
}


static void filter_finalize (GObject* obj) {
	Filter * self;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILTER, Filter);
#line 19 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_g_free0 (self->priv->_content);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	_g_regex_unref0 (self->priv->regex);
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	G_OBJECT_CLASS (filter_parent_class)->finalize (obj);
#line 425 "Filter.c"
}


GType filter_get_type (void) {
	static volatile gsize filter_type_id__volatile = 0;
	if (g_once_init_enter (&filter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Filter), 0, (GInstanceInitFunc) filter_instance_init, NULL };
		GType filter_type_id;
		filter_type_id = g_type_register_static (G_TYPE_OBJECT, "Filter", &g_define_type_info, 0);
		g_once_init_leave (&filter_type_id__volatile, filter_type_id);
	}
	return filter_type_id__volatile;
}


static void _vala_filter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Filter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILTER, Filter);
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	switch (property_id) {
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		case FILTER_BLOCK_COUNT:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_value_set_int (value, filter_get_block_count (self));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		case FILTER_CONTENT:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_value_set_string (value, filter_get_content (self));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		case FILTER_ID:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		g_value_set_int (value, filter_get_id (self));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 464 "Filter.c"
		default:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 470 "Filter.c"
	}
}


static void _vala_filter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Filter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILTER, Filter);
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
	switch (property_id) {
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		case FILTER_BLOCK_COUNT:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		filter_set_block_count (self, g_value_get_int (value));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		case FILTER_CONTENT:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		filter_set_content (self, g_value_get_string (value));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		case FILTER_ID:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		filter_set_id (self, g_value_get_int (value));
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 498 "Filter.c"
		default:
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "/builddir/build/BUILD/corebird-0.7/src/Filter.vala"
		break;
#line 504 "Filter.c"
	}
}



