/* NotificationManager.c generated by valac 0.22.1, the Vala compiler
 * generated from NotificationManager.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>


#define TYPE_NOTIFICATION_MANAGER (notification_manager_get_type ())
#define NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManager))
#define NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))
#define IS_NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MANAGER))
#define IS_NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MANAGER))
#define NOTIFICATION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))

typedef struct _NotificationManager NotificationManager;
typedef struct _NotificationManagerClass NotificationManagerClass;
typedef struct _NotificationManagerPrivate NotificationManagerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecNotificationManager ParamSpecNotificationManager;

struct _NotificationManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NotificationManagerPrivate * priv;
};

struct _NotificationManagerClass {
	GTypeClass parent_class;
	void (*finalize) (NotificationManager *self);
};

struct _ParamSpecNotificationManager {
	GParamSpec parent_instance;
};


static gpointer notification_manager_parent_class = NULL;

gpointer notification_manager_ref (gpointer instance);
void notification_manager_unref (gpointer instance);
GParamSpec* param_spec_notification_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_notification_manager (GValue* value, gpointer v_object);
void value_take_notification_manager (GValue* value, gpointer v_object);
gpointer value_get_notification_manager (const GValue* value);
GType notification_manager_get_type (void) G_GNUC_CONST;
enum  {
	NOTIFICATION_MANAGER_DUMMY_PROPERTY
};
void notification_manager_init (void);
void notification_manager_notify (const gchar* summary, const gchar* body, NotifyUrgency urgency, const gchar* icon, const gchar* image);
void notification_manager_notify_pixbuf (const gchar* summary, const gchar* body, GdkPixbuf* icon);
void notification_manager_uninit (void);
NotificationManager* notification_manager_new (void);
NotificationManager* notification_manager_construct (GType object_type);
static void notification_manager_finalize (NotificationManager* obj);


void notification_manager_init (void) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	notify_init ("Corebird");
#line 87 "NotificationManager.c"
}


void notification_manager_notify (const gchar* summary, const gchar* body, NotifyUrgency urgency, const gchar* icon, const gchar* image) {
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	NotifyNotification* n = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	NotifyNotification* _tmp8_ = NULL;
	NotifyNotification* _tmp9_ = NULL;
	NotifyUrgency _tmp10_ = 0;
	const gchar* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 25 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (summary != NULL);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (body != NULL);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp1_ = icon;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp0_ = _tmp2_;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp3_ = _tmp0_;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (_tmp3_ == NULL) {
#line 119 "NotificationManager.c"
		gchar* _tmp4_ = NULL;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp4_ = g_strdup ("corebird");
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_free0 (_tmp0_);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp0_ = _tmp4_;
#line 127 "NotificationManager.c"
	}
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp5_ = summary;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp6_ = body;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp7_ = _tmp0_;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp8_ = notify_notification_new (_tmp5_, _tmp6_, _tmp7_);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	n = _tmp8_;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp9_ = n;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp10_ = urgency;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	notify_notification_set_urgency (_tmp9_, _tmp10_);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp11_ = image;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (_tmp11_ != NULL) {
#line 149 "NotificationManager.c"
		NotifyNotification* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		GVariant* _tmp14_ = NULL;
		GVariant* _tmp15_ = NULL;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp12_ = n;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp13_ = image;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp14_ = g_variant_new_string (_tmp13_);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_variant_ref_sink (_tmp14_);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp15_ = _tmp14_;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notify_notification_set_hint (_tmp12_, "image-path", _tmp15_);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_variant_unref0 (_tmp15_);
#line 168 "NotificationManager.c"
	}
	{
		NotifyNotification* _tmp16_ = NULL;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp16_ = n;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notify_notification_show (_tmp16_, &_inner_error_);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		if (_inner_error_ != NULL) {
#line 178 "NotificationManager.c"
			goto __catch9_g_error;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		e = _inner_error_;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp17_ = e;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp18_ = _tmp17_->message;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_warning ("NotificationManager.vala:38: Error while showing notification: %s", _tmp18_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_error_free0 (e);
#line 200 "NotificationManager.c"
	}
	__finally9:
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (_inner_error_ != NULL) {
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_object_unref0 (n);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_free0 (_tmp0_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_clear_error (&_inner_error_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		return;
#line 215 "NotificationManager.c"
	}
#line 25 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_g_object_unref0 (n);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_g_free0 (_tmp0_);
#line 221 "NotificationManager.c"
}


void notification_manager_notify_pixbuf (const gchar* summary, const gchar* body, GdkPixbuf* icon) {
	NotifyNotification* n = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	NotifyNotification* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (summary != NULL);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (body != NULL);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (GDK_IS_PIXBUF (icon));
#line 43 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp0_ = summary;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp1_ = body;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp2_ = notify_notification_new (_tmp0_, _tmp1_, NULL);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	n = _tmp2_;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	notify_notification_set_urgency (n, NOTIFY_URGENCY_NORMAL);
#line 45 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_tmp3_ = icon;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	notify_notification_set_image_from_pixbuf (n, _tmp3_);
#line 252 "NotificationManager.c"
	{
#line 48 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notify_notification_show (n, &_inner_error_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		if (_inner_error_ != NULL) {
#line 258 "NotificationManager.c"
			goto __catch10_g_error;
		}
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		e = _inner_error_;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_inner_error_ = NULL;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp4_ = e;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_tmp5_ = _tmp4_->message;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_warning ("NotificationManager.vala:50: Error while showing notification: %s", _tmp5_);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_error_free0 (e);
#line 280 "NotificationManager.c"
	}
	__finally10:
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (_inner_error_ != NULL) {
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		_g_object_unref0 (n);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_clear_error (&_inner_error_);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		return;
#line 293 "NotificationManager.c"
	}
#line 42 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	_g_object_unref0 (n);
#line 297 "NotificationManager.c"
}


/**
   * Uninitializes the notification manager
   * Should be called when the application gets closed completely.
   */
void notification_manager_uninit (void) {
#line 60 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	notify_uninit ();
#line 308 "NotificationManager.c"
}


NotificationManager* notification_manager_construct (GType object_type) {
	NotificationManager* self = NULL;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	self = (NotificationManager*) g_type_create_instance (object_type);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return self;
#line 318 "NotificationManager.c"
}


NotificationManager* notification_manager_new (void) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return notification_manager_construct (TYPE_NOTIFICATION_MANAGER);
#line 325 "NotificationManager.c"
}


static void value_notification_manager_init (GValue* value) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	value->data[0].v_pointer = NULL;
#line 332 "NotificationManager.c"
}


static void value_notification_manager_free_value (GValue* value) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (value->data[0].v_pointer) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notification_manager_unref (value->data[0].v_pointer);
#line 341 "NotificationManager.c"
	}
}


static void value_notification_manager_copy_value (const GValue* src_value, GValue* dest_value) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (src_value->data[0].v_pointer) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		dest_value->data[0].v_pointer = notification_manager_ref (src_value->data[0].v_pointer);
#line 351 "NotificationManager.c"
	} else {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 355 "NotificationManager.c"
	}
}


static gpointer value_notification_manager_peek_pointer (const GValue* value) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return value->data[0].v_pointer;
#line 363 "NotificationManager.c"
}


static gchar* value_notification_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (collect_values[0].v_pointer) {
#line 370 "NotificationManager.c"
		NotificationManager* object;
		object = collect_values[0].v_pointer;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 377 "NotificationManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 381 "NotificationManager.c"
		}
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		value->data[0].v_pointer = notification_manager_ref (object);
#line 385 "NotificationManager.c"
	} else {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		value->data[0].v_pointer = NULL;
#line 389 "NotificationManager.c"
	}
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return NULL;
#line 393 "NotificationManager.c"
}


static gchar* value_notification_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	NotificationManager** object_p;
	object_p = collect_values[0].v_pointer;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (!object_p) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 404 "NotificationManager.c"
	}
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (!value->data[0].v_pointer) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		*object_p = NULL;
#line 410 "NotificationManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		*object_p = value->data[0].v_pointer;
#line 414 "NotificationManager.c"
	} else {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		*object_p = notification_manager_ref (value->data[0].v_pointer);
#line 418 "NotificationManager.c"
	}
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return NULL;
#line 422 "NotificationManager.c"
}


GParamSpec* param_spec_notification_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecNotificationManager* spec;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_NOTIFICATION_MANAGER), NULL);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return G_PARAM_SPEC (spec);
#line 436 "NotificationManager.c"
}


gpointer value_get_notification_manager (const GValue* value) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_MANAGER), NULL);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return value->data[0].v_pointer;
#line 445 "NotificationManager.c"
}


void value_set_notification_manager (GValue* value, gpointer v_object) {
	NotificationManager* old;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_MANAGER));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	old = value->data[0].v_pointer;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (v_object) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NOTIFICATION_MANAGER));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		value->data[0].v_pointer = v_object;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notification_manager_ref (value->data[0].v_pointer);
#line 465 "NotificationManager.c"
	} else {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		value->data[0].v_pointer = NULL;
#line 469 "NotificationManager.c"
	}
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (old) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notification_manager_unref (old);
#line 475 "NotificationManager.c"
	}
}


void value_take_notification_manager (GValue* value, gpointer v_object) {
	NotificationManager* old;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NOTIFICATION_MANAGER));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	old = value->data[0].v_pointer;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (v_object) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NOTIFICATION_MANAGER));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		value->data[0].v_pointer = v_object;
#line 494 "NotificationManager.c"
	} else {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		value->data[0].v_pointer = NULL;
#line 498 "NotificationManager.c"
	}
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (old) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		notification_manager_unref (old);
#line 504 "NotificationManager.c"
	}
}


static void notification_manager_class_init (NotificationManagerClass * klass) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	notification_manager_parent_class = g_type_class_peek_parent (klass);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	NOTIFICATION_MANAGER_CLASS (klass)->finalize = notification_manager_finalize;
#line 514 "NotificationManager.c"
}


static void notification_manager_instance_init (NotificationManager * self) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	self->ref_count = 1;
#line 521 "NotificationManager.c"
}


static void notification_manager_finalize (NotificationManager* obj) {
	NotificationManager * self;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION_MANAGER, NotificationManager);
#line 529 "NotificationManager.c"
}


GType notification_manager_get_type (void) {
	static volatile gsize notification_manager_type_id__volatile = 0;
	if (g_once_init_enter (&notification_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_notification_manager_init, value_notification_manager_free_value, value_notification_manager_copy_value, value_notification_manager_peek_pointer, "p", value_notification_manager_collect_value, "p", value_notification_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NotificationManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationManager), 0, (GInstanceInitFunc) notification_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType notification_manager_type_id;
		notification_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NotificationManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&notification_manager_type_id__volatile, notification_manager_type_id);
	}
	return notification_manager_type_id__volatile;
}


gpointer notification_manager_ref (gpointer instance) {
	NotificationManager* self;
	self = instance;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	return instance;
#line 554 "NotificationManager.c"
}


void notification_manager_unref (gpointer instance) {
	NotificationManager* self;
	self = instance;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		NOTIFICATION_MANAGER_GET_CLASS (self)->finalize (self);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/NotificationManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 567 "NotificationManager.c"
	}
}



