/* Tweet.c generated by valac 0.22.1, the Vala compiler
 * generated from Tweet.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>


#define TYPE_TWEET (tweet_get_type ())
#define TWEET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWEET, Tweet))
#define TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWEET, TweetClass))
#define IS_TWEET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWEET))
#define IS_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWEET))
#define TWEET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWEET, TweetClass))

typedef struct _Tweet Tweet;
typedef struct _TweetClass TweetClass;
typedef struct _TweetPrivate TweetPrivate;

#define TWEET_UTILS_TYPE_SEQUENCE (tweet_utils_sequence_get_type ())
typedef struct _TweetUtilsSequence TweetUtilsSequence;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_slist_free__tweet_utils_sequence_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__tweet_utils_sequence_free0_ (var), NULL)))

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
typedef struct _Block4Data Block4Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define TYPE_TWITTER (twitter_get_type ())
#define TWITTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWITTER, Twitter))
#define TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWITTER, TwitterClass))
#define IS_TWITTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWITTER))
#define IS_TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWITTER))
#define TWITTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWITTER, TwitterClass))

typedef struct _Twitter Twitter;
typedef struct _TwitterClass TwitterClass;

struct _Tweet {
	GObject parent_instance;
	TweetPrivate * priv;
	gint64 id;
	gint64 rt_id;
	gchar* text;
	gint64 user_id;
	gchar* user_name;
	gchar* retweeted_by;
	gchar* rt_by_screen_name;
	gint64 rt_by_id;
	gboolean is_retweet;
	GdkPixbuf* inline_media;
	gchar* time_delta;
	gchar* avatar_url;
	gchar* avatar_name;
	gchar* screen_name;
	gint64 created_at;
	gint64 rt_created_at;
	gboolean verified;
	gint64 my_retweet;
	gint64 reply_id;
	gchar* media;
	gchar* media_thumb;
	gboolean has_inline_media;
	gint retweet_count;
	gint favorite_count;
	gchar** mentions;
	gint mentions_length1;
};

struct _TweetClass {
	GObjectClass parent_class;
};

struct _TweetUtilsSequence {
	gint start;
	gint end;
	gchar* url;
	gchar* display_url;
	gboolean visual_display_url;
	gchar* title;
};

struct _TweetPrivate {
	gboolean _retweeted;
	gboolean _favorited;
	GdkPixbuf* _avatar;
	GSList* urls;
};

struct _Block4Data {
	int _ref_count_;
	Tweet * self;
	gint real_mentions;
	Account* account;
};

typedef void (*TwitterAvatarDownloadedFunc) (GdkPixbuf* avatar, void* user_data);

static gpointer tweet_parent_class = NULL;
extern GdkPixbuf* twitter_no_avatar;

GType tweet_get_type (void) G_GNUC_CONST;
GType tweet_utils_sequence_get_type (void) G_GNUC_CONST;
TweetUtilsSequence* tweet_utils_sequence_dup (const TweetUtilsSequence* self);
void tweet_utils_sequence_free (TweetUtilsSequence* self);
void tweet_utils_sequence_copy (const TweetUtilsSequence* self, TweetUtilsSequence* dest);
void tweet_utils_sequence_destroy (TweetUtilsSequence* self);
#define TWEET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TWEET, TweetPrivate))
enum  {
	TWEET_DUMMY_PROPERTY,
	TWEET_RETWEETED,
	TWEET_FAVORITED,
	TWEET_AVATAR
};
static void _tweet_utils_sequence_free0_ (gpointer var);
static void _g_slist_free__tweet_utils_sequence_free0_ (GSList* self);
#define TWEET_MAX_LENGTH 140
Tweet* tweet_new (void);
Tweet* tweet_construct (GType object_type);
void tweet_set_avatar (Tweet* self, GdkPixbuf* value);
GType account_get_type (void) G_GNUC_CONST;
void tweet_load_from_json (Tweet* self, JsonNode* status_node, GDateTime* now, Account* account);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
void tweet_set_favorited (Tweet* self, gboolean value);
void tweet_set_retweeted (Tweet* self, gboolean value);
GDateTime* utils_parse_date (const gchar* input);
gchar* utils_get_avatar_name (const gchar* path);
static void __lambda15_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
void inline_media_downloader_try_load_media (Tweet* t, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_);
void inline_media_downloader_try_load_media_finish (GAsyncResult* _res_);
static void ___lambda15__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
static void __lambda27_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
static void ___lambda27__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
static void __lambda28_ (Block4Data* _data4_, JsonArray* arr, guint index, JsonNode* node);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
const gchar* account_get_screen_name (Account* self);
static void ___lambda28__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
static void ___lambda29_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
static void ____lambda29__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
gchar* utils_get_time_delta (GDateTime* time, GDateTime* now);
GType twitter_get_type (void) G_GNUC_CONST;
Twitter* twitter_get (void);
GdkPixbuf* twitter_get_avatar (Twitter* self, const gchar* url, TwitterAvatarDownloadedFunc func, void* func_target, GDestroyNotify func_target_destroy_notify);
static void __lambda30_ (Tweet* self, GdkPixbuf* a);
static void ___lambda30__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self);
gchar* tweet_get_formatted_text (Tweet* self);
gchar* tweet_utils_get_formatted_text (const gchar* tweet_text, GSList* urls);
gchar* tweet_get_real_text (Tweet* self);
gchar* tweet_utils_get_real_text (const gchar* tweet_text, GSList* urls);
gboolean tweet_get_retweeted (Tweet* self);
gboolean tweet_get_favorited (Tweet* self);
GdkPixbuf* tweet_get_avatar (Tweet* self);
static void tweet_finalize (GObject* obj);
static void _vala_tweet_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tweet_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static void _tweet_utils_sequence_free0_ (gpointer var) {
#line 63 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	(var == NULL) ? NULL : (var = (tweet_utils_sequence_free (var), NULL));
#line 199 "Tweet.c"
}


static void _g_slist_free__tweet_utils_sequence_free0_ (GSList* self) {
#line 63 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_slist_foreach (self, (GFunc) _tweet_utils_sequence_free0_, NULL);
#line 63 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_slist_free (self);
#line 208 "Tweet.c"
}


Tweet* tweet_construct (GType object_type) {
	Tweet * self = NULL;
	GdkPixbuf* _tmp0_ = NULL;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self = (Tweet*) g_object_new (object_type, NULL);
#line 72 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = twitter_no_avatar;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_set_avatar (self, _tmp0_);
#line 71 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return self;
#line 223 "Tweet.c"
}


Tweet* tweet_new (void) {
#line 71 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return tweet_construct (TYPE_TWEET);
#line 230 "Tweet.c"
}


/**
   * Fills all the data of this tweet from Json data.
   * @param status The Json object to get the data from
   * @param now The current time
   */
static gpointer _g_object_ref0 (gpointer self) {
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return self ? g_object_ref (self) : NULL;
#line 242 "Tweet.c"
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return _data4_;
#line 251 "Tweet.c"
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 260 "Tweet.c"
		Tweet * self;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self = _data4_->self;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_object_unref0 (_data4_->account);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_object_unref0 (self);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		g_slice_free (Block4Data, _data4_);
#line 270 "Tweet.c"
	}
}


static gpointer _json_object_ref0 (gpointer self) {
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return self ? json_object_ref (self) : NULL;
#line 278 "Tweet.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 291 "Tweet.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 321 "Tweet.c"
				goto __catch6_g_regex_error;
			}
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 330 "Tweet.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 346 "Tweet.c"
				goto __catch6_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 357 "Tweet.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 365 "Tweet.c"
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1246 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 379 "Tweet.c"
	}
	__finally6:
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return NULL;
#line 390 "Tweet.c"
	}
}


static gpointer _json_array_ref0 (gpointer self) {
#line 133 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return self ? json_array_ref (self) : NULL;
#line 398 "Tweet.c"
}


static gpointer _tweet_utils_sequence_dup0 (gpointer self) {
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return self ? tweet_utils_sequence_dup (self) : NULL;
#line 405 "Tweet.c"
}


static void __lambda15_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* url = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	gchar* expanded_url = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp5_ = NULL;
	JsonArray* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint64 _tmp10_ = 0LL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	TweetUtilsSequence _tmp15_ = {0};
	TweetUtilsSequence _tmp16_ = {0};
	TweetUtilsSequence* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 139 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = node;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 139 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 139 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	url = _tmp2_;
#line 140 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp3_ = json_object_get_string_member (url, "expanded_url");
#line 140 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 140 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	expanded_url = _tmp4_;
#line 142 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp5_ = json_object_get_array_member (url, "indices");
#line 142 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp6_ = _json_array_ref0 (_tmp5_);
#line 142 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	indices = _tmp6_;
#line 143 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp7_ = expanded_url;
#line 143 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp8_ = string_replace (_tmp7_, "&", "&amp;");
#line 143 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 143 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	expanded_url = _tmp8_;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp9_ = json_array_get_int_element (indices, (guint) 0);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp10_ = json_array_get_int_element (indices, (guint) 1);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_ = expanded_url;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp13_ = json_object_get_string_member (url, "display_url");
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	memset (&_tmp15_, 0, sizeof (TweetUtilsSequence));
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.start = (gint) _tmp9_;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.end = (gint) _tmp10_;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp15_.url);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.url = _tmp12_;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp15_.display_url);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.display_url = _tmp14_;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.visual_display_url = FALSE;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp16_ = _tmp15_;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp17_ = _tweet_utils_sequence_dup0 (&_tmp16_);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp17_);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp16_);
#line 151 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp18_ = expanded_url;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	inline_media_downloader_try_load_media (self, _tmp18_, NULL, NULL);
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (url);
#line 510 "Tweet.c"
}


static void ___lambda15__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	__lambda15_ (self, array, index_, element_node);
#line 517 "Tweet.c"
}


static void __lambda27_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* hashtag = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp3_ = NULL;
	JsonArray* _tmp4_ = NULL;
	gint64 _tmp5_ = 0LL;
	gint64 _tmp6_ = 0LL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	TweetUtilsSequence _tmp11_ = {0};
	TweetUtilsSequence _tmp12_ = {0};
	TweetUtilsSequence* _tmp13_ = NULL;
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 155 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = node;
#line 155 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 155 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 155 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	hashtag = _tmp2_;
#line 156 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp3_ = json_object_get_array_member (hashtag, "indices");
#line 156 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp4_ = _json_array_ref0 (_tmp3_);
#line 156 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	indices = _tmp4_;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp5_ = json_array_get_int_element (indices, (guint) 0);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp6_ = json_array_get_int_element (indices, (guint) 1);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp7_ = json_object_get_string_member (hashtag, "text");
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp8_ = g_strconcat ("#", _tmp7_, NULL);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp9_ = json_object_get_string_member (hashtag, "text");
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp10_ = g_strconcat ("#", _tmp9_, NULL);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	memset (&_tmp11_, 0, sizeof (TweetUtilsSequence));
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_.start = (gint) _tmp5_;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_.end = (gint) _tmp6_;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp11_.url);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_.url = _tmp8_;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp11_.display_url);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_.display_url = _tmp10_;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_.visual_display_url = FALSE;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp12_ = _tmp11_;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp13_ = _tweet_utils_sequence_dup0 (&_tmp12_);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp13_);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp12_);
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (hashtag);
#line 596 "Tweet.c"
}


static void ___lambda27__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	__lambda27_ (self, array, index_, element_node);
#line 603 "Tweet.c"
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	for (i = 0; i < stack_length; i++) {
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			return TRUE;
#line 615 "Tweet.c"
		}
	}
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return FALSE;
#line 620 "Tweet.c"
}


static void __lambda28_ (Block4Data* _data4_, JsonArray* arr, guint index, JsonNode* node) {
	Tweet * self;
	JsonObject* mention = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonArray* indices = NULL;
	JsonObject* _tmp3_ = NULL;
	JsonArray* _tmp4_ = NULL;
	JsonArray* _tmp5_ = NULL;
	gchar* screen_name = NULL;
	JsonObject* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_ = NULL;
	gchar** _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp20_ = FALSE;
	JsonArray* _tmp27_ = NULL;
	gint64 _tmp28_ = 0LL;
	JsonArray* _tmp29_ = NULL;
	gint64 _tmp30_ = 0LL;
	JsonObject* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	gchar* _tmp33_ = NULL;
	const gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	JsonObject* _tmp36_ = NULL;
	const gchar* _tmp37_ = NULL;
	gchar* _tmp38_ = NULL;
	TweetUtilsSequence _tmp39_ = {0};
	TweetUtilsSequence _tmp40_ = {0};
	TweetUtilsSequence* _tmp41_ = NULL;
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self = _data4_->self;
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 169 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = node;
#line 169 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 169 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 169 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	mention = _tmp2_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp3_ = mention;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp4_ = json_object_get_array_member (_tmp3_, "indices");
#line 170 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp5_ = _json_array_ref0 (_tmp4_);
#line 170 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	indices = _tmp5_;
#line 172 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp6_ = mention;
#line 172 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp7_ = json_object_get_string_member (_tmp6_, "screen_name");
#line 172 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 172 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	screen_name = _tmp8_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_ = screen_name;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp12_ = self->mentions;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp12__length1 = self->mentions_length1;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (!_vala_string_array_contains (_tmp12_, _tmp12__length1, _tmp11_)) {
#line 698 "Tweet.c"
		const gchar* _tmp13_ = NULL;
		Account* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp13_ = screen_name;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp14_ = _data4_->account;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp15_ = account_get_screen_name (_tmp14_);
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp16_ = _tmp15_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp10_ = g_strcmp0 (_tmp13_, _tmp16_) != 0;
#line 713 "Tweet.c"
	} else {
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp10_ = FALSE;
#line 717 "Tweet.c"
	}
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp17_ = _tmp10_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (_tmp17_) {
#line 723 "Tweet.c"
		const gchar* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
#line 175 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp18_ = screen_name;
#line 175 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp19_ = self->screen_name;
#line 175 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp9_ = g_strcmp0 (_tmp18_, _tmp19_) != 0;
#line 732 "Tweet.c"
	} else {
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp9_ = FALSE;
#line 736 "Tweet.c"
	}
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp20_ = _tmp9_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (_tmp20_) {
#line 742 "Tweet.c"
		gchar** _tmp21_ = NULL;
		gint _tmp21__length1 = 0;
		gint _tmp22_ = 0;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gint _tmp26_ = 0;
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp21_ = self->mentions;
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp21__length1 = self->mentions_length1;
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp22_ = _data4_->real_mentions;
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp23_ = screen_name;
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp24_ = g_strconcat ("@", _tmp23_, NULL);
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (_tmp21_[_tmp22_]);
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp21_[_tmp22_] = _tmp24_;
#line 176 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp25_ = _tmp21_[_tmp22_];
#line 177 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp26_ = _data4_->real_mentions;
#line 177 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_data4_->real_mentions = _tmp26_ + 1;
#line 770 "Tweet.c"
	}
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp27_ = indices;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp28_ = json_array_get_int_element (_tmp27_, (guint) 0);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp29_ = indices;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp30_ = json_array_get_int_element (_tmp29_, (guint) 1);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp31_ = mention;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp32_ = json_object_get_string_member (_tmp31_, "id_str");
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp33_ = g_strconcat ("@", _tmp32_, NULL);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp34_ = screen_name;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp35_ = g_strconcat ("@", _tmp34_, NULL);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp36_ = mention;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp37_ = json_object_get_string_member (_tmp36_, "name");
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp38_ = g_strdup (_tmp37_);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	memset (&_tmp39_, 0, sizeof (TweetUtilsSequence));
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp39_.start = (gint) _tmp28_;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp39_.end = (gint) _tmp30_;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp39_.url);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp39_.url = _tmp33_;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp39_.display_url);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp39_.display_url = _tmp35_;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp39_.visual_display_url = TRUE;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp39_.title);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp39_.title = _tmp38_;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp40_ = _tmp39_;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp41_ = _tweet_utils_sequence_dup0 (&_tmp40_);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp41_);
#line 179 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp40_);
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (screen_name);
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (mention);
#line 830 "Tweet.c"
}


static void ___lambda28__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	__lambda28_ (self, array, index_, element_node);
#line 837 "Tweet.c"
}


static void ___lambda29_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* url = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	gchar* expanded_url = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp7_ = NULL;
	JsonArray* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint64 _tmp10_ = 0LL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	TweetUtilsSequence _tmp15_ = {0};
	TweetUtilsSequence _tmp16_ = {0};
	TweetUtilsSequence* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 195 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = node;
#line 195 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 195 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 195 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	url = _tmp2_;
#line 196 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->has_inline_media = TRUE;
#line 197 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp3_ = json_object_get_string_member (url, "expanded_url");
#line 197 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 197 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	expanded_url = _tmp4_;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp5_ = expanded_url;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp6_ = string_replace (_tmp5_, "&", "&amp;");
#line 198 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 198 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	expanded_url = _tmp6_;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp7_ = json_object_get_array_member (url, "indices");
#line 199 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 199 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	indices = _tmp8_;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp9_ = json_array_get_int_element (indices, (guint) 0);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp10_ = json_array_get_int_element (indices, (guint) 1);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_ = expanded_url;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp13_ = json_object_get_string_member (url, "display_url");
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	memset (&_tmp15_, 0, sizeof (TweetUtilsSequence));
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.start = (gint) _tmp9_;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.end = (gint) _tmp10_;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp15_.url);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.url = _tmp12_;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (_tmp15_.display_url);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.display_url = _tmp14_;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_.visual_display_url = FALSE;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp16_ = _tmp15_;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp17_ = _tweet_utils_sequence_dup0 (&_tmp16_);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp17_);
#line 200 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp16_);
#line 207 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp18_ = json_object_get_string_member (url, "media_url");
#line 207 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	inline_media_downloader_try_load_media (self, _tmp18_, NULL, NULL);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (url);
#line 944 "Tweet.c"
}


static void ____lambda29__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	___lambda29_ (self, array, index_, element_node);
#line 951 "Tweet.c"
}


static void __lambda30_ (Tweet* self, GdkPixbuf* a) {
	GdkPixbuf* _tmp0_ = NULL;
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (GDK_IS_PIXBUF (a));
#line 220 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = a;
#line 220 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_set_avatar (self, _tmp0_);
#line 963 "Tweet.c"
}


static void ___lambda30__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self) {
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	__lambda30_ (self, avatar);
#line 970 "Tweet.c"
}


void tweet_load_from_json (Tweet* self, JsonNode* status_node, GDateTime* now, Account* account) {
	Block4Data* _data4_;
	Account* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
	JsonObject* status = NULL;
	JsonNode* _tmp2_ = NULL;
	JsonObject* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	JsonObject* user = NULL;
	JsonObject* _tmp5_ = NULL;
	JsonObject* _tmp6_ = NULL;
	JsonObject* _tmp7_ = NULL;
	JsonObject* entities = NULL;
	JsonObject* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	JsonObject* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	JsonObject* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	JsonObject* _tmp14_ = NULL;
	gint64 _tmp15_ = 0LL;
	JsonObject* _tmp16_ = NULL;
	gint64 _tmp17_ = 0LL;
	JsonObject* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	GDateTime* _tmp20_ = NULL;
	GDateTime* _tmp21_ = NULL;
	gint64 _tmp22_ = 0LL;
	JsonObject* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	JsonObject* _tmp92_ = NULL;
	gboolean _tmp93_ = FALSE;
	const gchar* _tmp97_ = NULL;
	gchar* _tmp98_ = NULL;
	const gchar* _tmp99_ = NULL;
	gchar* _tmp100_ = NULL;
	JsonArray* urls = NULL;
	JsonObject* _tmp101_ = NULL;
	JsonArray* _tmp102_ = NULL;
	JsonArray* _tmp103_ = NULL;
	JsonArray* hashtags = NULL;
	JsonObject* _tmp104_ = NULL;
	JsonArray* _tmp105_ = NULL;
	JsonArray* _tmp106_ = NULL;
	JsonArray* user_mentions = NULL;
	JsonObject* _tmp107_ = NULL;
	JsonArray* _tmp108_ = NULL;
	JsonArray* _tmp109_ = NULL;
	JsonArray* _tmp110_ = NULL;
	guint _tmp111_ = 0U;
	gchar** _tmp112_ = NULL;
	JsonArray* _tmp113_ = NULL;
	JsonArray* _tmp114_ = NULL;
	JsonArray* _tmp115_ = NULL;
	gint _tmp116_ = 0;
	gint _tmp117_ = 0;
	JsonObject* _tmp118_ = NULL;
	gboolean _tmp119_ = FALSE;
	gint64 _tmp124_ = 0LL;
	gboolean _tmp125_ = FALSE;
	GDateTime* dt = NULL;
	gint64 _tmp128_ = 0LL;
	GDateTime* _tmp129_ = NULL;
	GDateTime* _tmp130_ = NULL;
	gchar* _tmp131_ = NULL;
	Twitter* _tmp132_ = NULL;
	Twitter* _tmp133_ = NULL;
	const gchar* _tmp134_ = NULL;
	GdkPixbuf* _tmp135_ = NULL;
	GdkPixbuf* _tmp136_ = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (IS_TWEET (self));
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (status_node != NULL);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (now != NULL);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (IS_ACCOUNT (account));
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_data4_->_ref_count_ = 1;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_data4_->self = g_object_ref (self);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = account;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_object_unref0 (_data4_->account);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_data4_->account = _tmp1_;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = status_node;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp3_ = json_node_get_object (_tmp2_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp4_ = _json_object_ref0 (_tmp3_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	status = _tmp4_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp5_ = status;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp6_ = json_object_get_object_member (_tmp5_, "user");
#line 83 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp7_ = _json_object_ref0 (_tmp6_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	user = _tmp7_;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp8_ = status;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp9_ = json_object_get_int_member (_tmp8_, "id");
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->id = _tmp9_;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp10_ = status;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp11_ = json_object_get_boolean_member (_tmp10_, "favorited");
#line 86 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_set_favorited (self, _tmp11_);
#line 87 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp12_ = status;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp13_ = json_object_get_boolean_member (_tmp12_, "retweeted");
#line 87 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_set_retweeted (self, _tmp13_);
#line 88 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp14_ = status;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp15_ = json_object_get_int_member (_tmp14_, "retweet_count");
#line 88 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->retweet_count = (gint) _tmp15_;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp16_ = status;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp17_ = json_object_get_int_member (_tmp16_, "favorite_count");
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->favorite_count = (gint) _tmp17_;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp18_ = status;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp19_ = json_object_get_string_member (_tmp18_, "created_at");
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp20_ = utils_parse_date (_tmp19_);
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp21_ = _tmp20_;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp22_ = g_date_time_to_unix (_tmp21_);
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->created_at = _tmp22_;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_date_time_unref0 (_tmp21_);
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp23_ = status;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp24_ = json_object_has_member (_tmp23_, "retweeted_status");
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (_tmp24_) {
#line 1132 "Tweet.c"
		JsonObject* rt = NULL;
		JsonObject* _tmp25_ = NULL;
		JsonObject* _tmp26_ = NULL;
		JsonObject* _tmp27_ = NULL;
		JsonObject* rt_user = NULL;
		JsonObject* _tmp28_ = NULL;
		JsonObject* _tmp29_ = NULL;
		JsonObject* _tmp30_ = NULL;
		JsonObject* _tmp31_ = NULL;
		JsonObject* _tmp32_ = NULL;
		JsonObject* _tmp33_ = NULL;
		JsonObject* _tmp34_ = NULL;
		gint64 _tmp35_ = 0LL;
		JsonObject* _tmp36_ = NULL;
		const gchar* _tmp37_ = NULL;
		gchar* _tmp38_ = NULL;
		JsonObject* _tmp39_ = NULL;
		const gchar* _tmp40_ = NULL;
		gchar* _tmp41_ = NULL;
		JsonObject* _tmp42_ = NULL;
		gint64 _tmp43_ = 0LL;
		JsonObject* _tmp44_ = NULL;
		const gchar* _tmp45_ = NULL;
		gchar* _tmp46_ = NULL;
		JsonObject* _tmp47_ = NULL;
		const gchar* _tmp48_ = NULL;
		gchar* _tmp49_ = NULL;
		JsonObject* _tmp50_ = NULL;
		const gchar* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		JsonObject* _tmp53_ = NULL;
		gint64 _tmp54_ = 0LL;
		JsonObject* _tmp55_ = NULL;
		const gchar* _tmp56_ = NULL;
		gchar* _tmp57_ = NULL;
		JsonObject* _tmp58_ = NULL;
		const gchar* _tmp59_ = NULL;
		GDateTime* _tmp60_ = NULL;
		GDateTime* _tmp61_ = NULL;
		gint64 _tmp62_ = 0LL;
		JsonObject* _tmp63_ = NULL;
		gboolean _tmp64_ = FALSE;
		JsonObject* _tmp65_ = NULL;
		gboolean _tmp66_ = FALSE;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp25_ = status;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp26_ = json_object_get_object_member (_tmp25_, "retweeted_status");
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp27_ = _json_object_ref0 (_tmp26_);
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		rt = _tmp27_;
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp28_ = rt;
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp29_ = json_object_get_object_member (_tmp28_, "user");
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp30_ = _json_object_ref0 (_tmp29_);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		rt_user = _tmp30_;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp31_ = rt;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp32_ = json_object_get_object_member (_tmp31_, "entities");
#line 97 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp33_ = _json_object_ref0 (_tmp32_);
#line 97 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_json_object_unref0 (entities);
#line 97 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		entities = _tmp33_;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->is_retweet = TRUE;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp34_ = rt;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp35_ = json_object_get_int_member (_tmp34_, "id");
#line 99 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->rt_id = _tmp35_;
#line 100 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp36_ = user;
#line 100 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp37_ = json_object_get_string_member (_tmp36_, "name");
#line 100 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp38_ = string_replace (_tmp37_, "&", "&amp;");
#line 100 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->retweeted_by);
#line 100 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->retweeted_by = _tmp38_;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp39_ = user;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp40_ = json_object_get_string_member (_tmp39_, "screen_name");
#line 101 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 101 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->rt_by_screen_name);
#line 101 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->rt_by_screen_name = _tmp41_;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp42_ = user;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp43_ = json_object_get_int_member (_tmp42_, "id");
#line 102 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->rt_by_id = _tmp43_;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp44_ = rt;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp45_ = json_object_get_string_member (_tmp44_, "text");
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp46_ = g_strdup (_tmp45_);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->text);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->text = _tmp46_;
#line 104 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp47_ = rt_user;
#line 104 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp48_ = json_object_get_string_member (_tmp47_, "name");
#line 104 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 104 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->user_name);
#line 104 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->user_name = _tmp49_;
#line 105 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp50_ = rt_user;
#line 105 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp51_ = json_object_get_string_member (_tmp50_, "profile_image_url");
#line 105 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp52_ = g_strdup (_tmp51_);
#line 105 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->avatar_url);
#line 105 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->avatar_url = _tmp52_;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp53_ = rt_user;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp54_ = json_object_get_int_member (_tmp53_, "id");
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->user_id = _tmp54_;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp55_ = rt_user;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp56_ = json_object_get_string_member (_tmp55_, "screen_name");
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp57_ = g_strdup (_tmp56_);
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->screen_name);
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->screen_name = _tmp57_;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp58_ = rt;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp59_ = json_object_get_string_member (_tmp58_, "created_at");
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp60_ = utils_parse_date (_tmp59_);
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp61_ = _tmp60_;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp62_ = g_date_time_to_unix (_tmp61_);
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->rt_created_at = _tmp62_;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_date_time_unref0 (_tmp61_);
#line 110 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp63_ = rt_user;
#line 110 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp64_ = json_object_get_boolean_member (_tmp63_, "verified");
#line 110 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->verified = _tmp64_;
#line 111 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp65_ = rt;
#line 111 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp66_ = json_object_get_null_member (_tmp65_, "in_reply_to_status_id");
#line 111 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		if (!_tmp66_) {
#line 1309 "Tweet.c"
			JsonObject* _tmp67_ = NULL;
			gint64 _tmp68_ = 0LL;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			_tmp67_ = rt;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			_tmp68_ = json_object_get_int_member (_tmp67_, "in_reply_to_status_id");
#line 112 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			self->reply_id = _tmp68_;
#line 1318 "Tweet.c"
		}
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_json_object_unref0 (rt_user);
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_json_object_unref0 (rt);
#line 1324 "Tweet.c"
	} else {
		JsonObject* _tmp69_ = NULL;
		JsonObject* _tmp70_ = NULL;
		JsonObject* _tmp71_ = NULL;
		JsonObject* _tmp72_ = NULL;
		const gchar* _tmp73_ = NULL;
		gchar* _tmp74_ = NULL;
		JsonObject* _tmp75_ = NULL;
		const gchar* _tmp76_ = NULL;
		gchar* _tmp77_ = NULL;
		JsonObject* _tmp78_ = NULL;
		gint64 _tmp79_ = 0LL;
		JsonObject* _tmp80_ = NULL;
		const gchar* _tmp81_ = NULL;
		gchar* _tmp82_ = NULL;
		JsonObject* _tmp83_ = NULL;
		const gchar* _tmp84_ = NULL;
		gchar* _tmp85_ = NULL;
		JsonObject* _tmp86_ = NULL;
		gboolean _tmp87_ = FALSE;
		JsonObject* _tmp88_ = NULL;
		gboolean _tmp89_ = FALSE;
#line 114 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp69_ = status;
#line 114 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp70_ = json_object_get_object_member (_tmp69_, "entities");
#line 114 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp71_ = _json_object_ref0 (_tmp70_);
#line 114 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_json_object_unref0 (entities);
#line 114 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		entities = _tmp71_;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp72_ = status;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp73_ = json_object_get_string_member (_tmp72_, "text");
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp74_ = g_strdup (_tmp73_);
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->text);
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->text = _tmp74_;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp75_ = user;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp76_ = json_object_get_string_member (_tmp75_, "name");
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp77_ = g_strdup (_tmp76_);
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->user_name);
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->user_name = _tmp77_;
#line 117 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp78_ = user;
#line 117 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp79_ = json_object_get_int_member (_tmp78_, "id");
#line 117 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->user_id = _tmp79_;
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp80_ = user;
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp81_ = json_object_get_string_member (_tmp80_, "screen_name");
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp82_ = g_strdup (_tmp81_);
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->screen_name);
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->screen_name = _tmp82_;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp83_ = user;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp84_ = json_object_get_string_member (_tmp83_, "profile_image_url");
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp85_ = g_strdup (_tmp84_);
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_g_free0 (self->avatar_url);
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->avatar_url = _tmp85_;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp86_ = user;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp87_ = json_object_get_boolean_member (_tmp86_, "verified");
#line 120 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->verified = _tmp87_;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp88_ = status;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp89_ = json_object_get_null_member (_tmp88_, "in_reply_to_status_id");
#line 121 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		if (!_tmp89_) {
#line 1415 "Tweet.c"
			JsonObject* _tmp90_ = NULL;
			gint64 _tmp91_ = 0LL;
#line 122 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			_tmp90_ = status;
#line 122 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			_tmp91_ = json_object_get_int_member (_tmp90_, "in_reply_to_status_id");
#line 122 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
			self->reply_id = _tmp91_;
#line 1424 "Tweet.c"
		}
	}
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp92_ = status;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp93_ = json_object_has_member (_tmp92_, "current_user_retweet");
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (_tmp93_) {
#line 1433 "Tweet.c"
		JsonObject* _tmp94_ = NULL;
		JsonObject* _tmp95_ = NULL;
		gint64 _tmp96_ = 0LL;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp94_ = status;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp95_ = json_object_get_object_member (_tmp94_, "current_user_retweet");
#line 125 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp96_ = json_object_get_int_member (_tmp95_, "id");
#line 125 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		self->my_retweet = _tmp96_;
#line 126 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		tweet_set_retweeted (self, TRUE);
#line 1447 "Tweet.c"
	}
#line 129 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp97_ = self->user_name;
#line 129 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp98_ = string_replace (_tmp97_, "&", "&amp;");
#line 129 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->user_name);
#line 129 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->user_name = _tmp98_;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp99_ = self->avatar_url;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp100_ = utils_get_avatar_name (_tmp99_);
#line 130 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->avatar_name);
#line 130 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->avatar_name = _tmp100_;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp101_ = entities;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp102_ = json_object_get_array_member (_tmp101_, "urls");
#line 133 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp103_ = _json_array_ref0 (_tmp102_);
#line 133 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	urls = _tmp103_;
#line 134 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp104_ = entities;
#line 134 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp105_ = json_object_get_array_member (_tmp104_, "hashtags");
#line 134 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp106_ = _json_array_ref0 (_tmp105_);
#line 134 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	hashtags = _tmp106_;
#line 135 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp107_ = entities;
#line 135 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp108_ = json_object_get_array_member (_tmp107_, "user_mentions");
#line 135 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp109_ = _json_array_ref0 (_tmp108_);
#line 135 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	user_mentions = _tmp109_;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp110_ = user_mentions;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp111_ = json_array_get_length (_tmp110_);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp112_ = g_new0 (gchar*, _tmp111_ + 1);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->mentions = (_vala_array_free (self->mentions, self->mentions_length1, (GDestroyNotify) g_free), NULL);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->mentions = _tmp112_;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->mentions_length1 = _tmp111_;
#line 137 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	__g_slist_free__tweet_utils_sequence_free0_0 (self->priv->urls);
#line 137 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->urls = NULL;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp113_ = urls;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	json_array_foreach_element (_tmp113_, ___lambda15__json_array_foreach, self);
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp114_ = hashtags;
#line 154 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	json_array_foreach_element (_tmp114_, ___lambda27__json_array_foreach, self);
#line 167 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_data4_->real_mentions = 0;
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp115_ = user_mentions;
#line 168 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	json_array_foreach_element (_tmp115_, ___lambda28__json_array_foreach, _data4_);
#line 188 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp116_ = _data4_->real_mentions;
#line 188 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp117_ = _tmp116_;
#line 188 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->mentions = g_renew (gchar*, self->mentions, _tmp116_);
#line 188 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	(_tmp117_ > self->mentions_length1) ? memset (self->mentions + self->mentions_length1, 0, sizeof (gchar*) * (_tmp117_ - self->mentions_length1)) : NULL;
#line 188 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->mentions_length1 = _tmp117_;
#line 192 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp118_ = entities;
#line 192 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp119_ = json_object_has_member (_tmp118_, "media");
#line 192 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (_tmp119_) {
#line 1535 "Tweet.c"
		JsonArray* medias = NULL;
		JsonObject* _tmp120_ = NULL;
		JsonArray* _tmp121_ = NULL;
		JsonArray* _tmp122_ = NULL;
		JsonArray* _tmp123_ = NULL;
#line 193 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp120_ = entities;
#line 193 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp121_ = json_object_get_array_member (_tmp120_, "media");
#line 193 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp122_ = _json_array_ref0 (_tmp121_);
#line 193 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		medias = _tmp122_;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp123_ = medias;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		json_array_foreach_element (_tmp123_, ____lambda29__json_array_foreach, self);
#line 192 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_json_array_unref0 (medias);
#line 1555 "Tweet.c"
	}
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp125_ = self->is_retweet;
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	if (_tmp125_) {
#line 1561 "Tweet.c"
		gint64 _tmp126_ = 0LL;
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp126_ = self->rt_created_at;
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp124_ = _tmp126_;
#line 1567 "Tweet.c"
	} else {
		gint64 _tmp127_ = 0LL;
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp127_ = self->created_at;
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		_tmp124_ = _tmp127_;
#line 1574 "Tweet.c"
	}
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp128_ = _tmp124_;
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp129_ = g_date_time_new_from_unix_local (_tmp128_);
#line 215 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	dt = _tmp129_;
#line 216 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp130_ = now;
#line 216 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp131_ = utils_get_time_delta (dt, _tmp130_);
#line 216 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->time_delta);
#line 216 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->time_delta = _tmp131_;
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp132_ = twitter_get ();
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp133_ = _tmp132_;
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp134_ = self->avatar_url;
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp135_ = twitter_get_avatar (_tmp133_, _tmp134_, ___lambda30__twitter_avatar_downloaded_func, g_object_ref (self), g_object_unref);
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp136_ = _tmp135_;
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_set_avatar (self, _tmp136_);
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_object_unref0 (_tmp136_);
#line 219 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_object_unref0 (_tmp133_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_date_time_unref0 (dt);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (user_mentions);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (hashtags);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_array_unref0 (urls);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (entities);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (user);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_json_object_unref0 (status);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	block4_data_unref (_data4_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_data4_ = NULL;
#line 1624 "Tweet.c"
}


/**
   * Returns the text of this tweet in pango markup form,
   * i.e. formatted with the html tags used by pango.
   *
   * @return The tweet's formatted text.
   */
gchar* tweet_get_formatted_text (Tweet* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GSList* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 237 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), NULL);
#line 238 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = self->text;
#line 238 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = self->priv->urls;
#line 238 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = tweet_utils_get_formatted_text (_tmp0_, _tmp1_);
#line 238 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	result = _tmp2_;
#line 238 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return result;
#line 1651 "Tweet.c"
}


/**
   * Returns the text of this tweet, with its long urls.
   * Twitter automatically shortens them.
   *
   * @return The tweet's text with long urls
   */
gchar* tweet_get_real_text (Tweet* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GSList* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 247 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), NULL);
#line 248 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = self->text;
#line 248 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp1_ = self->priv->urls;
#line 248 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp2_ = tweet_utils_get_real_text (_tmp0_, _tmp1_);
#line 248 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	result = _tmp2_;
#line 248 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return result;
#line 1678 "Tweet.c"
}


gboolean tweet_get_retweeted (Tweet* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), FALSE);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = self->priv->_retweeted;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return result;
#line 1693 "Tweet.c"
}


void tweet_set_retweeted (Tweet* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (IS_TWEET (self));
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->_retweeted = _tmp0_;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_object_notify ((GObject *) self, "retweeted");
#line 1707 "Tweet.c"
}


gboolean tweet_get_favorited (Tweet* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), FALSE);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = self->priv->_favorited;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return result;
#line 1722 "Tweet.c"
}


void tweet_set_favorited (Tweet* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (IS_TWEET (self));
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->_favorited = _tmp0_;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_object_notify ((GObject *) self, "favorited");
#line 1736 "Tweet.c"
}


GdkPixbuf* tweet_get_avatar (Tweet* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), NULL);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = self->priv->_avatar;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	result = _tmp0_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	return result;
#line 1751 "Tweet.c"
}


void tweet_set_avatar (Tweet* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_return_if_fail (IS_TWEET (self));
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = value;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->_avatar = _tmp0_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_object_notify ((GObject *) self, "avatar");
#line 1765 "Tweet.c"
}


static void tweet_class_init (TweetClass * klass) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	tweet_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_type_class_add_private (klass, sizeof (TweetPrivate));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tweet_get_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tweet_set_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	G_OBJECT_CLASS (klass)->finalize = tweet_finalize;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TWEET_RETWEETED, g_param_spec_boolean ("retweeted", "retweeted", "retweeted", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TWEET_FAVORITED, g_param_spec_boolean ("favorited", "favorited", "favorited", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TWEET_AVATAR, g_param_spec_object ("avatar", "avatar", "avatar", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	g_signal_new ("inline_media_added", TYPE_TWEET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GDK_TYPE_PIXBUF);
#line 1788 "Tweet.c"
}


static void tweet_instance_init (Tweet * self) {
	gchar* _tmp0_ = NULL;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv = TWEET_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->rt_id = (gint64) 0;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->_retweeted = FALSE;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->priv->_favorited = FALSE;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_tmp0_ = g_strdup ("-1s");
#line 43 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->time_delta = _tmp0_;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->verified = FALSE;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->reply_id = (gint64) 0;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->has_inline_media = FALSE;
#line 1812 "Tweet.c"
}


static void tweet_finalize (GObject* obj) {
	Tweet * self;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEET, Tweet);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->text);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->user_name);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->retweeted_by);
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->rt_by_screen_name);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_object_unref0 (self->inline_media);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->time_delta);
#line 45 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->avatar_url);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->avatar_name);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->screen_name);
#line 57 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->media);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	_g_free0 (self->media_thumb);
#line 63 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	__g_slist_free__tweet_utils_sequence_free0_0 (self->priv->urls);
#line 68 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	self->mentions = (_vala_array_free (self->mentions, self->mentions_length1, (GDestroyNotify) g_free), NULL);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	G_OBJECT_CLASS (tweet_parent_class)->finalize (obj);
#line 1848 "Tweet.c"
}


GType tweet_get_type (void) {
	static volatile gsize tweet_type_id__volatile = 0;
	if (g_once_init_enter (&tweet_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TweetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tweet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tweet), 0, (GInstanceInitFunc) tweet_instance_init, NULL };
		GType tweet_type_id;
		tweet_type_id = g_type_register_static (G_TYPE_OBJECT, "Tweet", &g_define_type_info, 0);
		g_once_init_leave (&tweet_type_id__volatile, tweet_type_id);
	}
	return tweet_type_id__volatile;
}


static void _vala_tweet_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Tweet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWEET, Tweet);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		case TWEET_RETWEETED:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		g_value_set_boolean (value, tweet_get_retweeted (self));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		case TWEET_FAVORITED:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		g_value_set_boolean (value, tweet_get_favorited (self));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		case TWEET_AVATAR:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		g_value_set_object (value, tweet_get_avatar (self));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 1887 "Tweet.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 1893 "Tweet.c"
	}
}


static void _vala_tweet_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Tweet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWEET, Tweet);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		case TWEET_RETWEETED:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		tweet_set_retweeted (self, g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		case TWEET_FAVORITED:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		tweet_set_favorited (self, g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		case TWEET_AVATAR:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		tweet_set_avatar (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 1921 "Tweet.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Tweet.vala"
		break;
#line 1927 "Tweet.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



