/* Twitter.c generated by valac 0.22.1, the Vala compiler
 * generated from Twitter.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gstdio.h>
#include <gio/gio.h>


#define TYPE_TWITTER (twitter_get_type ())
#define TWITTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWITTER, Twitter))
#define TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWITTER, TwitterClass))
#define IS_TWITTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWITTER))
#define IS_TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWITTER))
#define TWITTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWITTER, TwitterClass))

typedef struct _Twitter Twitter;
typedef struct _TwitterClass TwitterClass;
typedef struct _TwitterPrivate TwitterPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;

struct _Twitter {
	GObject parent_instance;
	TwitterPrivate * priv;
	GeeHashMap* avatars;
};

struct _TwitterClass {
	GObjectClass parent_class;
};

typedef void (*TwitterAvatarDownloadedFunc) (GdkPixbuf* avatar, void* user_data);
struct _Block5Data {
	int _ref_count_;
	Twitter * self;
	gchar* url;
	TwitterAvatarDownloadedFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	gulong handler_id;
};


static gpointer twitter_parent_class = NULL;
static Twitter* twitter_twitter;
static Twitter* twitter_twitter = NULL;
static gint twitter__short_url_length;
static gint twitter__short_url_length = 22;
static gint twitter__short_url_length_https;
static gint twitter__short_url_length_https = 23;
static gint twitter__max_media_per_upload;
static gint twitter__max_media_per_upload = 1;
extern GdkPixbuf* twitter_no_avatar;
GdkPixbuf* twitter_no_avatar = NULL;
extern GdkPixbuf* twitter_no_banner;
GdkPixbuf* twitter_no_banner = NULL;
extern GdkPixbuf* twitter_verified_icon;
GdkPixbuf* twitter_verified_icon = NULL;

GType twitter_get_type (void) G_GNUC_CONST;
enum  {
	TWITTER_DUMMY_PROPERTY
};
Twitter* twitter_get (void);
Twitter* twitter_new (void);
Twitter* twitter_construct (GType object_type);
void twitter_init (Twitter* self);
#define DATADIR "/usr/share/corebird/"
GdkPixbuf* twitter_get_avatar (Twitter* self, const gchar* url, TwitterAvatarDownloadedFunc func, void* func_target, GDestroyNotify func_target_destroy_notify);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
gchar* utils_get_avatar_name (const gchar* path);
gchar* dirs_cache (const gchar* path);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda12_ (Block6Data* _data6_, GdkPixbuf* ava);
static void ____lambda12__twitter_avatar_downloaded (Twitter* _sender, GdkPixbuf* avatar, gpointer self);
void tweet_utils_download_avatar (const gchar* avatar_url, GAsyncReadyCallback _callback_, gpointer _user_data_);
GdkPixbuf* tweet_utils_download_avatar_finish (GAsyncResult* _res_);
static void ___lambda14_ (Block5Data* _data5_, GObject* obj, GAsyncResult* res);
static void ____lambda14__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
gint twitter_get_short_url_length (void);
static void twitter_set_short_url_length (gint value);
gint twitter_get_short_url_length_https (void);
static void twitter_set_short_url_length_https (gint value);
gint twitter_get_max_media_per_upload (void);
static void twitter_set_max_media_per_upload (gint value);
static void twitter_finalize (GObject* obj);
static void _vala_twitter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_twitter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return self ? g_object_ref (self) : NULL;
#line 127 "Twitter.c"
}


Twitter* twitter_get (void) {
	Twitter* result = NULL;
	Twitter* _tmp0_ = NULL;
	Twitter* _tmp2_ = NULL;
	Twitter* _tmp3_ = NULL;
#line 25 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = twitter_twitter;
#line 25 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (_tmp0_ == NULL) {
#line 140 "Twitter.c"
		Twitter* _tmp1_ = NULL;
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp1_ = twitter_new ();
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_object_unref0 (twitter_twitter);
#line 26 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		twitter_twitter = _tmp1_;
#line 148 "Twitter.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2_ = twitter_twitter;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	result = _tmp3_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return result;
#line 158 "Twitter.c"
}


Twitter* twitter_construct (GType object_type) {
	Twitter * self = NULL;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	self = (Twitter*) g_object_new (object_type, NULL);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return self;
#line 168 "Twitter.c"
}


Twitter* twitter_new (void) {
#line 31 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return twitter_construct (TYPE_TWITTER);
#line 175 "Twitter.c"
}


void twitter_init (Twitter* self) {
	GeeHashMap* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_return_if_fail (IS_TWITTER (self));
#line 184 "Twitter.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_ = NULL;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp1_ = gdk_pixbuf_new_from_file (DATADIR "/no_avatar.png", &_inner_error_);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp0_ = _tmp1_;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		if (_inner_error_ != NULL) {
#line 198 "Twitter.c"
			goto __catch7_g_error;
		}
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_object_unref0 (twitter_no_avatar);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		twitter_no_avatar = _tmp0_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp3_ = gdk_pixbuf_new_from_file (DATADIR "/no_banner.png", &_inner_error_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp2_ = _tmp3_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		if (_inner_error_ != NULL) {
#line 211 "Twitter.c"
			goto __catch7_g_error;
		}
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_object_unref0 (twitter_no_banner);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		twitter_no_banner = _tmp2_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp5_ = gdk_pixbuf_new_from_file (DATADIR "/verified.png", &_inner_error_);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp4_ = _tmp5_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		if (_inner_error_ != NULL) {
#line 224 "Twitter.c"
			goto __catch7_g_error;
		}
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_object_unref0 (twitter_verified_icon);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		twitter_verified_icon = _tmp4_;
#line 231 "Twitter.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		e = _inner_error_;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp6_ = e->message;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		g_error ("Twitter.vala:51: Error while loading assets: %s", _tmp6_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_error_free0 (e);
#line 248 "Twitter.c"
	}
	__finally7:
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (_inner_error_ != NULL) {
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		g_clear_error (&_inner_error_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		return;
#line 259 "Twitter.c"
	}
#line 54 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp7_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GDK_TYPE_PIXBUF, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_object_unref0 (self->avatars);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	self->avatars = _tmp7_;
#line 267 "Twitter.c"
}


/**
   * Get the avatar with the given url. If the avatar exists on the
   * hard drive already, it is loaded and returned immediately. If
   * the avatar is in memory already, that version is returned.
   * If the avatar is neither on disk nor in memory, it will be downladed
   * first and set via the supplied `func`.
   *
   * Example usage:
   *
   * Gdk.Pixbuf?a = get_avatar("http://foo", (avatar) => {
   *   a = avatar;
   * });
   * (a may be null here)
   *
   * @param url The url of the avatar to return
   * @param func The AvatarDownloadedFunc to call once the avatar has been
   *             downloaded successfully.
   *
   * @return The requested avatar if it was already downloaded/in ram, or null
   *         if it has to be downloaded first, in which case the AvatarDownloadedFunc
   *         will be called after that's finished.
   */
static Block5Data* block5_data_ref (Block5Data* _data5_) {
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return _data5_;
#line 298 "Twitter.c"
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 307 "Twitter.c"
		Twitter * self;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		self = _data5_->self;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_free0 (_data5_->url);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		(_data5_->func_target_destroy_notify == NULL) ? NULL : (_data5_->func_target_destroy_notify (_data5_->func_target), NULL);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data5_->func = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data5_->func_target = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data5_->func_target_destroy_notify = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_object_unref0 (self);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		g_slice_free (Block5Data, _data5_);
#line 325 "Twitter.c"
	}
}


static Block6Data* block6_data_ref (Block6Data* _data6_) {
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return _data6_;
#line 335 "Twitter.c"
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 344 "Twitter.c"
		Twitter * self;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		self = _data6_->_data5_->self;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		block5_data_unref (_data6_->_data5_);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_->_data5_ = NULL;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		g_slice_free (Block6Data, _data6_);
#line 354 "Twitter.c"
	}
}


static void ___lambda12_ (Block6Data* _data6_, GdkPixbuf* ava) {
	Block5Data* _data5_;
	Twitter * self;
	TwitterAvatarDownloadedFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	gulong _tmp2_ = 0UL;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_ = _data6_->_data5_;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	self = _data5_->self;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_return_if_fail (GDK_IS_PIXBUF (ava));
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = _data5_->func;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0__target = _data5_->func_target;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp1_ = ava;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ (_tmp1_, _tmp0__target);
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2_ = _data6_->handler_id;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp2_);
#line 384 "Twitter.c"
}


static void ____lambda12__twitter_avatar_downloaded (Twitter* _sender, GdkPixbuf* avatar, gpointer self) {
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	___lambda12_ (self, avatar);
#line 391 "Twitter.c"
}


static void ___lambda14_ (Block5Data* _data5_, GObject* obj, GAsyncResult* res) {
	Twitter * self;
	GdkPixbuf* avatar = NULL;
	GAsyncResult* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	TwitterAvatarDownloadedFunc _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GeeHashMap* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	self = _data5_->self;
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = res;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp1_ = tweet_utils_download_avatar_finish (_tmp0_);
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_object_unref0 (avatar);
#line 115 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	avatar = _tmp1_;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2_ = _data5_->func;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2__target = _data5_->func_target;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2_ (avatar, _tmp2__target);
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp3_ = _data5_->url;
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp4_ = g_strconcat ("avatar-downloaded::", _tmp3_, NULL);
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_signal_emit_by_name (self, _tmp4_, avatar);
#line 118 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_free0 (_tmp4_);
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp5_ = self->avatars;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp6_ = _data5_->url;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_, avatar);
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_object_unref0 (avatar);
#line 442 "Twitter.c"
}


static void ____lambda14__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	___lambda14_ (self, source_object, res);
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	block5_data_unref (self);
#line 451 "Twitter.c"
}


GdkPixbuf* twitter_get_avatar (Twitter* self, const gchar* url, TwitterAvatarDownloadedFunc func, void* func_target, GDestroyNotify func_target_destroy_notify) {
	GdkPixbuf* result = NULL;
	Block5Data* _data5_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	TwitterAvatarDownloadedFunc _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	GdkPixbuf* a = NULL;
	GeeHashMap* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gpointer _tmp5_ = NULL;
	gboolean has_key = FALSE;
	GeeHashMap* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GdkPixbuf* _tmp9_ = NULL;
	gchar* avatar_name = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* avatar_dest = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp27_ = FALSE;
	GError * _inner_error_ = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_return_val_if_fail (IS_TWITTER (self), NULL);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->_ref_count_ = 1;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->self = g_object_ref (self);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = url;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_free0 (_data5_->url);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->url = _tmp1_;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2_ = func;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp2__target = func_target;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	(_data5_->func_target_destroy_notify == NULL) ? NULL : (_data5_->func_target_destroy_notify (_data5_->func_target), NULL);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->func = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->func_target = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->func_target_destroy_notify = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->func = _tmp2_;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->func_target = _tmp2__target;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_->func_target_destroy_notify = func_target_destroy_notify;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp3_ = self->avatars;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp4_ = _data5_->url;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 81 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	a = (GdkPixbuf*) _tmp5_;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp6_ = self->avatars;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp7_ = _data5_->url;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp8_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp7_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	has_key = _tmp8_;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp9_ = a;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (_tmp9_ != NULL) {
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		result = a;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		block5_data_unref (_data5_);
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data5_ = NULL;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		return result;
#line 548 "Twitter.c"
	}
#line 88 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp10_ = _data5_->url;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp11_ = utils_get_avatar_name (_tmp10_);
#line 88 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	avatar_name = _tmp11_;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp12_ = avatar_name;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp13_ = g_strconcat ("assets/avatars/", _tmp12_, NULL);
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp14_ = _tmp13_;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp15_ = dirs_cache (_tmp14_);
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp16_ = _tmp15_;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_free0 (_tmp14_);
#line 89 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	avatar_dest = _tmp16_;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp17_ = avatar_dest;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp18_ = g_file_test (_tmp17_, G_FILE_TEST_EXISTS);
#line 92 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (_tmp18_) {
#line 576 "Twitter.c"
		{
			GdkPixbuf* p = NULL;
			const gchar* _tmp19_ = NULL;
			GdkPixbuf* _tmp20_ = NULL;
			GeeHashMap* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
			GdkPixbuf* _tmp23_ = NULL;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp19_ = avatar_dest;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp20_ = gdk_pixbuf_new_from_file (_tmp19_, &_inner_error_);
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			p = _tmp20_;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			if (_inner_error_ != NULL) {
#line 592 "Twitter.c"
				goto __catch8_g_error;
			}
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp21_ = self->avatars;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp22_ = _data5_->url;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp23_ = p;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_, _tmp23_);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			result = p;
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_free0 (avatar_dest);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_free0 (avatar_name);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_object_unref0 (a);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			block5_data_unref (_data5_);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_data5_ = NULL;
#line 96 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			return result;
#line 617 "Twitter.c"
		}
		goto __finally8;
		__catch8_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp24_ = NULL;
			GError* _tmp25_ = NULL;
			const gchar* _tmp26_ = NULL;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			e = _inner_error_;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_inner_error_ = NULL;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp24_ = _data5_->url;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp25_ = e;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_tmp26_ = _tmp25_->message;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			g_critical ("Twitter.vala:98: Error while loading avatar `%s`: %s", _tmp24_, _tmp26_);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_error_free0 (e);
#line 640 "Twitter.c"
		}
		__finally8:
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		if (_inner_error_ != NULL) {
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_free0 (avatar_dest);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_free0 (avatar_name);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_g_object_unref0 (a);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			block5_data_unref (_data5_);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			_data5_ = NULL;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			g_clear_error (&_inner_error_);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
			return NULL;
#line 661 "Twitter.c"
		}
	}
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp27_ = has_key;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	if (_tmp27_) {
#line 668 "Twitter.c"
		Block6Data* _data6_;
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
		gulong _tmp30_ = 0UL;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_ = g_slice_new0 (Block6Data);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_->_ref_count_ = 1;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_->_data5_ = block5_data_ref (_data5_);
#line 105 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_->handler_id = (gulong) 0;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp28_ = _data5_->url;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp29_ = g_strconcat ("avatar-downloaded::", _tmp28_, NULL);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp30_ = g_signal_connect_data (self, _tmp29_, (GCallback) ____lambda12__twitter_avatar_downloaded, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_->handler_id = _tmp30_;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_g_free0 (_tmp29_);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		block6_data_unref (_data6_);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_data6_ = NULL;
#line 695 "Twitter.c"
	} else {
		GeeHashMap* _tmp31_ = NULL;
		const gchar* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp31_ = self->avatars;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp32_ = _data5_->url;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp32_, NULL);
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		_tmp33_ = _data5_->url;
#line 113 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		tweet_utils_download_avatar (_tmp33_, ____lambda14__gasync_ready_callback, block5_data_ref (_data5_));
#line 710 "Twitter.c"
	}
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	result = NULL;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_free0 (avatar_dest);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_free0 (avatar_name);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_object_unref0 (a);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	block5_data_unref (_data5_);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_data5_ = NULL;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return result;
#line 726 "Twitter.c"
}


gint twitter_get_short_url_length (void) {
	gint result;
	gint _tmp0_ = 0;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = twitter__short_url_length;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return result;
#line 739 "Twitter.c"
}


static void twitter_set_short_url_length (gint value) {
	gint _tmp0_ = 0;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	twitter__short_url_length = _tmp0_;
#line 749 "Twitter.c"
}


gint twitter_get_short_url_length_https (void) {
	gint result;
	gint _tmp0_ = 0;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = twitter__short_url_length_https;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return result;
#line 762 "Twitter.c"
}


static void twitter_set_short_url_length_https (gint value) {
	gint _tmp0_ = 0;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = value;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	twitter__short_url_length_https = _tmp0_;
#line 772 "Twitter.c"
}


gint twitter_get_max_media_per_upload (void) {
	gint result;
	gint _tmp0_ = 0;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = twitter__max_media_per_upload;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	return result;
#line 785 "Twitter.c"
}


static void twitter_set_max_media_per_upload (gint value) {
	gint _tmp0_ = 0;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_tmp0_ = value;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	twitter__max_media_per_upload = _tmp0_;
#line 795 "Twitter.c"
}


static void twitter_class_init (TwitterClass * klass) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	twitter_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_twitter_get_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_twitter_set_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	G_OBJECT_CLASS (klass)->finalize = twitter_finalize;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	g_signal_new ("avatar_downloaded", TYPE_TWITTER, G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GDK_TYPE_PIXBUF);
#line 810 "Twitter.c"
}


static void twitter_instance_init (Twitter * self) {
}


static void twitter_finalize (GObject* obj) {
	Twitter * self;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWITTER, Twitter);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	_g_object_unref0 (self->avatars);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	G_OBJECT_CLASS (twitter_parent_class)->finalize (obj);
#line 826 "Twitter.c"
}


GType twitter_get_type (void) {
	static volatile gsize twitter_type_id__volatile = 0;
	if (g_once_init_enter (&twitter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TwitterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) twitter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Twitter), 0, (GInstanceInitFunc) twitter_instance_init, NULL };
		GType twitter_type_id;
		twitter_type_id = g_type_register_static (G_TYPE_OBJECT, "Twitter", &g_define_type_info, 0);
		g_once_init_leave (&twitter_type_id__volatile, twitter_type_id);
	}
	return twitter_type_id__volatile;
}


static void _vala_twitter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Twitter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWITTER, Twitter);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	switch (property_id) {
#line 847 "Twitter.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		break;
#line 853 "Twitter.c"
	}
}


static void _vala_twitter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Twitter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWITTER, Twitter);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
	switch (property_id) {
#line 863 "Twitter.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/Twitter.vala"
		break;
#line 869 "Twitter.c"
	}
}



