/* UserStream.c generated by valac 0.22.1, the Vala compiler
 * generated from UserStream.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */
/* See https://dev.twitter.com/docs/streaming-apis/messages*/

#include <glib.h>
#include <glib-object.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy-call.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <rest/rest-proxy.h>


#define TYPE_STREAM_MESSAGE_TYPE (stream_message_type_get_type ())

#define TYPE_USER_STREAM (user_stream_get_type ())
#define USER_STREAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_STREAM, UserStream))
#define USER_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_STREAM, UserStreamClass))
#define IS_USER_STREAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_STREAM))
#define IS_USER_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_STREAM))
#define USER_STREAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_STREAM, UserStreamClass))

typedef struct _UserStream UserStream;
typedef struct _UserStreamClass UserStreamClass;
typedef struct _UserStreamPrivate UserStreamPrivate;

#define TYPE_IMESSAGE_RECEIVER (imessage_receiver_get_type ())
#define IMESSAGE_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMESSAGE_RECEIVER, IMessageReceiver))
#define IS_IMESSAGE_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMESSAGE_RECEIVER))
#define IMESSAGE_RECEIVER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_IMESSAGE_RECEIVER, IMessageReceiverIface))

typedef struct _IMessageReceiver IMessageReceiver;
typedef struct _IMessageReceiverIface IMessageReceiverIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_slist_free0(var) ((var == NULL) ? NULL : (var = (g_slist_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

typedef enum  {
	STREAM_MESSAGE_TYPE_UNSUPPORTED,
	STREAM_MESSAGE_TYPE_DELETE,
	STREAM_MESSAGE_TYPE_SCRUB_GEO,
	STREAM_MESSAGE_TYPE_LIMIT,
	STREAM_MESSAGE_TYPE_DISCONNECT,
	STREAM_MESSAGE_TYPE_FRIENDS,
	STREAM_MESSAGE_TYPE_EVENT,
	STREAM_MESSAGE_TYPE_WARNING,
	STREAM_MESSAGE_TYPE_FOLLOW,
	STREAM_MESSAGE_TYPE_DIRECT_MESSAGE,
	STREAM_MESSAGE_TYPE_TWEET,
	STREAM_MESSAGE_TYPE_EVENT_LIST_CREATED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_DESTROYED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_UPDATED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_UNSUBSCRIBED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_SUBSCRIBED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_ADDED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_REMOVED,
	STREAM_MESSAGE_TYPE_EVENT_FAVORITE,
	STREAM_MESSAGE_TYPE_EVENT_UNFAVORITE,
	STREAM_MESSAGE_TYPE_EVENT_UNFOLLOW,
	STREAM_MESSAGE_TYPE_EVENT_BLOCK,
	STREAM_MESSAGE_TYPE_EVENT_UNBLOCK
} StreamMessageType;

struct _UserStream {
	GObject parent_instance;
	UserStreamPrivate * priv;
};

struct _UserStreamClass {
	GObjectClass parent_class;
};

struct _IMessageReceiverIface {
	GTypeInterface parent_iface;
	void (*stream_message_received) (IMessageReceiver* self, StreamMessageType type, JsonNode* root_node);
};

struct _UserStreamPrivate {
	OAuthProxy* proxy;
	RestProxyCall* proxy_call;
	GString* data;
	GSList* receivers;
	GNetworkMonitor* network_monitor;
	gboolean network_available;
	guint network_timeout_id;
	guint heartbeat_timeout_id;
	gboolean running;
	gchar* account_name;
};


static gpointer user_stream_parent_class = NULL;

GType stream_message_type_get_type (void) G_GNUC_CONST;
GType user_stream_get_type (void) G_GNUC_CONST;
GType imessage_receiver_get_type (void) G_GNUC_CONST;
#define USER_STREAM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_STREAM, UserStreamPrivate))
enum  {
	USER_STREAM_DUMMY_PROPERTY,
	USER_STREAM_TOKEN,
	USER_STREAM_TOKEN_SECRET
};
#define USER_STREAM_TIMEOUT_INTERVAL (45 * 1000)
UserStream* user_stream_new (const gchar* account_name);
UserStream* user_stream_construct (GType object_type, const gchar* account_name);
gchar* utils_decode (const gchar* source);
#define UTILS_CONSUMER_KEY "MHJ2SExkYnpSVUxaZDVkejZYMVRVQQ=="
#define UTILS_CONSUMER_SECRET "b0dydmQ2NjU0bldMaHpMY0p5d1NXM3BsdFVma2hQNEJucmFQUFZOaEh0WQ=="
static void user_stream_network_changed_cb (UserStream* self, gboolean available);
static void _user_stream_network_changed_cb_g_network_monitor_network_changed (GNetworkMonitor* _sender, gboolean available, gpointer self);
static void user_stream_start_network_timeout (UserStream* self);
void user_stream_register (UserStream* self, IMessageReceiver* receiver);
static void user_stream_restart (UserStream* self);
void user_stream_start (UserStream* self);
static void user_stream_parse_data_cb (UserStream* self, RestProxyCall* call, const gchar* buf, gsize length, GError* _error_);
static void _user_stream_parse_data_cb_rest_proxy_call_continuous_callback (RestProxyCall* call, const gchar* buf, gsize len, GError* _error_, GObject* weak_object, gpointer self);
void user_stream_stop (UserStream* self);
static gboolean __lambda6_ (UserStream* self);
static gboolean ___lambda6__gsource_func (gpointer self);
static void user_stream_start_heartbeat_timeout (UserStream* self);
static gboolean __lambda5_ (UserStream* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static StreamMessageType user_stream_get_event_type (UserStream* self, const gchar* evt_str);
void imessage_receiver_stream_message_received (IMessageReceiver* self, StreamMessageType type, JsonNode* root_node);
static void _vala_JsonNode_free (JsonNode* self);
void user_stream_set_token (UserStream* self, const gchar* value);
void user_stream_set_token_secret (UserStream* self, const gchar* value);
static void user_stream_finalize (GObject* obj);
static void _vala_user_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType stream_message_type_get_type (void) {
	static volatile gsize stream_message_type_type_id__volatile = 0;
	if (g_once_init_enter (&stream_message_type_type_id__volatile)) {
		static const GEnumValue values[] = {{STREAM_MESSAGE_TYPE_UNSUPPORTED, "STREAM_MESSAGE_TYPE_UNSUPPORTED", "unsupported"}, {STREAM_MESSAGE_TYPE_DELETE, "STREAM_MESSAGE_TYPE_DELETE", "delete"}, {STREAM_MESSAGE_TYPE_SCRUB_GEO, "STREAM_MESSAGE_TYPE_SCRUB_GEO", "scrub-geo"}, {STREAM_MESSAGE_TYPE_LIMIT, "STREAM_MESSAGE_TYPE_LIMIT", "limit"}, {STREAM_MESSAGE_TYPE_DISCONNECT, "STREAM_MESSAGE_TYPE_DISCONNECT", "disconnect"}, {STREAM_MESSAGE_TYPE_FRIENDS, "STREAM_MESSAGE_TYPE_FRIENDS", "friends"}, {STREAM_MESSAGE_TYPE_EVENT, "STREAM_MESSAGE_TYPE_EVENT", "event"}, {STREAM_MESSAGE_TYPE_WARNING, "STREAM_MESSAGE_TYPE_WARNING", "warning"}, {STREAM_MESSAGE_TYPE_FOLLOW, "STREAM_MESSAGE_TYPE_FOLLOW", "follow"}, {STREAM_MESSAGE_TYPE_DIRECT_MESSAGE, "STREAM_MESSAGE_TYPE_DIRECT_MESSAGE", "direct-message"}, {STREAM_MESSAGE_TYPE_TWEET, "STREAM_MESSAGE_TYPE_TWEET", "tweet"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_CREATED, "STREAM_MESSAGE_TYPE_EVENT_LIST_CREATED", "event-list-created"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_DESTROYED, "STREAM_MESSAGE_TYPE_EVENT_LIST_DESTROYED", "event-list-destroyed"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_UPDATED, "STREAM_MESSAGE_TYPE_EVENT_LIST_UPDATED", "event-list-updated"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_UNSUBSCRIBED, "STREAM_MESSAGE_TYPE_EVENT_LIST_UNSUBSCRIBED", "event-list-unsubscribed"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_SUBSCRIBED, "STREAM_MESSAGE_TYPE_EVENT_LIST_SUBSCRIBED", "event-list-subscribed"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_ADDED, "STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_ADDED", "event-list-member-added"}, {STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_REMOVED, "STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_REMOVED", "event-list-member-removed"}, {STREAM_MESSAGE_TYPE_EVENT_FAVORITE, "STREAM_MESSAGE_TYPE_EVENT_FAVORITE", "event-favorite"}, {STREAM_MESSAGE_TYPE_EVENT_UNFAVORITE, "STREAM_MESSAGE_TYPE_EVENT_UNFAVORITE", "event-unfavorite"}, {STREAM_MESSAGE_TYPE_EVENT_UNFOLLOW, "STREAM_MESSAGE_TYPE_EVENT_UNFOLLOW", "event-unfollow"}, {STREAM_MESSAGE_TYPE_EVENT_BLOCK, "STREAM_MESSAGE_TYPE_EVENT_BLOCK", "event-block"}, {STREAM_MESSAGE_TYPE_EVENT_UNBLOCK, "STREAM_MESSAGE_TYPE_EVENT_UNBLOCK", "event-unblock"}, {0, NULL, NULL}};
		GType stream_message_type_type_id;
		stream_message_type_type_id = g_enum_register_static ("StreamMessageType", values);
		g_once_init_leave (&stream_message_type_type_id__volatile, stream_message_type_type_id);
	}
	return stream_message_type_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 83 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return self ? g_object_ref (self) : NULL;
#line 172 "UserStream.c"
}


static void _user_stream_network_changed_cb_g_network_monitor_network_changed (GNetworkMonitor* _sender, gboolean available, gpointer self) {
#line 85 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	user_stream_network_changed_cb (self, available);
#line 179 "UserStream.c"
}


UserStream* user_stream_construct (GType object_type, const gchar* account_name) {
	UserStream * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	OAuthProxy* _tmp9_ = NULL;
	GNetworkMonitor* _tmp10_ = NULL;
	GNetworkMonitor* _tmp11_ = NULL;
	GNetworkMonitor* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	GNetworkMonitor* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_val_if_fail (account_name != NULL, NULL);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self = (UserStream*) g_object_new (object_type, NULL);
#line 75 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = account_name;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 75 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (self->priv->account_name);
#line 75 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->account_name = _tmp1_;
#line 76 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp2_ = account_name;
#line 76 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = g_strconcat ("CREATING USER STREAM FOR ", _tmp2_, NULL);
#line 76 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp4_ = _tmp3_;
#line 76 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_debug ("UserStream.vala:76: %s", _tmp4_);
#line 76 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (_tmp4_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp5_ = utils_decode (UTILS_CONSUMER_KEY);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp6_ = _tmp5_;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp7_ = utils_decode (UTILS_CONSUMER_SECRET);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp8_ = _tmp7_;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp9_ = (OAuthProxy*) oauth_proxy_new (_tmp6_, _tmp8_, "https://userstream.twitter.com/", FALSE);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->proxy = _tmp9_;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (_tmp8_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (_tmp6_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp10_ = g_network_monitor_get_default ();
#line 83 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_object_unref0 (self->priv->network_monitor);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->network_monitor = _tmp11_;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp12_ = self->priv->network_monitor;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp13_ = g_network_monitor_get_network_available (_tmp12_);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->network_available = _tmp13_;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp14_ = self->priv->network_monitor;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_signal_connect_object (_tmp14_, "network-changed", (GCallback) _user_stream_network_changed_cb_g_network_monitor_network_changed, self, 0);
#line 86 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp15_ = self->priv->network_available;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (!_tmp15_) {
#line 87 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		user_stream_start_network_timeout (self);
#line 265 "UserStream.c"
	}
#line 74 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return self;
#line 269 "UserStream.c"
}


UserStream* user_stream_new (const gchar* account_name) {
#line 74 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return user_stream_construct (TYPE_USER_STREAM, account_name);
#line 276 "UserStream.c"
}


void user_stream_register (UserStream* self, IMessageReceiver* receiver) {
	IMessageReceiver* _tmp0_ = NULL;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 91 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_IMESSAGE_RECEIVER (receiver));
#line 92 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = receiver;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->receivers = g_slist_append (self->priv->receivers, _tmp0_);
#line 290 "UserStream.c"
}


static void user_stream_network_changed_cb (UserStream* self, gboolean available) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 96 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 97 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = available;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = self->priv->network_available;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp0_ == _tmp1_) {
#line 98 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		return;
#line 309 "UserStream.c"
	}
#line 100 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp2_ = available;
#line 100 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->network_available = _tmp2_;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = self->priv->network_available;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp3_) {
#line 103 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_debug ("UserStream.vala:103: Restarting stream (reason: Network available (cal" \
"lback))");
#line 104 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		user_stream_restart (self);
#line 105 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_signal_emit_by_name (self, "resumed");
#line 325 "UserStream.c"
	} else {
		const gchar* _tmp4_ = NULL;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp4_ = self->priv->account_name;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_debug ("UserStream.vala:107: Connection lost (%s) Reason: network unavailable", _tmp4_);
#line 108 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_signal_emit_by_name (self, "interrupted");
#line 109 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		user_stream_start_network_timeout (self);
#line 336 "UserStream.c"
	}
}


/**
   * Starts the UserStream
   */
static void _user_stream_parse_data_cb_rest_proxy_call_continuous_callback (RestProxyCall* call, const gchar* buf, gsize len, GError* _error_, GObject* weak_object, gpointer self) {
#line 125 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	user_stream_parse_data_cb (self, call, buf, len, _error_);
#line 347 "UserStream.c"
}


void user_stream_start (UserStream* self) {
	OAuthProxy* _tmp0_ = NULL;
	RestProxyCall* _tmp1_ = NULL;
	RestProxyCall* _tmp2_ = NULL;
	RestProxyCall* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 118 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 120 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->running = TRUE;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->proxy;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, rest_proxy_get_type (), RestProxy));
#line 121 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy_call);
#line 121 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->proxy_call = _tmp1_;
#line 122 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp2_ = self->priv->proxy_call;
#line 122 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	rest_proxy_call_set_function (_tmp2_, "1.1/user.json");
#line 123 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = self->priv->proxy_call;
#line 123 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	rest_proxy_call_set_method (_tmp3_, "GET");
#line 377 "UserStream.c"
	{
		RestProxyCall* _tmp4_ = NULL;
		RestProxyCall* _tmp5_ = NULL;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp4_ = self->priv->proxy_call;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp5_ = self->priv->proxy_call;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		rest_proxy_call_continuous (_tmp4_, _user_stream_parse_data_cb_rest_proxy_call_continuous_callback, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, G_TYPE_OBJECT, GObject), self, &_inner_error_);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		if (_inner_error_ != NULL) {
#line 389 "UserStream.c"
			goto __catch53_g_error;
		}
	}
	goto __finally53;
	__catch53_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		e = _inner_error_;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_inner_error_ = NULL;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp6_ = e->message;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_error ("UserStream.vala:127: %s", _tmp6_);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_g_error_free0 (e);
#line 408 "UserStream.c"
	}
	__finally53:
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_inner_error_ != NULL) {
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_clear_error (&_inner_error_);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		return;
#line 419 "UserStream.c"
	}
}


/**
   * Stops the UserStream
   */
void user_stream_stop (UserStream* self) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	RestProxyCall* _tmp3_ = NULL;
#line 134 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 135 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->running = FALSE;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->account_name;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = g_strconcat ("STOPPING STREAM FOR ", _tmp0_, NULL);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp2_ = _tmp1_;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_debug ("UserStream.vala:136: %s", _tmp2_);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (_tmp2_);
#line 137 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = self->priv->proxy_call;
#line 137 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	rest_proxy_call_cancel (_tmp3_);
#line 450 "UserStream.c"
}


static void user_stream_restart (UserStream* self) {
#line 140 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 141 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	user_stream_stop (self);
#line 142 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	user_stream_start (self);
#line 461 "UserStream.c"
}


static gboolean __lambda6_ (UserStream* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean available = FALSE;
	GNetworkMonitor* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 147 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->running;
#line 147 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp0_) {
#line 148 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		result = FALSE;
#line 148 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		return result;
#line 480 "UserStream.c"
	}
#line 150 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = self->priv->network_monitor;
#line 150 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp2_ = g_network_monitor_get_network_available (_tmp1_);
#line 150 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	available = _tmp2_;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = available;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp3_) {
#line 152 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_debug ("UserStream.vala:152: Restarting stream (reason: network available (tim" \
"eout))");
#line 153 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		user_stream_restart (self);
#line 154 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		result = FALSE;
#line 154 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		return result;
#line 500 "UserStream.c"
	}
#line 156 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	result = TRUE;
#line 156 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return result;
#line 506 "UserStream.c"
}


static gboolean ___lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda6_ (self);
#line 146 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return result;
#line 515 "UserStream.c"
}


static void user_stream_start_network_timeout (UserStream* self) {
	guint _tmp0_ = 0U;
#line 145 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 146 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (30 * 1000), ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 146 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->network_timeout_id = _tmp0_;
#line 527 "UserStream.c"
}


static gboolean __lambda5_ (UserStream* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
#line 163 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->running = FALSE;
#line 164 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->account_name;
#line 164 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_debug ("UserStream.vala:164: Connection lost (%s) Reason: heartbeat. Restartin" \
"g...", _tmp0_);
#line 165 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	user_stream_restart (self);
#line 166 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	result = FALSE;
#line 166 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return result;
#line 546 "UserStream.c"
}


static gboolean ___lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda5_ (self);
#line 161 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return result;
#line 555 "UserStream.c"
}


static void user_stream_start_heartbeat_timeout (UserStream* self) {
	guint _tmp0_ = 0U;
#line 160 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 161 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) USER_STREAM_TIMEOUT_INTERVAL, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 161 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->heartbeat_timeout_id = _tmp0_;
#line 567 "UserStream.c"
}


/**
   * Callback called by the Rest.ProxyCall whenever it receives data.
   *
   * @param call The Rest.ProxyCall created when the UserStream was started.
   * @param buf The string received
   * @param length The buffer's length
   * @param error
   */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 598 "UserStream.c"
		glong _tmp4_ = 0L;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 606 "UserStream.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 618 "UserStream.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
#line 1167 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 643 "UserStream.c"
		glong _tmp2_ = 0L;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 649 "UserStream.c"
	} else {
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 653 "UserStream.c"
	}
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 659 "UserStream.c"
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 671 "UserStream.c"
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 681 "UserStream.c"
	}
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 687 "UserStream.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 701 "UserStream.c"
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 711 "UserStream.c"
	}
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 717 "UserStream.c"
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 726 "UserStream.c"
	}
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 746 "UserStream.c"
}


static JsonNode* _vala_JsonNode_copy (JsonNode* self) {
#line 213 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 753 "UserStream.c"
}


static gpointer __vala_JsonNode_copy0 (gpointer self) {
#line 213 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 760 "UserStream.c"
}


static gpointer _json_object_ref0 (gpointer self) {
#line 214 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return self ? json_object_ref (self) : NULL;
#line 767 "UserStream.c"
}


static void _vala_JsonNode_free (JsonNode* self) {
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_boxed_free (json_node_get_type (), self);
#line 774 "UserStream.c"
}


static void user_stream_parse_data_cb (UserStream* self, RestProxyCall* call, const gchar* buf, gsize length, GError* _error_) {
	const gchar* _tmp0_ = NULL;
	gchar* real = NULL;
	const gchar* _tmp1_ = NULL;
	gsize _tmp2_ = 0UL;
	gchar* _tmp3_ = NULL;
	GString* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 183 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 183 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (REST_IS_PROXY_CALL (call));
#line 185 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = buf;
#line 185 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp0_ == NULL) {
#line 186 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_debug ("UserStream.vala:186: buf == NULL");
#line 187 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		return;
#line 803 "UserStream.c"
	}
#line 190 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = buf;
#line 190 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp2_ = length;
#line 190 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = string_substring (_tmp1_, (glong) 0, (glong) ((gint) _tmp2_));
#line 190 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	real = _tmp3_;
#line 192 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp4_ = self->priv->data;
#line 192 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp5_ = real;
#line 192 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_string_append (_tmp4_, _tmp5_);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp7_ = real;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp8_ = g_str_has_suffix (_tmp7_, "\r\n");
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp8_) {
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp6_ = TRUE;
#line 827 "UserStream.c"
	} else {
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp9_ = real;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp10_ = g_str_has_suffix (_tmp9_, "\r");
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp6_ = _tmp10_;
#line 837 "UserStream.c"
	}
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp11_ = _tmp6_;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp11_) {
#line 843 "UserStream.c"
		const gchar* _tmp12_ = NULL;
		JsonParser* parser = NULL;
		JsonParser* _tmp17_ = NULL;
		JsonNode* root_node = NULL;
		JsonParser* _tmp23_ = NULL;
		JsonNode* _tmp24_ = NULL;
		JsonNode* _tmp25_ = NULL;
		JsonObject* root = NULL;
		JsonNode* _tmp26_ = NULL;
		JsonObject* _tmp27_ = NULL;
		JsonObject* _tmp28_ = NULL;
		StreamMessageType type = 0;
		JsonObject* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		GSList* _tmp54_ = NULL;
		GString* _tmp59_ = NULL;
#line 196 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp12_ = real;
#line 196 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		if (g_strcmp0 (_tmp12_, "\r\n") == 0) {
#line 864 "UserStream.c"
			const gchar* _tmp13_ = NULL;
			GString* _tmp14_ = NULL;
			guint _tmp15_ = 0U;
#line 197 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp13_ = self->priv->account_name;
#line 197 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			g_debug ("UserStream.vala:197: HEARTBEAT(%s)", _tmp13_);
#line 198 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp14_ = self->priv->data;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			g_string_erase (_tmp14_, (gssize) 0, (gssize) (-1));
#line 199 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp15_ = self->priv->heartbeat_timeout_id;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			if (_tmp15_ != ((guint) 0)) {
#line 880 "UserStream.c"
				guint _tmp16_ = 0U;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				_tmp16_ = self->priv->heartbeat_timeout_id;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				g_source_remove (_tmp16_);
#line 886 "UserStream.c"
			}
#line 202 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			user_stream_start_heartbeat_timeout (self);
#line 203 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_g_free0 (real);
#line 203 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			return;
#line 894 "UserStream.c"
		}
#line 206 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp17_ = json_parser_new ();
#line 206 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		parser = _tmp17_;
#line 900 "UserStream.c"
		{
			JsonParser* _tmp18_ = NULL;
			GString* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
#line 208 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp18_ = parser;
#line 208 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp19_ = self->priv->data;
#line 208 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp20_ = _tmp19_->str;
#line 208 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			json_parser_load_from_data (_tmp18_, _tmp20_, (gssize) (-1), &_inner_error_);
#line 208 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			if (_inner_error_ != NULL) {
#line 915 "UserStream.c"
				goto __catch54_g_error;
			}
		}
		goto __finally54;
		__catch54_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			e = _inner_error_;
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_inner_error_ = NULL;
#line 210 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp21_ = e;
#line 210 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp22_ = _tmp21_->message;
#line 210 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			g_critical ("UserStream.vala:210: %s", _tmp22_);
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_g_error_free0 (e);
#line 937 "UserStream.c"
		}
		__finally54:
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		if (_inner_error_ != NULL) {
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_g_object_unref0 (parser);
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_g_free0 (real);
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			g_clear_error (&_inner_error_);
#line 207 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			return;
#line 952 "UserStream.c"
		}
#line 213 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp23_ = parser;
#line 213 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp24_ = json_parser_get_root (_tmp23_);
#line 213 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp25_ = __vala_JsonNode_copy0 (_tmp24_);
#line 213 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		root_node = _tmp25_;
#line 214 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp26_ = root_node;
#line 214 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp27_ = json_node_get_object (_tmp26_);
#line 214 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp28_ = _json_object_ref0 (_tmp27_);
#line 214 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		root = _tmp28_;
#line 216 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		type = 0;
#line 218 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp29_ = root;
#line 218 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp30_ = json_object_has_member (_tmp29_, "delete");
#line 218 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		if (_tmp30_) {
#line 219 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			type = STREAM_MESSAGE_TYPE_DELETE;
#line 980 "UserStream.c"
		} else {
			JsonObject* _tmp31_ = NULL;
			gboolean _tmp32_ = FALSE;
#line 220 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp31_ = root;
#line 220 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			_tmp32_ = json_object_has_member (_tmp31_, "scrub_geo");
#line 220 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			if (_tmp32_) {
#line 221 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				type = STREAM_MESSAGE_TYPE_SCRUB_GEO;
#line 992 "UserStream.c"
			} else {
				JsonObject* _tmp33_ = NULL;
				gboolean _tmp34_ = FALSE;
#line 222 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				_tmp33_ = root;
#line 222 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				_tmp34_ = json_object_has_member (_tmp33_, "limit");
#line 222 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				if (_tmp34_) {
#line 223 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					type = STREAM_MESSAGE_TYPE_LIMIT;
#line 1004 "UserStream.c"
				} else {
					JsonObject* _tmp35_ = NULL;
					gboolean _tmp36_ = FALSE;
#line 224 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					_tmp35_ = root;
#line 224 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					_tmp36_ = json_object_has_member (_tmp35_, "disconnect");
#line 224 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					if (_tmp36_) {
#line 225 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
						type = STREAM_MESSAGE_TYPE_DISCONNECT;
#line 1016 "UserStream.c"
					} else {
						JsonObject* _tmp37_ = NULL;
						gboolean _tmp38_ = FALSE;
#line 226 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
						_tmp37_ = root;
#line 226 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
						_tmp38_ = json_object_has_member (_tmp37_, "friends");
#line 226 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
						if (_tmp38_) {
#line 227 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
							type = STREAM_MESSAGE_TYPE_FRIENDS;
#line 1028 "UserStream.c"
						} else {
							JsonObject* _tmp39_ = NULL;
							gboolean _tmp40_ = FALSE;
#line 228 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
							_tmp39_ = root;
#line 228 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
							_tmp40_ = json_object_has_member (_tmp39_, "text");
#line 228 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
							if (_tmp40_) {
#line 229 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
								type = STREAM_MESSAGE_TYPE_TWEET;
#line 1040 "UserStream.c"
							} else {
								JsonObject* _tmp41_ = NULL;
								gboolean _tmp42_ = FALSE;
#line 230 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
								_tmp41_ = root;
#line 230 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
								_tmp42_ = json_object_has_member (_tmp41_, "event");
#line 230 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
								if (_tmp42_) {
#line 1050 "UserStream.c"
									gchar* evt_str = NULL;
									JsonObject* _tmp43_ = NULL;
									const gchar* _tmp44_ = NULL;
									gchar* _tmp45_ = NULL;
									const gchar* _tmp46_ = NULL;
									StreamMessageType _tmp47_ = 0;
#line 231 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp43_ = root;
#line 231 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp44_ = json_object_get_string_member (_tmp43_, "event");
#line 231 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp45_ = g_strdup (_tmp44_);
#line 231 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									evt_str = _tmp45_;
#line 232 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp46_ = evt_str;
#line 232 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp47_ = user_stream_get_event_type (self, _tmp46_);
#line 232 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									type = _tmp47_;
#line 230 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_g_free0 (evt_str);
#line 1073 "UserStream.c"
								} else {
									JsonObject* _tmp48_ = NULL;
									gboolean _tmp49_ = FALSE;
#line 234 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp48_ = root;
#line 234 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									_tmp49_ = json_object_has_member (_tmp48_, "warning");
#line 234 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
									if (_tmp49_) {
#line 235 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
										type = STREAM_MESSAGE_TYPE_WARNING;
#line 1085 "UserStream.c"
									} else {
										JsonObject* _tmp50_ = NULL;
										gboolean _tmp51_ = FALSE;
#line 236 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
										_tmp50_ = root;
#line 236 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
										_tmp51_ = json_object_has_member (_tmp50_, "direct_message");
#line 236 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
										if (_tmp51_) {
#line 237 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
											type = STREAM_MESSAGE_TYPE_DIRECT_MESSAGE;
#line 1097 "UserStream.c"
										} else {
											JsonObject* _tmp52_ = NULL;
											gboolean _tmp53_ = FALSE;
#line 238 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
											_tmp52_ = root;
#line 238 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
											_tmp53_ = json_object_has_member (_tmp52_, "status_withheld");
#line 238 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
											if (_tmp53_) {
#line 239 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
												type = STREAM_MESSAGE_TYPE_UNSUPPORTED;
#line 1109 "UserStream.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
#line 246 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp54_ = self->priv->receivers;
#line 1122 "UserStream.c"
		{
			GSList* it_collection = NULL;
			GSList* it_it = NULL;
#line 246 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			it_collection = _tmp54_;
#line 246 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
			for (it_it = it_collection; it_it != NULL; it_it = it_it->next) {
#line 1130 "UserStream.c"
				IMessageReceiver* _tmp55_ = NULL;
				IMessageReceiver* it = NULL;
#line 246 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				_tmp55_ = _g_object_ref0 ((IMessageReceiver*) it_it->data);
#line 246 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				it = _tmp55_;
#line 1137 "UserStream.c"
				{
					IMessageReceiver* _tmp56_ = NULL;
					StreamMessageType _tmp57_ = 0;
					JsonNode* _tmp58_ = NULL;
#line 247 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					_tmp56_ = it;
#line 247 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					_tmp57_ = type;
#line 247 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					_tmp58_ = root_node;
#line 247 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					imessage_receiver_stream_message_received (_tmp56_, _tmp57_, _tmp58_);
#line 246 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
					_g_object_unref0 (it);
#line 1152 "UserStream.c"
				}
			}
		}
#line 250 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_tmp59_ = self->priv->data;
#line 250 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		g_string_erase (_tmp59_, (gssize) 0, (gssize) (-1));
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_json_object_unref0 (root);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		__vala_JsonNode_free0 (root_node);
#line 194 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		_g_object_unref0 (parser);
#line 1166 "UserStream.c"
	}
#line 183 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (real);
#line 1170 "UserStream.c"
}


static StreamMessageType user_stream_get_event_type (UserStream* self, const gchar* evt_str) {
	StreamMessageType result = 0;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label0 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label1 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label2 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label3 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label4 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label5 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label6 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label7 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label8 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label9 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label10 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label11 = 0;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	static GQuark _tmp2_label12 = 0;
#line 255 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_val_if_fail (IS_USER_STREAM (self), 0);
#line 255 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_val_if_fail (evt_str != NULL, 0);
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = evt_str;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = _tmp0_;
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("follow")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1219 "UserStream.c"
			default:
			{
#line 258 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_FOLLOW;
#line 258 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1226 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("list_created")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1232 "UserStream.c"
			default:
			{
#line 260 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_CREATED;
#line 260 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1239 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("list_destroyed")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1245 "UserStream.c"
			default:
			{
#line 262 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_DESTROYED;
#line 262 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1252 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("list_updated")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1258 "UserStream.c"
			default:
			{
#line 264 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_UPDATED;
#line 264 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1265 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("list_user_unsubscribed")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1271 "UserStream.c"
			default:
			{
#line 266 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_UNSUBSCRIBED;
#line 266 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1278 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("list_user_subscribed")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1284 "UserStream.c"
			default:
			{
#line 268 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_SUBSCRIBED;
#line 268 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1291 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("list_member_added")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1297 "UserStream.c"
			default:
			{
#line 270 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_ADDED;
#line 270 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1304 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("list_member_removed")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1310 "UserStream.c"
			default:
			{
#line 272 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_REMOVED;
#line 272 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1317 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("favorite")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1323 "UserStream.c"
			default:
			{
#line 274 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_FAVORITE;
#line 274 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1330 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("unfavorite")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1336 "UserStream.c"
			default:
			{
#line 276 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_UNFAVORITE;
#line 276 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1343 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("unfollow")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1349 "UserStream.c"
			default:
			{
#line 278 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_UNFOLLOW;
#line 278 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1356 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("block")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1362 "UserStream.c"
			default:
			{
#line 280 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_BLOCK;
#line 280 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1369 "UserStream.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("unblock")))) {
#line 256 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		switch (0) {
#line 1375 "UserStream.c"
			default:
			{
#line 282 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				result = STREAM_MESSAGE_TYPE_EVENT_UNBLOCK;
#line 282 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
				return result;
#line 1382 "UserStream.c"
			}
		}
	}
#line 285 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	result = 0;
#line 285 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	return result;
#line 1390 "UserStream.c"
}


void user_stream_set_token (UserStream* self, const gchar* value) {
	OAuthProxy* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 61 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->proxy;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = value;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	oauth_proxy_set_token (_tmp0_, _tmp1_);
#line 61 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_object_notify ((GObject *) self, "token");
#line 1407 "UserStream.c"
}


void user_stream_set_token_secret (UserStream* self, const gchar* value) {
	OAuthProxy* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 64 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->proxy;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp1_ = value;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	oauth_proxy_set_token_secret (_tmp0_, _tmp1_);
#line 64 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_object_notify ((GObject *) self, "token-secret");
#line 1424 "UserStream.c"
}


static void user_stream_class_init (UserStreamClass * klass) {
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	user_stream_parent_class = g_type_class_peek_parent (klass);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_type_class_add_private (klass, sizeof (UserStreamPrivate));
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_user_stream_set_property;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	G_OBJECT_CLASS (klass)->finalize = user_stream_finalize;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_STREAM_TOKEN, g_param_spec_string ("token", "token", "token", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_STREAM_TOKEN_SECRET, g_param_spec_string ("token-secret", "token-secret", "token-secret", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_signal_new ("interrupted", TYPE_USER_STREAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_signal_new ("resumed", TYPE_USER_STREAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1445 "UserStream.c"
}


static void user_stream_instance_init (UserStream * self) {
	GString* _tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv = USER_STREAM_GET_PRIVATE (self);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = g_string_new ("");
#line 52 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->data = _tmp0_;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->receivers = NULL;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->network_timeout_id = (guint) 0;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->heartbeat_timeout_id = (guint) 0;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self->priv->running = FALSE;
#line 1465 "UserStream.c"
}


static void user_stream_finalize (GObject* obj) {
	UserStream * self;
	const gchar* _tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_STREAM, UserStream);
#line 172 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_tmp0_ = self->priv->account_name;
#line 172 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	g_debug ("UserStream.vala:172: USERSTREAM for %s DESTROYED", _tmp0_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy);
#line 51 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy_call);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_string_free0 (self->priv->data);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_slist_free0 (self->priv->receivers);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_object_unref0 (self->priv->network_monitor);
#line 59 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	_g_free0 (self->priv->account_name);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	G_OBJECT_CLASS (user_stream_parent_class)->finalize (obj);
#line 1492 "UserStream.c"
}


GType user_stream_get_type (void) {
	static volatile gsize user_stream_type_id__volatile = 0;
	if (g_once_init_enter (&user_stream_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserStreamClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_stream_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserStream), 0, (GInstanceInitFunc) user_stream_instance_init, NULL };
		GType user_stream_type_id;
		user_stream_type_id = g_type_register_static (G_TYPE_OBJECT, "UserStream", &g_define_type_info, 0);
		g_once_init_leave (&user_stream_type_id__volatile, user_stream_type_id);
	}
	return user_stream_type_id__volatile;
}


static void _vala_user_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UserStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_STREAM, UserStream);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
	switch (property_id) {
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		case USER_STREAM_TOKEN:
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		user_stream_set_token (self, g_value_get_string (value));
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		break;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		case USER_STREAM_TOKEN_SECRET:
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		user_stream_set_token_secret (self, g_value_get_string (value));
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		break;
#line 1525 "UserStream.c"
		default:
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/UserStream.vala"
		break;
#line 1531 "UserStream.c"
	}
}



