/* WarningService.c generated by valac 0.22.1, the Vala compiler
 * generated from WarningService.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_IMESSAGE_RECEIVER (imessage_receiver_get_type ())
#define IMESSAGE_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMESSAGE_RECEIVER, IMessageReceiver))
#define IS_IMESSAGE_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMESSAGE_RECEIVER))
#define IMESSAGE_RECEIVER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_IMESSAGE_RECEIVER, IMessageReceiverIface))

typedef struct _IMessageReceiver IMessageReceiver;
typedef struct _IMessageReceiverIface IMessageReceiverIface;

#define TYPE_STREAM_MESSAGE_TYPE (stream_message_type_get_type ())

#define TYPE_WARNING_SERVICE (warning_service_get_type ())
#define WARNING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARNING_SERVICE, WarningService))
#define WARNING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARNING_SERVICE, WarningServiceClass))
#define IS_WARNING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARNING_SERVICE))
#define IS_WARNING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARNING_SERVICE))
#define WARNING_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARNING_SERVICE, WarningServiceClass))

typedef struct _WarningService WarningService;
typedef struct _WarningServiceClass WarningServiceClass;
typedef struct _WarningServicePrivate WarningServicePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block30Data Block30Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

typedef enum  {
	STREAM_MESSAGE_TYPE_UNSUPPORTED,
	STREAM_MESSAGE_TYPE_DELETE,
	STREAM_MESSAGE_TYPE_SCRUB_GEO,
	STREAM_MESSAGE_TYPE_LIMIT,
	STREAM_MESSAGE_TYPE_DISCONNECT,
	STREAM_MESSAGE_TYPE_FRIENDS,
	STREAM_MESSAGE_TYPE_EVENT,
	STREAM_MESSAGE_TYPE_WARNING,
	STREAM_MESSAGE_TYPE_FOLLOW,
	STREAM_MESSAGE_TYPE_DIRECT_MESSAGE,
	STREAM_MESSAGE_TYPE_TWEET,
	STREAM_MESSAGE_TYPE_EVENT_LIST_CREATED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_DESTROYED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_UPDATED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_UNSUBSCRIBED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_SUBSCRIBED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_ADDED,
	STREAM_MESSAGE_TYPE_EVENT_LIST_MEMBER_REMOVED,
	STREAM_MESSAGE_TYPE_EVENT_FAVORITE,
	STREAM_MESSAGE_TYPE_EVENT_UNFAVORITE,
	STREAM_MESSAGE_TYPE_EVENT_UNFOLLOW,
	STREAM_MESSAGE_TYPE_EVENT_BLOCK,
	STREAM_MESSAGE_TYPE_EVENT_UNBLOCK
} StreamMessageType;

struct _IMessageReceiverIface {
	GTypeInterface parent_iface;
	void (*stream_message_received) (IMessageReceiver* self, StreamMessageType type, JsonNode* root_node);
};

struct _WarningService {
	GObject parent_instance;
	WarningServicePrivate * priv;
};

struct _WarningServiceClass {
	GObjectClass parent_class;
};

struct _WarningServicePrivate {
	gchar* stream_name;
};

struct _Block30Data {
	int _ref_count_;
	WarningService * self;
	GtkMessageDialog* dialog;
};


static gpointer warning_service_parent_class = NULL;
static IMessageReceiverIface* warning_service_imessage_receiver_parent_iface = NULL;

GType stream_message_type_get_type (void) G_GNUC_CONST;
GType imessage_receiver_get_type (void) G_GNUC_CONST;
GType warning_service_get_type (void) G_GNUC_CONST;
#define WARNING_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WARNING_SERVICE, WarningServicePrivate))
enum  {
	WARNING_SERVICE_DUMMY_PROPERTY
};
WarningService* warning_service_new (const gchar* stream_name);
WarningService* warning_service_construct (GType object_type, const gchar* stream_name);
static void warning_service_real_stream_message_received (IMessageReceiver* base, StreamMessageType type, JsonNode* root_node);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void __lambda173_ (Block30Data* _data30_, gint id);
static void ___lambda173__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
static void warning_service_finalize (GObject* obj);


WarningService* warning_service_construct (GType object_type, const gchar* stream_name) {
	WarningService * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	g_return_val_if_fail (stream_name != NULL, NULL);
#line 23 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	self = (WarningService*) g_object_new (object_type, NULL);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp0_ = stream_name;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_g_free0 (self->priv->stream_name);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	self->priv->stream_name = _tmp1_;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	return self;
#line 144 "WarningService.c"
}


WarningService* warning_service_new (const gchar* stream_name) {
#line 23 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	return warning_service_construct (TYPE_WARNING_SERVICE, stream_name);
#line 151 "WarningService.c"
}


static Block30Data* block30_data_ref (Block30Data* _data30_) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	return _data30_;
#line 160 "WarningService.c"
}


static void block30_data_unref (void * _userdata_) {
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 169 "WarningService.c"
		WarningService * self;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		self = _data30_->self;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		_g_object_unref0 (_data30_->dialog);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		_g_object_unref0 (self);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		g_slice_free (Block30Data, _data30_);
#line 179 "WarningService.c"
	}
}


static gpointer _json_object_ref0 (gpointer self) {
#line 31 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	return self ? json_object_ref (self) : NULL;
#line 187 "WarningService.c"
}


static void __lambda173_ (Block30Data* _data30_, gint id) {
	WarningService * self;
	gint _tmp0_ = 0;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	self = _data30_->self;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp0_ = id;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	if (_tmp0_ == ((gint) GTK_RESPONSE_OK)) {
#line 200 "WarningService.c"
		GtkMessageDialog* _tmp1_ = NULL;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		_tmp1_ = _data30_->dialog;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GTK_TYPE_WIDGET, GtkWidget));
#line 206 "WarningService.c"
	}
}


static void ___lambda173__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
#line 41 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	__lambda173_ (self, response_id);
#line 214 "WarningService.c"
}


static void warning_service_real_stream_message_received (IMessageReceiver* base, StreamMessageType type, JsonNode* root_node) {
	WarningService * self;
	Block30Data* _data30_;
	StreamMessageType _tmp0_ = 0;
	JsonObject* root = NULL;
	JsonNode* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonObject* _tmp3_ = NULL;
	JsonObject* warning_object = NULL;
	JsonObject* _tmp4_ = NULL;
	JsonObject* _tmp5_ = NULL;
	JsonObject* _tmp6_ = NULL;
	gchar* message = NULL;
	JsonObject* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	JsonObject* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	GtkMessageDialog* _tmp16_ = NULL;
	GtkMessageDialog* _tmp17_ = NULL;
	GtkMessageDialog* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	GtkMessageDialog* _tmp20_ = NULL;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_WARNING_SERVICE, WarningService);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	g_return_if_fail (root_node != NULL);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_data30_->_ref_count_ = 1;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_data30_->self = g_object_ref (self);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp0_ = type;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	if (_tmp0_ != STREAM_MESSAGE_TYPE_WARNING) {
#line 29 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		block30_data_unref (_data30_);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		_data30_ = NULL;
#line 29 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
		return;
#line 265 "WarningService.c"
	}
#line 31 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp1_ = root_node;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp2_ = json_node_get_object (_tmp1_);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp3_ = _json_object_ref0 (_tmp2_);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	root = _tmp3_;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp4_ = root;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp5_ = json_object_get_object_member (_tmp4_, "warning");
#line 33 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp6_ = _json_object_ref0 (_tmp5_);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	warning_object = _tmp6_;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp7_ = warning_object;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp8_ = json_object_get_string_member (_tmp7_, "code");
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp9_ = g_strconcat (_tmp8_, "\n", NULL);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp10_ = _tmp9_;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp11_ = warning_object;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp12_ = json_object_get_string_member (_tmp11_, "message");
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp13_ = g_strconcat (_tmp10_, _tmp12_, NULL);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp14_ = _tmp13_;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_g_free0 (_tmp10_);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	message = _tmp14_;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp15_ = message;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp16_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, _tmp15_);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	g_object_ref_sink (_tmp16_);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_data30_->dialog = _tmp16_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp17_ = _data30_->dialog;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GTK_TYPE_DIALOG, GtkDialog), "response", (GCallback) ___lambda173__gtk_dialog_response, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp18_ = _data30_->dialog;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp19_ = self->priv->stream_name;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	gtk_window_set_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GTK_TYPE_WINDOW, GtkWindow), _tmp19_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_tmp20_ = _data30_->dialog;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GTK_TYPE_WIDGET, GtkWidget));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_g_free0 (message);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_json_object_unref0 (warning_object);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_json_object_unref0 (root);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	block30_data_unref (_data30_);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_data30_ = NULL;
#line 335 "WarningService.c"
}


static void warning_service_class_init (WarningServiceClass * klass) {
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	warning_service_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	g_type_class_add_private (klass, sizeof (WarningServicePrivate));
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	G_OBJECT_CLASS (klass)->finalize = warning_service_finalize;
#line 346 "WarningService.c"
}


static void warning_service_imessage_receiver_interface_init (IMessageReceiverIface * iface) {
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	warning_service_imessage_receiver_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	iface->stream_message_received = (void (*)(IMessageReceiver*, StreamMessageType, JsonNode*)) warning_service_real_stream_message_received;
#line 355 "WarningService.c"
}


static void warning_service_instance_init (WarningService * self) {
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	self->priv = WARNING_SERVICE_GET_PRIVATE (self);
#line 362 "WarningService.c"
}


static void warning_service_finalize (GObject* obj) {
	WarningService * self;
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WARNING_SERVICE, WarningService);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	_g_free0 (self->priv->stream_name);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/WarningService.vala"
	G_OBJECT_CLASS (warning_service_parent_class)->finalize (obj);
#line 374 "WarningService.c"
}


GType warning_service_get_type (void) {
	static volatile gsize warning_service_type_id__volatile = 0;
	if (g_once_init_enter (&warning_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WarningServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warning_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarningService), 0, (GInstanceInitFunc) warning_service_instance_init, NULL };
		static const GInterfaceInfo imessage_receiver_info = { (GInterfaceInitFunc) warning_service_imessage_receiver_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType warning_service_type_id;
		warning_service_type_id = g_type_register_static (G_TYPE_OBJECT, "WarningService", &g_define_type_info, 0);
		g_type_add_interface_static (warning_service_type_id, TYPE_IMESSAGE_RECEIVER, &imessage_receiver_info);
		g_once_init_leave (&warning_service_type_id__volatile, warning_service_type_id);
	}
	return warning_service_type_id__volatile;
}



