/* DMListEntry.c generated by valac 0.22.1, the Vala compiler
 * generated from DMListEntry.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_ITWITTER_ITEM (itwitter_item_get_type ())
#define ITWITTER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ITWITTER_ITEM, ITwitterItem))
#define IS_ITWITTER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ITWITTER_ITEM))
#define ITWITTER_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ITWITTER_ITEM, ITwitterItemIface))

typedef struct _ITwitterItem ITwitterItem;
typedef struct _ITwitterItemIface ITwitterItemIface;

#define TYPE_DM_LIST_ENTRY (dm_list_entry_get_type ())
#define DM_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DM_LIST_ENTRY, DMListEntry))
#define DM_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DM_LIST_ENTRY, DMListEntryClass))
#define IS_DM_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DM_LIST_ENTRY))
#define IS_DM_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DM_LIST_ENTRY))
#define DM_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DM_LIST_ENTRY, DMListEntryClass))

typedef struct _DMListEntry DMListEntry;
typedef struct _DMListEntryClass DMListEntryClass;
typedef struct _DMListEntryPrivate DMListEntryPrivate;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;

#define TYPE_TEXT_BUTTON (text_button_get_type ())
#define TEXT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_BUTTON, TextButton))
#define TEXT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_BUTTON, TextButtonClass))
#define IS_TEXT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_BUTTON))
#define IS_TEXT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_BUTTON))
#define TEXT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_BUTTON, TextButtonClass))

typedef struct _TextButton TextButton;
typedef struct _TextButtonClass TextButtonClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_TWITTER (twitter_get_type ())
#define TWITTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWITTER, Twitter))
#define TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWITTER, TwitterClass))
#define IS_TWITTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWITTER))
#define IS_TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWITTER))
#define TWITTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWITTER, TwitterClass))

typedef struct _Twitter Twitter;
typedef struct _TwitterClass TwitterClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _ITwitterItemIface {
	GTypeInterface parent_iface;
	gint (*update_time_delta) (ITwitterItem* self, GDateTime* now);
	gint64 (*get_sort_factor) (ITwitterItem* self);
	gboolean (*get_seen) (ITwitterItem* self);
	void (*set_seen) (ITwitterItem* self, gboolean value);
};

struct _DMListEntry {
	GtkListBoxRow parent_instance;
	DMListEntryPrivate * priv;
	gchar* avatar_url;
	gint64 timestamp;
	gint64 id;
	gint64 user_id;
	MainWindow* main_window;
};

struct _DMListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _DMListEntryPrivate {
	GtkImage* avatar_image;
	GtkLabel* text_label;
	GtkLabel* screen_name_label;
	TextButton* name_button;
	GtkLabel* time_delta_label;
};

typedef void (*TwitterAvatarDownloadedFunc) (GdkPixbuf* avatar, void* user_data);

static gpointer dm_list_entry_parent_class = NULL;
static ITwitterItemIface* dm_list_entry_itwitter_item_parent_iface = NULL;

GType itwitter_item_get_type (void) G_GNUC_CONST;
GType dm_list_entry_get_type (void) G_GNUC_CONST;
GType main_window_get_type (void) G_GNUC_CONST;
GType text_button_get_type (void) G_GNUC_CONST;
#define DM_LIST_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DM_LIST_ENTRY, DMListEntryPrivate))
enum  {
	DM_LIST_ENTRY_DUMMY_PROPERTY,
	DM_LIST_ENTRY_TEXT,
	DM_LIST_ENTRY_SCREEN_NAME,
	DM_LIST_ENTRY_NAME,
	DM_LIST_ENTRY_AVATAR,
	DM_LIST_ENTRY_SEEN,
	DM_LIST_ENTRY_SORT_FACTOR
};
DMListEntry* dm_list_entry_new (void);
DMListEntry* dm_list_entry_construct (GType object_type);
static void __lambda99_ (DMListEntry* self);
void main_window_switch_page (MainWindow* self, gint page_id, ...);
#define MAIN_WINDOW_PAGE_PROFILE 7
static void ___lambda99__gtk_button_clicked (GtkButton* _sender, gpointer self);
void dm_list_entry_load_avatar (DMListEntry* self);
GType twitter_get_type (void) G_GNUC_CONST;
Twitter* twitter_get (void);
GdkPixbuf* twitter_get_avatar (Twitter* self, const gchar* url, TwitterAvatarDownloadedFunc func, void* func_target, GDestroyNotify func_target_destroy_notify);
static void __lambda100_ (DMListEntry* self, GdkPixbuf* a);
static void ___lambda100__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self);
static gint dm_list_entry_real_update_time_delta (ITwitterItem* base, GDateTime* now);
gchar* utils_get_time_delta (GDateTime* time, GDateTime* now);
void dm_list_entry_set_text (DMListEntry* self, const gchar* value);
void dm_list_entry_set_screen_name (DMListEntry* self, const gchar* value);
void dm_list_entry_set_name (DMListEntry* self, const gchar* value);
void dm_list_entry_set_avatar (DMListEntry* self, GdkPixbuf* value);
static void dm_list_entry_finalize (GObject* obj);
gboolean itwitter_item_get_seen (ITwitterItem* self);
gint64 itwitter_item_get_sort_factor (ITwitterItem* self);
static void _vala_dm_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
void itwitter_item_set_seen (ITwitterItem* self, gboolean value);
static void _vala_dm_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void __lambda99_ (DMListEntry* self) {
	MainWindow* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->main_window;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = self->user_id;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	main_window_switch_page (_tmp0_, MAIN_WINDOW_PAGE_PROFILE, _tmp1_, NULL);
#line 166 "DMListEntry.c"
}


static void ___lambda99__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 63 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	__lambda99_ (self);
#line 173 "DMListEntry.c"
}


DMListEntry* dm_list_entry_construct (GType object_type) {
	DMListEntry * self = NULL;
	TextButton* _tmp0_ = NULL;
#line 62 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self = (DMListEntry*) g_object_new (object_type, NULL);
#line 63 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->name_button;
#line 63 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_BUTTON, GtkButton), "clicked", (GCallback) ___lambda99__gtk_button_clicked, self, 0);
#line 62 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	return self;
#line 188 "DMListEntry.c"
}


DMListEntry* dm_list_entry_new (void) {
#line 62 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	return dm_list_entry_construct (TYPE_DM_LIST_ENTRY);
#line 195 "DMListEntry.c"
}


static void __lambda100_ (DMListEntry* self, GdkPixbuf* a) {
	GtkImage* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_return_if_fail (GDK_IS_PIXBUF (a));
#line 71 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = a;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_set (_tmp0_, "pixbuf", _tmp1_, NULL);
#line 210 "DMListEntry.c"
}


static void ___lambda100__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self) {
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	__lambda100_ (self, avatar);
#line 217 "DMListEntry.c"
}


void dm_list_entry_load_avatar (DMListEntry* self) {
	GtkImage* _tmp0_ = NULL;
	Twitter* _tmp1_ = NULL;
	Twitter* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GdkPixbuf* _tmp5_ = NULL;
#line 69 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_return_if_fail (IS_DM_LIST_ENTRY (self));
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = twitter_get ();
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp2_ = _tmp1_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp3_ = self->avatar_url;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp4_ = twitter_get_avatar (_tmp2_, _tmp3_, ___lambda100__twitter_avatar_downloaded_func, g_object_ref (self), g_object_unref);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp5_ = _tmp4_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_set (_tmp0_, "pixbuf", _tmp5_, NULL);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (_tmp5_);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (_tmp2_);
#line 248 "DMListEntry.c"
}


static gpointer _g_date_time_ref0 (gpointer self) {
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 255 "DMListEntry.c"
}


static gint dm_list_entry_real_update_time_delta (ITwitterItem* base, GDateTime* now) {
	DMListEntry * self;
	gint result = 0;
	GDateTime* cur_time = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* then = NULL;
	gint64 _tmp4_ = 0LL;
	GDateTime* _tmp5_ = NULL;
	GtkLabel* _tmp6_ = NULL;
	GDateTime* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	GDateTime* _tmp14_ = NULL;
	GTimeSpan _tmp15_ = 0LL;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = now;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	if (_tmp0_ == NULL) {
#line 283 "DMListEntry.c"
		GDateTime* _tmp1_ = NULL;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		_g_date_time_unref0 (cur_time);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		cur_time = _tmp1_;
#line 291 "DMListEntry.c"
	} else {
		GDateTime* _tmp2_ = NULL;
		GDateTime* _tmp3_ = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		_tmp2_ = now;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		_tmp3_ = _g_date_time_ref0 (_tmp2_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		_g_date_time_unref0 (cur_time);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		cur_time = _tmp3_;
#line 303 "DMListEntry.c"
	}
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp4_ = self->timestamp;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp5_ = g_date_time_new_from_unix_local (_tmp4_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	then = _tmp5_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp6_ = self->priv->time_delta_label;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp7_ = cur_time;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp8_ = utils_get_time_delta (then, _tmp7_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp9_ = _tmp8_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp10_ = g_strconcat ("<small>", _tmp9_, NULL);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp11_ = _tmp10_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp12_ = g_strconcat (_tmp11_, "</small>", NULL);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp13_ = _tmp12_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_label_set_label (_tmp6_, _tmp13_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_free0 (_tmp13_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_free0 (_tmp11_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_free0 (_tmp9_);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp14_ = cur_time;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp15_ = g_date_time_difference (_tmp14_, then);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	result = (gint) ((_tmp15_ / 1000.0) / 1000.0);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_date_time_unref0 (then);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_date_time_unref0 (cur_time);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	return result;
#line 347 "DMListEntry.c"
}


void dm_list_entry_set_text (DMListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_return_if_fail (IS_DM_LIST_ENTRY (self));
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->text_label;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = value;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_notify ((GObject *) self, "text");
#line 364 "DMListEntry.c"
}


void dm_list_entry_set_screen_name (DMListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_return_if_fail (IS_DM_LIST_ENTRY (self));
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = value;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp2_ = g_strconcat ("@", _tmp1_, NULL);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp3_ = _tmp2_;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_free0 (_tmp3_);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_notify ((GObject *) self, "screen-name");
#line 389 "DMListEntry.c"
}


void dm_list_entry_set_name (DMListEntry* self, const gchar* value) {
	TextButton* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_return_if_fail (IS_DM_LIST_ENTRY (self));
#line 40 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->name_button;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = value;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_BUTTON, GtkButton), _tmp1_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_notify ((GObject *) self, "name");
#line 406 "DMListEntry.c"
}


void dm_list_entry_set_avatar (DMListEntry* self, GdkPixbuf* value) {
	GtkImage* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_return_if_fail (IS_DM_LIST_ENTRY (self));
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp1_ = value;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_set (_tmp0_, "pixbuf", _tmp1_, NULL);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_notify ((GObject *) self, "avatar");
#line 423 "DMListEntry.c"
}


static gboolean dm_list_entry_real_get_seen (ITwitterItem* base) {
	gboolean result;
	DMListEntry* self;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	result = TRUE;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	return result;
#line 436 "DMListEntry.c"
}


static void dm_list_entry_real_set_seen (ITwitterItem* base, gboolean value) {
	DMListEntry* self;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_notify ((GObject *) self, "seen");
#line 446 "DMListEntry.c"
}


static gint64 dm_list_entry_real_get_sort_factor (ITwitterItem* base) {
	gint64 result;
	DMListEntry* self;
	gint64 _tmp0_ = 0LL;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_tmp0_ = self->timestamp;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	return result;
#line 462 "DMListEntry.c"
}


static void dm_list_entry_class_init (DMListEntryClass * klass) {
	gint DMListEntry_private_offset;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	dm_list_entry_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_type_class_add_private (klass, sizeof (DMListEntryPrivate));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dm_list_entry_get_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dm_list_entry_set_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = dm_list_entry_finalize;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_TEXT, g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_SCREEN_NAME, g_param_spec_string ("screen-name", "screen-name", "screen-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_AVATAR, g_param_spec_object ("avatar", "avatar", "avatar", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_SEEN, g_param_spec_boolean ("seen", "seen", "seen", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_LIST_ENTRY_SORT_FACTOR, g_param_spec_int64 ("sort-factor", "sort-factor", "sort-factor", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	DMListEntry_private_offset = g_type_class_get_instance_private_offset (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/dm-list-entry.ui");
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "avatar_image", FALSE, DMListEntry_private_offset + G_STRUCT_OFFSET (DMListEntryPrivate, avatar_image));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_label", FALSE, DMListEntry_private_offset + G_STRUCT_OFFSET (DMListEntryPrivate, text_label));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "screen_name_label", FALSE, DMListEntry_private_offset + G_STRUCT_OFFSET (DMListEntryPrivate, screen_name_label));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_button", FALSE, DMListEntry_private_offset + G_STRUCT_OFFSET (DMListEntryPrivate, name_button));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "time_delta_label", FALSE, DMListEntry_private_offset + G_STRUCT_OFFSET (DMListEntryPrivate, time_delta_label));
#line 504 "DMListEntry.c"
}


static void dm_list_entry_itwitter_item_interface_init (ITwitterItemIface * iface) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	dm_list_entry_itwitter_item_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	iface->update_time_delta = (gint (*)(ITwitterItem*, GDateTime*)) dm_list_entry_real_update_time_delta;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	iface->get_seen = dm_list_entry_real_get_seen;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	iface->set_seen = dm_list_entry_real_set_seen;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	iface->get_sort_factor = dm_list_entry_real_get_sort_factor;
#line 519 "DMListEntry.c"
}


static void dm_list_entry_instance_init (DMListEntry * self) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self->priv = DM_LIST_ENTRY_GET_PRIVATE (self);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 528 "DMListEntry.c"
}


static void dm_list_entry_finalize (GObject* obj) {
	DMListEntry * self;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 23 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->avatar_image);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->text_label);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->name_button);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_object_unref0 (self->priv->time_delta_label);
#line 56 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	_g_free0 (self->avatar_url);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	G_OBJECT_CLASS (dm_list_entry_parent_class)->finalize (obj);
#line 550 "DMListEntry.c"
}


GType dm_list_entry_get_type (void) {
	static volatile gsize dm_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&dm_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DMListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dm_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DMListEntry), 0, (GInstanceInitFunc) dm_list_entry_instance_init, NULL };
		static const GInterfaceInfo itwitter_item_info = { (GInterfaceInitFunc) dm_list_entry_itwitter_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType dm_list_entry_type_id;
		dm_list_entry_type_id = g_type_register_static (GTK_TYPE_LIST_BOX_ROW, "DMListEntry", &g_define_type_info, 0);
		g_type_add_interface_static (dm_list_entry_type_id, TYPE_ITWITTER_ITEM, &itwitter_item_info);
		g_once_init_leave (&dm_list_entry_type_id__volatile, dm_list_entry_type_id);
	}
	return dm_list_entry_type_id__volatile;
}


static void _vala_dm_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DMListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SEEN:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		g_value_set_boolean (value, itwitter_item_get_seen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ITWITTER_ITEM, ITwitterItem)));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SORT_FACTOR:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		g_value_set_int64 (value, itwitter_item_get_sort_factor (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ITWITTER_ITEM, ITwitterItem)));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 585 "DMListEntry.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 591 "DMListEntry.c"
	}
}


static void _vala_dm_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DMListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DM_LIST_ENTRY, DMListEntry);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_TEXT:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		dm_list_entry_set_text (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SCREEN_NAME:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		dm_list_entry_set_screen_name (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_NAME:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		dm_list_entry_set_name (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_AVATAR:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		dm_list_entry_set_avatar (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		case DM_LIST_ENTRY_SEEN:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		itwitter_item_set_seen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ITWITTER_ITEM, ITwitterItem), g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 631 "DMListEntry.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/DMListEntry.vala"
		break;
#line 637 "DMListEntry.c"
	}
}



