/* FilterListEntry.c generated by valac 0.22.1, the Vala compiler
 * generated from FilterListEntry.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>


#define TYPE_FILTER_LIST_ENTRY (filter_list_entry_get_type ())
#define FILTER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILTER_LIST_ENTRY, FilterListEntry))
#define FILTER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILTER_LIST_ENTRY, FilterListEntryClass))
#define IS_FILTER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILTER_LIST_ENTRY))
#define IS_FILTER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILTER_LIST_ENTRY))
#define FILTER_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILTER_LIST_ENTRY, FilterListEntryClass))

typedef struct _FilterListEntry FilterListEntry;
typedef struct _FilterListEntryClass FilterListEntryClass;
typedef struct _FilterListEntryPrivate FilterListEntryPrivate;

#define TYPE_FILTER (filter_get_type ())
#define FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILTER, Filter))
#define FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILTER, FilterClass))
#define IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILTER))
#define IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILTER))
#define FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILTER, FilterClass))

typedef struct _Filter Filter;
typedef struct _FilterClass FilterClass;

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _AccountPrivate AccountPrivate;

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _FilterListEntry {
	GtkListBoxRow parent_instance;
	FilterListEntryPrivate * priv;
};

struct _FilterListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _FilterListEntryPrivate {
	GtkLabel* content_label;
	Filter* _filter;
	Account* account;
};

struct _Account {
	GObject parent_instance;
	AccountPrivate * priv;
	GeeArrayList* filters;
};

struct _AccountClass {
	GObjectClass parent_class;
};


static gpointer filter_list_entry_parent_class = NULL;

GType filter_list_entry_get_type (void) G_GNUC_CONST;
GType filter_get_type (void) G_GNUC_CONST;
GType account_get_type (void) G_GNUC_CONST;
#define FILTER_LIST_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILTER_LIST_ENTRY, FilterListEntryPrivate))
enum  {
	FILTER_LIST_ENTRY_DUMMY_PROPERTY,
	FILTER_LIST_ENTRY_FILTER,
	FILTER_LIST_ENTRY_CONTENT
};
FilterListEntry* filter_list_entry_new (Filter* f, Account* account);
FilterListEntry* filter_list_entry_construct (GType object_type, Filter* f, Account* account);
void filter_list_entry_set_filter (FilterListEntry* self, Filter* value);
static void filter_list_entry_delete_item_activated_cb (FilterListEntry* self);
gint filter_get_id (Filter* self);
Filter* filter_list_entry_get_filter (FilterListEntry* self);
gpointer sql_database_ref (gpointer instance);
void sql_database_unref (gpointer instance);
GParamSpec* sql_param_spec_database (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_database (GValue* value, gpointer v_object);
void sql_value_take_database (GValue* value, gpointer v_object);
gpointer sql_value_get_database (const GValue* value);
GType sql_database_get_type (void) G_GNUC_CONST;
SqlDatabase* account_get_db (Account* self);
void sql_database_exec (SqlDatabase* self, const gchar* sql, sqlite3_callback callback, void* callback_target);
static void _filter_list_entry_delete_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
const gchar* filter_get_content (Filter* self);
const gchar* filter_list_entry_get_content (FilterListEntry* self);
void filter_list_entry_set_content (FilterListEntry* self, const gchar* value);
static void filter_list_entry_finalize (GObject* obj);
static void _vala_filter_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_filter_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


FilterListEntry* filter_list_entry_construct (GType object_type, Filter* f, Account* account) {
	FilterListEntry * self = NULL;
	Filter* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_val_if_fail (IS_FILTER (f), NULL);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_val_if_fail (IS_ACCOUNT (account), NULL);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	self = (FilterListEntry*) g_object_new (object_type, NULL);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp0_ = f;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	filter_list_entry_set_filter (self, _tmp0_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp1_ = account;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	self->priv->account = _tmp1_;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	return self;
#line 156 "FilterListEntry.c"
}


FilterListEntry* filter_list_entry_new (Filter* f, Account* account) {
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	return filter_list_entry_construct (TYPE_FILTER_LIST_ENTRY, f, account);
#line 163 "FilterListEntry.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 170 "FilterListEntry.c"
}


static void filter_list_entry_delete_item_activated_cb (FilterListEntry* self) {
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
#line 177 "FilterListEntry.c"
	{
		GeeArrayList* _f_list = NULL;
		Account* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _tmp2_ = NULL;
		gint _f_size = 0;
		GeeArrayList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _f_index = 0;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_tmp0_ = self->priv->account;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_tmp1_ = _tmp0_->filters;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_f_list = _tmp2_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_tmp3_ = _f_list;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_tmp4_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_tmp5_ = _tmp4_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_f_size = _tmp5_;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_f_index = -1;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		while (TRUE) {
#line 208 "FilterListEntry.c"
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			Filter* f = NULL;
			GeeArrayList* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gpointer _tmp11_ = NULL;
			Filter* _tmp12_ = NULL;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			Filter* _tmp15_ = NULL;
			Filter* _tmp16_ = NULL;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp6_ = _f_index;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_f_index = _tmp6_ + 1;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp7_ = _f_index;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp8_ = _f_size;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				break;
#line 235 "FilterListEntry.c"
			}
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp9_ = _f_list;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp10_ = _f_index;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp11_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp10_);
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			f = (Filter*) _tmp11_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp12_ = f;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp13_ = filter_get_id (_tmp12_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp14_ = _tmp13_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp15_ = filter_list_entry_get_filter (self);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp16_ = _tmp15_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp17_ = filter_get_id (_tmp16_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_tmp18_ = _tmp17_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			if (_tmp14_ == _tmp18_) {
#line 261 "FilterListEntry.c"
				Account* _tmp19_ = NULL;
				GeeArrayList* _tmp20_ = NULL;
				Filter* _tmp21_ = NULL;
				Account* _tmp22_ = NULL;
				SqlDatabase* _tmp23_ = NULL;
				SqlDatabase* _tmp24_ = NULL;
				Filter* _tmp25_ = NULL;
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
				gchar* _tmp28_ = NULL;
				gchar* _tmp29_ = NULL;
				Filter* _tmp30_ = NULL;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp19_ = self->priv->account;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp20_ = _tmp19_->filters;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp21_ = f;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp21_);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp22_ = self->priv->account;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp23_ = account_get_db (_tmp22_);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp24_ = _tmp23_;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp25_ = f;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp26_ = filter_get_id (_tmp25_);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp27_ = _tmp26_;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp28_ = g_strdup_printf ("DELETE FROM `filters` WHERE `id`='%d'", _tmp27_);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp29_ = _tmp28_;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				sql_database_exec (_tmp24_, _tmp29_, NULL, NULL);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_g_free0 (_tmp29_);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_tmp30_ = f;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				g_signal_emit_by_name (self, "removed", _tmp30_);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_g_object_unref0 (f);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				_g_object_unref0 (_f_list);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
				return;
#line 312 "FilterListEntry.c"
			}
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
			_g_object_unref0 (f);
#line 316 "FilterListEntry.c"
		}
#line 49 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		_g_object_unref0 (_f_list);
#line 320 "FilterListEntry.c"
	}
}


static void _filter_list_entry_delete_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	filter_list_entry_delete_item_activated_cb (self);
#line 328 "FilterListEntry.c"
}


Filter* filter_list_entry_get_filter (FilterListEntry* self) {
	Filter* result;
	Filter* _tmp0_ = NULL;
#line 27 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_val_if_fail (IS_FILTER_LIST_ENTRY (self), NULL);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp0_ = self->priv->_filter;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	return result;
#line 343 "FilterListEntry.c"
}


void filter_list_entry_set_filter (FilterListEntry* self, Filter* value) {
	GtkLabel* _tmp0_ = NULL;
	Filter* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	Filter* _tmp4_ = NULL;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp0_ = self->priv->content_label;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp1_ = value;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp2_ = filter_get_content (_tmp1_);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp3_ = _tmp2_;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp4_ = value;
#line 25 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	self->priv->_filter = _tmp4_;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_object_notify ((GObject *) self, "filter");
#line 371 "FilterListEntry.c"
}


const gchar* filter_list_entry_get_content (FilterListEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_val_if_fail (IS_FILTER_LIST_ENTRY (self), NULL);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp0_ = self->priv->content_label;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp2_ = _tmp1_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	result = _tmp2_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	return result;
#line 392 "FilterListEntry.c"
}


void filter_list_entry_set_content (FilterListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
#line 33 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp0_ = self->priv->content_label;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_tmp1_ = value;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_object_notify ((GObject *) self, "content");
#line 409 "FilterListEntry.c"
}


static void filter_list_entry_class_init (FilterListEntryClass * klass) {
	gint FilterListEntry_private_offset;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	filter_list_entry_parent_class = g_type_class_peek_parent (klass);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_type_class_add_private (klass, sizeof (FilterListEntryPrivate));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_filter_list_entry_get_property;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_filter_list_entry_set_property;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = filter_list_entry_finalize;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_LIST_ENTRY_FILTER, g_param_spec_object ("filter", "filter", "filter", TYPE_FILTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_LIST_ENTRY_CONTENT, g_param_spec_string ("content", "content", "content", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	FilterListEntry_private_offset = g_type_class_get_instance_private_offset (klass);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/filter-list-entry.ui");
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	g_signal_new ("removed", TYPE_FILTER_LIST_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_FILTER);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content_label", FALSE, FilterListEntry_private_offset + G_STRUCT_OFFSET (FilterListEntryPrivate, content_label));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_item_activated_cb", G_CALLBACK(_filter_list_entry_delete_item_activated_cb_gtk_menu_item_activate));
#line 439 "FilterListEntry.c"
}


static void filter_list_entry_instance_init (FilterListEntry * self) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	self->priv = FILTER_LIST_ENTRY_GET_PRIVATE (self);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 39 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	self->priv->account = NULL;
#line 450 "FilterListEntry.c"
}


static void filter_list_entry_finalize (GObject* obj) {
	FilterListEntry * self;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
#line 20 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	_g_object_unref0 (self->priv->content_label);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	G_OBJECT_CLASS (filter_list_entry_parent_class)->finalize (obj);
#line 462 "FilterListEntry.c"
}


GType filter_list_entry_get_type (void) {
	static volatile gsize filter_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&filter_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FilterListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) filter_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilterListEntry), 0, (GInstanceInitFunc) filter_list_entry_instance_init, NULL };
		GType filter_list_entry_type_id;
		filter_list_entry_type_id = g_type_register_static (GTK_TYPE_LIST_BOX_ROW, "FilterListEntry", &g_define_type_info, 0);
		g_once_init_leave (&filter_list_entry_type_id__volatile, filter_list_entry_type_id);
	}
	return filter_list_entry_type_id__volatile;
}


static void _vala_filter_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FilterListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	switch (property_id) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		case FILTER_LIST_ENTRY_FILTER:
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		g_value_set_object (value, filter_list_entry_get_filter (self));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		break;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		case FILTER_LIST_ENTRY_CONTENT:
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		g_value_set_string (value, filter_list_entry_get_content (self));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		break;
#line 495 "FilterListEntry.c"
		default:
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		break;
#line 501 "FilterListEntry.c"
	}
}


static void _vala_filter_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FilterListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
	switch (property_id) {
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		case FILTER_LIST_ENTRY_FILTER:
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		filter_list_entry_set_filter (self, g_value_get_object (value));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		break;
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		case FILTER_LIST_ENTRY_CONTENT:
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		filter_list_entry_set_content (self, g_value_get_string (value));
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		break;
#line 523 "FilterListEntry.c"
		default:
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/builddir/build/BUILD/corebird-0.7/src/list/FilterListEntry.vala"
		break;
#line 529 "FilterListEntry.c"
	}
}



