/* ListListEntry.c generated by valac 0.22.1, the Vala compiler
 * generated from ListListEntry.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <rest/rest-proxy-call.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy.h>
#include <gio/gio.h>
#include <gdk/gdk.h>


#define TYPE_LIST_LIST_ENTRY (list_list_entry_get_type ())
#define LIST_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIST_LIST_ENTRY, ListListEntry))
#define LIST_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIST_LIST_ENTRY, ListListEntryClass))
#define IS_LIST_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIST_LIST_ENTRY))
#define IS_LIST_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIST_LIST_ENTRY))
#define LIST_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIST_LIST_ENTRY, ListListEntryClass))

typedef struct _ListListEntry ListListEntry;
typedef struct _ListListEntryClass ListListEntryClass;
typedef struct _ListListEntryPrivate ListListEntryPrivate;

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block56Data Block56Data;
typedef struct _Block57Data Block57Data;
typedef struct _Block58Data Block58Data;

struct _ListListEntry {
	GtkListBoxRow parent_instance;
	ListListEntryPrivate * priv;
	gint64 id;
	gboolean user_list;
	gchar* creator_screen_name;
	gint n_subscribers;
	gint n_members;
	gint64 created_at;
	gchar* mode;
};

struct _ListListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _ListListEntryPrivate {
	GtkLabel* name_label;
	GtkLabel* description_label;
	GtkStack* stack;
	GtkButton* subscribe_button;
	GtkButton* unsubscribe_button;
	GtkButton* delete_button;
	GtkButton* cancel_button;
	Account* account;
};

struct _Block56Data {
	int _ref_count_;
	ListListEntry * self;
	RestProxyCall* call;
};

struct _Block57Data {
	int _ref_count_;
	ListListEntry * self;
	RestProxyCall* call;
};

struct _Block58Data {
	int _ref_count_;
	ListListEntry * self;
	RestProxyCall* call;
};


static gpointer list_list_entry_parent_class = NULL;

GType list_list_entry_get_type (void) G_GNUC_CONST;
GType account_get_type (void) G_GNUC_CONST;
#define LIST_LIST_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIST_LIST_ENTRY, ListListEntryPrivate))
enum  {
	LIST_LIST_ENTRY_DUMMY_PROPERTY,
	LIST_LIST_ENTRY_NAME,
	LIST_LIST_ENTRY_DESCRIPTION
};
gint list_list_entry_sort_func (GtkListBoxRow* r1, GtkListBoxRow* r2);
const gchar* list_list_entry_get_name (ListListEntry* self);
ListListEntry* list_list_entry_new_from_json_data (JsonObject* obj, Account* account);
ListListEntry* list_list_entry_construct_from_json_data (GType object_type, JsonObject* obj, Account* account);
static gchar* list_list_entry_normalize_name (ListListEntry* self, const gchar* name);
void list_list_entry_set_name (ListListEntry* self, const gchar* value);
void list_list_entry_set_description (ListListEntry* self, const gchar* value);
GDateTime* utils_parse_date (const gchar* input);
gint64 account_get_id (Account* self);
static void list_list_entry_delete_button_clicked_cb (ListListEntry* self);
static Block56Data* block56_data_ref (Block56Data* _data56_);
static void block56_data_unref (void * _userdata_);
OAuthProxy* account_get_proxy (Account* self);
static void __lambda112_ (Block56Data* _data56_, GObject* o, GAsyncResult* res);
void utils_show_error_object (const gchar* json_data, const gchar* alternative);
static void ___lambda112__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void _list_list_entry_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void list_list_entry_subscribe_button_clicked_cb (ListListEntry* self);
static Block57Data* block57_data_ref (Block57Data* _data57_);
static void block57_data_unref (void * _userdata_);
static void __lambda113_ (Block57Data* _data57_, GObject* o, GAsyncResult* res);
static void ___lambda113__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void _list_list_entry_subscribe_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void list_list_entry_unsubscribe_button_clicked_cb (ListListEntry* self);
static Block58Data* block58_data_ref (Block58Data* _data58_);
static void block58_data_unref (void * _userdata_);
static void __lambda114_ (Block58Data* _data58_, GObject* o, GAsyncResult* res);
static void ___lambda114__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void _list_list_entry_unsubscribe_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void list_list_entry_more_button_clicked_cb (ListListEntry* self);
static void _list_list_entry_more_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void list_list_entry_cancel_button_clicked_cb (ListListEntry* self);
static void _list_list_entry_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static gboolean list_list_entry_focus_out_cb (ListListEntry* self);
static gboolean _list_list_entry_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
ListListEntry* list_list_entry_new (void);
ListListEntry* list_list_entry_construct (GType object_type);
const gchar* list_list_entry_get_description (ListListEntry* self);
static void list_list_entry_finalize (GObject* obj);
static void _vala_list_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_list_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


gint list_list_entry_sort_func (GtkListBoxRow* r1, GtkListBoxRow* r2) {
	gint result = 0;
	GtkListBoxRow* _tmp0_ = NULL;
	GtkListBoxRow* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkListBoxRow* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (GTK_IS_LIST_BOX_ROW (r1), 0);
#line 23 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (GTK_IS_LIST_BOX_ROW (r2), 0);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = r1;
#line 25 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIST_LIST_ENTRY)) {
#line 26 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		result = -1;
#line 26 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return result;
#line 186 "ListListEntry.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = r1;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = list_list_entry_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIST_LIST_ENTRY, ListListEntry));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp3_ = _tmp2_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp4_ = r2;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp5_ = list_list_entry_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIST_LIST_ENTRY, ListListEntry));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp6_ = _tmp5_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp7_ = g_ascii_strcasecmp (_tmp3_, _tmp6_);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	result = _tmp7_;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return result;
#line 206 "ListListEntry.c"
}


static gpointer _json_object_ref0 (gpointer self) {
#line 74 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return self ? json_object_ref (self) : NULL;
#line 213 "ListListEntry.c"
}


ListListEntry* list_list_entry_construct_from_json_data (GType object_type, JsonObject* obj, Account* account) {
	ListListEntry * self = NULL;
	Account* _tmp0_ = NULL;
	JsonObject* user = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonObject* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	JsonObject* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	JsonObject* _tmp10_ = NULL;
	gint64 _tmp11_ = 0LL;
	JsonObject* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	JsonObject* _tmp15_ = NULL;
	gint64 _tmp16_ = 0LL;
	JsonObject* _tmp17_ = NULL;
	gint64 _tmp18_ = 0LL;
	JsonObject* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	GDateTime* _tmp21_ = NULL;
	GDateTime* _tmp22_ = NULL;
	gint64 _tmp23_ = 0LL;
	JsonObject* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	gboolean following = FALSE;
	JsonObject* _tmp27_ = NULL;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp36_ = FALSE;
	JsonObject* _tmp41_ = NULL;
	gint64 _tmp42_ = 0LL;
	Account* _tmp43_ = NULL;
	gint64 _tmp44_ = 0LL;
	gint64 _tmp45_ = 0LL;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 72 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (IS_ACCOUNT (account), NULL);
#line 72 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self = (ListListEntry*) g_object_new (object_type, NULL);
#line 73 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = account;
#line 73 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->priv->account = _tmp0_;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = obj;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = json_object_get_object_member (_tmp1_, "user");
#line 74 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp3_ = _json_object_ref0 (_tmp2_);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	user = _tmp3_;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp4_ = obj;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp5_ = json_object_get_string_member (_tmp4_, "full_name");
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp6_ = list_list_entry_normalize_name (self, _tmp5_);
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp7_ = _tmp6_;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_set_name (self, _tmp7_);
#line 75 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (_tmp7_);
#line 76 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp8_ = obj;
#line 76 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp9_ = json_object_get_string_member (_tmp8_, "description");
#line 76 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_set_description (self, _tmp9_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp10_ = obj;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp11_ = json_object_get_int_member (_tmp10_, "id");
#line 77 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->id = _tmp11_;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp12_ = user;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp13_ = json_object_get_string_member (_tmp12_, "screen_name");
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (self->creator_screen_name);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->creator_screen_name = _tmp14_;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp15_ = obj;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp16_ = json_object_get_int_member (_tmp15_, "subscriber_count");
#line 79 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->n_subscribers = (gint) _tmp16_;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp17_ = obj;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp18_ = json_object_get_int_member (_tmp17_, "member_count");
#line 80 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->n_members = (gint) _tmp18_;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp19_ = obj;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp20_ = json_object_get_string_member (_tmp19_, "created_at");
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp21_ = utils_parse_date (_tmp20_);
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp22_ = _tmp21_;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp23_ = g_date_time_to_unix (_tmp22_);
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->created_at = _tmp23_;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_date_time_unref0 (_tmp22_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp24_ = obj;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp25_ = json_object_get_string_member (_tmp24_, "mode");
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp26_ = g_strdup (_tmp25_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (self->mode);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->mode = _tmp26_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp27_ = obj;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp28_ = json_object_get_boolean_member (_tmp27_, "following");
#line 83 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	following = _tmp28_;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp30_ = following;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_tmp30_) {
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp29_ = TRUE;
#line 358 "ListListEntry.c"
	} else {
		JsonObject* _tmp31_ = NULL;
		gint64 _tmp32_ = 0LL;
		Account* _tmp33_ = NULL;
		gint64 _tmp34_ = 0LL;
		gint64 _tmp35_ = 0LL;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp31_ = user;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp32_ = json_object_get_int_member (_tmp31_, "id");
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp33_ = account;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp34_ = account_get_id (_tmp33_);
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp35_ = _tmp34_;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp29_ = _tmp32_ == _tmp35_;
#line 377 "ListListEntry.c"
	}
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp36_ = _tmp29_;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_tmp36_) {
#line 383 "ListListEntry.c"
		GtkButton* _tmp37_ = NULL;
		GtkButton* _tmp38_ = NULL;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp37_ = self->priv->unsubscribe_button;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GTK_TYPE_WIDGET, GtkWidget));
#line 87 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp38_ = self->priv->subscribe_button;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GTK_TYPE_WIDGET, GtkWidget));
#line 394 "ListListEntry.c"
	} else {
		GtkButton* _tmp39_ = NULL;
		GtkButton* _tmp40_ = NULL;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp39_ = self->priv->unsubscribe_button;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GTK_TYPE_WIDGET, GtkWidget));
#line 90 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp40_ = self->priv->subscribe_button;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GTK_TYPE_WIDGET, GtkWidget));
#line 406 "ListListEntry.c"
	}
#line 93 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp41_ = user;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp42_ = json_object_get_int_member (_tmp41_, "id");
#line 93 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp43_ = account;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp44_ = account_get_id (_tmp43_);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp45_ = _tmp44_;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_tmp42_ == _tmp45_) {
#line 420 "ListListEntry.c"
		GtkButton* _tmp46_ = NULL;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		self->user_list = TRUE;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp46_ = self->priv->unsubscribe_button;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GTK_TYPE_WIDGET, GtkWidget));
#line 428 "ListListEntry.c"
	} else {
		GtkButton* _tmp47_ = NULL;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp47_ = self->priv->delete_button;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GTK_TYPE_WIDGET, GtkWidget));
#line 435 "ListListEntry.c"
	}
#line 72 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_json_object_unref0 (user);
#line 72 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return self;
#line 441 "ListListEntry.c"
}


ListListEntry* list_list_entry_new_from_json_data (JsonObject* obj, Account* account) {
#line 72 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return list_list_entry_construct_from_json_data (TYPE_LIST_LIST_ENTRY, obj, account);
#line 448 "ListListEntry.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1237 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1237 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 468 "ListListEntry.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 481 "ListListEntry.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 511 "ListListEntry.c"
				goto __catch86_g_regex_error;
			}
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 520 "ListListEntry.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 536 "ListListEntry.c"
				goto __catch86_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 547 "ListListEntry.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 555 "ListListEntry.c"
	}
	goto __finally86;
	__catch86_g_regex_error:
	{
		GError* e = NULL;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1246 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 569 "ListListEntry.c"
	}
	__finally86:
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return NULL;
#line 580 "ListListEntry.c"
	}
}


static gchar* list_list_entry_normalize_name (ListListEntry* self, const gchar* name) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (IS_LIST_LIST_ENTRY (self), NULL);
#line 101 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 102 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = name;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = string_contains (_tmp0_, "/lists/");
#line 102 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_tmp1_) {
#line 601 "ListListEntry.c"
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp2_ = name;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp3_ = string_replace (_tmp2_, "/lists/", "/");
#line 103 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		result = _tmp3_;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return result;
#line 612 "ListListEntry.c"
	}
#line 105 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp4_ = name;
#line 105 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 105 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	result = _tmp5_;
#line 105 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return result;
#line 622 "ListListEntry.c"
}


static Block56Data* block56_data_ref (Block56Data* _data56_) {
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_atomic_int_inc (&_data56_->_ref_count_);
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return _data56_;
#line 631 "ListListEntry.c"
}


static void block56_data_unref (void * _userdata_) {
	Block56Data* _data56_;
	_data56_ = (Block56Data*) _userdata_;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (g_atomic_int_dec_and_test (&_data56_->_ref_count_)) {
#line 640 "ListListEntry.c"
		ListListEntry * self;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		self = _data56_->self;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_object_unref0 (_data56_->call);
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_object_unref0 (self);
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_slice_free (Block56Data, _data56_);
#line 650 "ListListEntry.c"
	}
}


static void __lambda112_ (Block56Data* _data56_, GObject* o, GAsyncResult* res) {
	ListListEntry * self;
	GError * _inner_error_ = NULL;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self = _data56_->self;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail ((o == NULL) || G_IS_OBJECT (o));
#line 115 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 664 "ListListEntry.c"
	{
		GAsyncResult* _tmp0_ = NULL;
#line 117 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp0_ = res;
#line 117 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		rest_proxy_call_invoke_finish (_data56_->call, _tmp0_, &_inner_error_);
#line 117 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		if (_inner_error_ != NULL) {
#line 673 "ListListEntry.c"
			goto __catch87_g_error;
		}
	}
	goto __finally87;
	__catch87_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		e = _inner_error_;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp1_ = rest_proxy_call_get_payload (_data56_->call);
#line 119 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp2_ = e;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp3_ = _tmp2_->message;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		utils_show_error_object (_tmp1_, _tmp3_);
#line 120 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_error_free0 (e);
#line 120 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return;
#line 700 "ListListEntry.c"
	}
	__finally87:
#line 116 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_inner_error_ != NULL) {
#line 116 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 116 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_clear_error (&_inner_error_);
#line 116 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return;
#line 711 "ListListEntry.c"
	}
}


static void ___lambda112__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 115 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	__lambda112_ (self, source_object, res);
#line 115 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	block56_data_unref (self);
#line 721 "ListListEntry.c"
}


static void list_list_entry_delete_button_clicked_cb (ListListEntry* self) {
	Block56Data* _data56_;
	Account* _tmp0_ = NULL;
	OAuthProxy* _tmp1_ = NULL;
	OAuthProxy* _tmp2_ = NULL;
	RestProxyCall* _tmp3_ = NULL;
	gint64 _tmp4_ = 0LL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data56_ = g_slice_new0 (Block56Data);
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data56_->_ref_count_ = 1;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data56_->self = g_object_ref (self);
#line 110 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), FALSE);
#line 111 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->account;
#line 111 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = account_get_proxy (_tmp0_);
#line 111 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = _tmp1_;
#line 111 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp3_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, rest_proxy_get_type (), RestProxy));
#line 111 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data56_->call = _tmp3_;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_set_function (_data56_->call, "1.1/lists/destroy.json");
#line 113 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_set_method (_data56_->call, "POST");
#line 114 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp4_ = self->id;
#line 114 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp4_);
#line 114 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp6_ = _tmp5_;
#line 114 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_add_param (_data56_->call, "list_id", _tmp6_);
#line 114 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (_tmp6_);
#line 115 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_invoke_async (_data56_->call, NULL, ___lambda112__gasync_ready_callback, block56_data_ref (_data56_));
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	block56_data_unref (_data56_);
#line 109 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data56_ = NULL;
#line 774 "ListListEntry.c"
}


static void _list_list_entry_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_delete_button_clicked_cb (self);
#line 781 "ListListEntry.c"
}


static Block57Data* block57_data_ref (Block57Data* _data57_) {
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_atomic_int_inc (&_data57_->_ref_count_);
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return _data57_;
#line 790 "ListListEntry.c"
}


static void block57_data_unref (void * _userdata_) {
	Block57Data* _data57_;
	_data57_ = (Block57Data*) _userdata_;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (g_atomic_int_dec_and_test (&_data57_->_ref_count_)) {
#line 799 "ListListEntry.c"
		ListListEntry * self;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		self = _data57_->self;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_object_unref0 (_data57_->call);
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_object_unref0 (self);
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_slice_free (Block57Data, _data57_);
#line 809 "ListListEntry.c"
	}
}


static void __lambda113_ (Block57Data* _data57_, GObject* o, GAsyncResult* res) {
	ListListEntry * self;
	GtkButton* _tmp8_ = NULL;
	GtkButton* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
#line 134 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self = _data57_->self;
#line 134 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail ((o == NULL) || G_IS_OBJECT (o));
#line 134 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 825 "ListListEntry.c"
	{
		GAsyncResult* _tmp0_ = NULL;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp0_ = res;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		rest_proxy_call_invoke_finish (_data57_->call, _tmp0_, &_inner_error_);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		if (_inner_error_ != NULL) {
#line 834 "ListListEntry.c"
			goto __catch88_g_error;
		}
	}
	goto __finally88;
	__catch88_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 135 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		e = _inner_error_;
#line 135 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp1_ = rest_proxy_call_get_payload (_data57_->call);
#line 138 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp2_ = e;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp3_ = _tmp2_->message;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		utils_show_error_object (_tmp1_, _tmp3_);
#line 139 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_error_free0 (e);
#line 859 "ListListEntry.c"
		{
			GtkButton* _tmp4_ = NULL;
			GtkButton* _tmp5_ = NULL;
#line 141 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
			_tmp4_ = self->priv->subscribe_button;
#line 141 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 142 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
			_tmp5_ = self->priv->cancel_button;
#line 142 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 871 "ListListEntry.c"
		}
#line 139 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return;
#line 875 "ListListEntry.c"
	}
	__finally88:
	{
		GtkButton* _tmp6_ = NULL;
		GtkButton* _tmp7_ = NULL;
#line 141 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp6_ = self->priv->subscribe_button;
#line 141 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 142 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp7_ = self->priv->cancel_button;
#line 142 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 889 "ListListEntry.c"
	}
#line 135 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_inner_error_ != NULL) {
#line 135 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 135 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_clear_error (&_inner_error_);
#line 135 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return;
#line 899 "ListListEntry.c"
	}
#line 144 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp8_ = self->priv->subscribe_button;
#line 144 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GTK_TYPE_WIDGET, GtkWidget));
#line 145 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp9_ = self->priv->unsubscribe_button;
#line 145 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GTK_TYPE_WIDGET, GtkWidget));
#line 909 "ListListEntry.c"
}


static void ___lambda113__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 134 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	__lambda113_ (self, source_object, res);
#line 134 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	block57_data_unref (self);
#line 918 "ListListEntry.c"
}


static void list_list_entry_subscribe_button_clicked_cb (ListListEntry* self) {
	Block57Data* _data57_;
	GtkButton* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
	Account* _tmp2_ = NULL;
	OAuthProxy* _tmp3_ = NULL;
	OAuthProxy* _tmp4_ = NULL;
	RestProxyCall* _tmp5_ = NULL;
	gint64 _tmp6_ = 0LL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data57_ = g_slice_new0 (Block57Data);
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data57_->_ref_count_ = 1;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data57_->self = g_object_ref (self);
#line 128 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->subscribe_button;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WIDGET, GtkWidget), FALSE);
#line 129 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = self->priv->cancel_button;
#line 129 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GTK_TYPE_WIDGET, GtkWidget), FALSE);
#line 130 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = self->priv->account;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp3_ = account_get_proxy (_tmp2_);
#line 130 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp4_ = _tmp3_;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp5_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, rest_proxy_get_type (), RestProxy));
#line 130 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data57_->call = _tmp5_;
#line 131 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_set_function (_data57_->call, "1.1/lists/subscribers/create.json");
#line 132 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_set_method (_data57_->call, "POST");
#line 133 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp6_ = self->id;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp6_);
#line 133 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp8_ = _tmp7_;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_add_param (_data57_->call, "list_id", _tmp8_);
#line 133 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (_tmp8_);
#line 134 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_invoke_async (_data57_->call, NULL, ___lambda113__gasync_ready_callback, block57_data_ref (_data57_));
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	block57_data_unref (_data57_);
#line 127 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data57_ = NULL;
#line 979 "ListListEntry.c"
}


static void _list_list_entry_subscribe_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_subscribe_button_clicked_cb (self);
#line 986 "ListListEntry.c"
}


static Block58Data* block58_data_ref (Block58Data* _data58_) {
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_atomic_int_inc (&_data58_->_ref_count_);
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return _data58_;
#line 995 "ListListEntry.c"
}


static void block58_data_unref (void * _userdata_) {
	Block58Data* _data58_;
	_data58_ = (Block58Data*) _userdata_;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (g_atomic_int_dec_and_test (&_data58_->_ref_count_)) {
#line 1004 "ListListEntry.c"
		ListListEntry * self;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		self = _data58_->self;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_object_unref0 (_data58_->call);
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_object_unref0 (self);
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_slice_free (Block58Data, _data58_);
#line 1014 "ListListEntry.c"
	}
}


static void __lambda114_ (Block58Data* _data58_, GObject* o, GAsyncResult* res) {
	ListListEntry * self;
	GError * _inner_error_ = NULL;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self = _data58_->self;
#line 157 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail ((o == NULL) || G_IS_OBJECT (o));
#line 157 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 1028 "ListListEntry.c"
	{
		GAsyncResult* _tmp0_ = NULL;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp0_ = res;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		rest_proxy_call_invoke_finish (_data58_->call, _tmp0_, &_inner_error_);
#line 159 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		if (_inner_error_ != NULL) {
#line 1037 "ListListEntry.c"
			goto __catch89_g_error;
		}
	}
	goto __finally89;
	__catch89_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 158 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		e = _inner_error_;
#line 158 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_inner_error_ = NULL;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp1_ = rest_proxy_call_get_payload (_data58_->call);
#line 161 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp2_ = e;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_tmp3_ = _tmp2_->message;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		utils_show_error_object (_tmp1_, _tmp3_);
#line 162 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		_g_error_free0 (e);
#line 162 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return;
#line 1064 "ListListEntry.c"
	}
	__finally89:
#line 158 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	if (_inner_error_ != NULL) {
#line 158 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		return;
#line 1075 "ListListEntry.c"
	}
}


static void ___lambda114__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 157 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	__lambda114_ (self, source_object, res);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	block58_data_unref (self);
#line 1085 "ListListEntry.c"
}


static void list_list_entry_unsubscribe_button_clicked_cb (ListListEntry* self) {
	Block58Data* _data58_;
	Account* _tmp0_ = NULL;
	OAuthProxy* _tmp1_ = NULL;
	OAuthProxy* _tmp2_ = NULL;
	RestProxyCall* _tmp3_ = NULL;
	gint64 _tmp4_ = 0LL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data58_ = g_slice_new0 (Block58Data);
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data58_->_ref_count_ = 1;
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data58_->self = g_object_ref (self);
#line 152 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), FALSE);
#line 153 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->account;
#line 153 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = account_get_proxy (_tmp0_);
#line 153 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = _tmp1_;
#line 153 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp3_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, rest_proxy_get_type (), RestProxy));
#line 153 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data58_->call = _tmp3_;
#line 154 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_set_function (_data58_->call, "1.1/lists/subscribers/destroy.json");
#line 155 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_set_method (_data58_->call, "POST");
#line 156 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp4_ = self->id;
#line 156 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp4_);
#line 156 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp6_ = _tmp5_;
#line 156 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_add_param (_data58_->call, "list_id", _tmp6_);
#line 156 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (_tmp6_);
#line 157 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	rest_proxy_call_invoke_async (_data58_->call, NULL, ___lambda114__gasync_ready_callback, block58_data_ref (_data58_));
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	block58_data_unref (_data58_);
#line 151 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_data58_ = NULL;
#line 1138 "ListListEntry.c"
}


static void _list_list_entry_unsubscribe_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_unsubscribe_button_clicked_cb (self);
#line 1145 "ListListEntry.c"
}


static void list_list_entry_more_button_clicked_cb (ListListEntry* self) {
	GtkStack* _tmp0_ = NULL;
#line 169 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 170 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->stack;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "more");
#line 1157 "ListListEntry.c"
}


static void _list_list_entry_more_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_more_button_clicked_cb (self);
#line 1164 "ListListEntry.c"
}


static void list_list_entry_cancel_button_clicked_cb (ListListEntry* self) {
	GtkStack* _tmp0_ = NULL;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 175 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->stack;
#line 175 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "default");
#line 1176 "ListListEntry.c"
}


static void _list_list_entry_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_cancel_button_clicked_cb (self);
#line 1183 "ListListEntry.c"
}


static gboolean list_list_entry_focus_out_cb (ListListEntry* self) {
	gboolean result = FALSE;
	GtkStack* _tmp0_ = NULL;
#line 179 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (IS_LIST_LIST_ENTRY (self), FALSE);
#line 180 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->stack;
#line 180 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "default");
#line 181 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	result = FALSE;
#line 181 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return result;
#line 1200 "ListListEntry.c"
}


static gboolean _list_list_entry_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = list_list_entry_focus_out_cb (self);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return result;
#line 1209 "ListListEntry.c"
}


ListListEntry* list_list_entry_construct (GType object_type) {
	ListListEntry * self = NULL;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self = (ListListEntry*) g_object_new (object_type, NULL);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return self;
#line 1219 "ListListEntry.c"
}


ListListEntry* list_list_entry_new (void) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return list_list_entry_construct (TYPE_LIST_LIST_ENTRY);
#line 1226 "ListListEntry.c"
}


const gchar* list_list_entry_get_name (ListListEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (IS_LIST_LIST_ENTRY (self), NULL);
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = _tmp1_;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	result = _tmp2_;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return result;
#line 1247 "ListListEntry.c"
}


void list_list_entry_set_name (ListListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = value;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = list_list_entry_normalize_name (self, _tmp1_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp3_ = _tmp2_;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (_tmp3_);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_object_notify ((GObject *) self, "name");
#line 1272 "ListListEntry.c"
}


const gchar* list_list_entry_get_description (ListListEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_val_if_fail (IS_LIST_LIST_ENTRY (self), NULL);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->description_label;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp2_ = _tmp1_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	result = _tmp2_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	return result;
#line 1293 "ListListEntry.c"
}


void list_list_entry_set_description (ListListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_return_if_fail (IS_LIST_LIST_ENTRY (self));
#line 45 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp0_ = self->priv->description_label;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_tmp1_ = value;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_object_notify ((GObject *) self, "description");
#line 1310 "ListListEntry.c"
}


static void list_list_entry_class_init (ListListEntryClass * klass) {
	gint ListListEntry_private_offset;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	list_list_entry_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_type_class_add_private (klass, sizeof (ListListEntryPrivate));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_list_list_entry_get_property;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_list_list_entry_set_property;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = list_list_entry_finalize;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIST_LIST_ENTRY_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIST_LIST_ENTRY_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	ListListEntry_private_offset = g_type_class_get_instance_private_offset (klass);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/list-list-entry.ui");
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_label", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, name_label));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_label", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, description_label));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, stack));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subscribe_button", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, subscribe_button));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unsubscribe_button", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, unsubscribe_button));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_button", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, delete_button));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cancel_button", FALSE, ListListEntry_private_offset + G_STRUCT_OFFSET (ListListEntryPrivate, cancel_button));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_button_clicked_cb", G_CALLBACK(_list_list_entry_delete_button_clicked_cb_gtk_button_clicked));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "subscribe_button_clicked_cb", G_CALLBACK(_list_list_entry_subscribe_button_clicked_cb_gtk_button_clicked));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "unsubscribe_button_clicked_cb", G_CALLBACK(_list_list_entry_unsubscribe_button_clicked_cb_gtk_button_clicked));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "more_button_clicked_cb", G_CALLBACK(_list_list_entry_more_button_clicked_cb_gtk_button_clicked));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_button_clicked_cb", G_CALLBACK(_list_list_entry_cancel_button_clicked_cb_gtk_button_clicked));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "focus_out_cb", G_CALLBACK(_list_list_entry_focus_out_cb_gtk_widget_focus_out_event));
#line 1360 "ListListEntry.c"
}


static void list_list_entry_instance_init (ListListEntry * self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->priv = LIST_LIST_ENTRY_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 64 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->user_list = FALSE;
#line 67 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self->n_members = 0;
#line 1373 "ListListEntry.c"
}


static void list_list_entry_finalize (GObject* obj) {
	ListListEntry * self;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIST_LIST_ENTRY, ListListEntry);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->name_label);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->description_label);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->stack);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->subscribe_button);
#line 56 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->unsubscribe_button);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 60 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 65 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (self->creator_screen_name);
#line 69 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	_g_free0 (self->mode);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	G_OBJECT_CLASS (list_list_entry_parent_class)->finalize (obj);
#line 1401 "ListListEntry.c"
}


GType list_list_entry_get_type (void) {
	static volatile gsize list_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&list_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ListListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) list_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ListListEntry), 0, (GInstanceInitFunc) list_list_entry_instance_init, NULL };
		GType list_list_entry_type_id;
		list_list_entry_type_id = g_type_register_static (GTK_TYPE_LIST_BOX_ROW, "ListListEntry", &g_define_type_info, 0);
		g_once_init_leave (&list_list_entry_type_id__volatile, list_list_entry_type_id);
	}
	return list_list_entry_type_id__volatile;
}


static void _vala_list_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ListListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIST_LIST_ENTRY, ListListEntry);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	switch (property_id) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		case LIST_LIST_ENTRY_NAME:
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_value_set_string (value, list_list_entry_get_name (self));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		break;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		case LIST_LIST_ENTRY_DESCRIPTION:
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		g_value_set_string (value, list_list_entry_get_description (self));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		break;
#line 1434 "ListListEntry.c"
		default:
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		break;
#line 1440 "ListListEntry.c"
	}
}


static void _vala_list_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ListListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIST_LIST_ENTRY, ListListEntry);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
	switch (property_id) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		case LIST_LIST_ENTRY_NAME:
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		list_list_entry_set_name (self, g_value_get_string (value));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		break;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		case LIST_LIST_ENTRY_DESCRIPTION:
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		list_list_entry_set_description (self, g_value_get_string (value));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		break;
#line 1462 "ListListEntry.c"
		default:
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/list/ListListEntry.vala"
		break;
#line 1468 "ListListEntry.c"
	}
}



