/* UserListEntry.c generated by valac 0.22.1, the Vala compiler
 * generated from UserListEntry.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_ITWITTER_ITEM (itwitter_item_get_type ())
#define ITWITTER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ITWITTER_ITEM, ITwitterItem))
#define IS_ITWITTER_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ITWITTER_ITEM))
#define ITWITTER_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ITWITTER_ITEM, ITwitterItemIface))

typedef struct _ITwitterItem ITwitterItem;
typedef struct _ITwitterItemIface ITwitterItemIface;

#define TYPE_USER_LIST_ENTRY (user_list_entry_get_type ())
#define USER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_LIST_ENTRY, UserListEntry))
#define USER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_LIST_ENTRY, UserListEntryClass))
#define IS_USER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_LIST_ENTRY))
#define IS_USER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_LIST_ENTRY))
#define USER_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_LIST_ENTRY, UserListEntryClass))

typedef struct _UserListEntry UserListEntry;
typedef struct _UserListEntryClass UserListEntryClass;
typedef struct _UserListEntryPrivate UserListEntryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_TWITTER (twitter_get_type ())
#define TWITTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWITTER, Twitter))
#define TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWITTER, TwitterClass))
#define IS_TWITTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWITTER))
#define IS_TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWITTER))
#define TWITTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWITTER, TwitterClass))

typedef struct _Twitter Twitter;
typedef struct _TwitterClass TwitterClass;

struct _ITwitterItemIface {
	GTypeInterface parent_iface;
	gint (*update_time_delta) (ITwitterItem* self, GDateTime* now);
	gint64 (*get_sort_factor) (ITwitterItem* self);
	gboolean (*get_seen) (ITwitterItem* self);
	void (*set_seen) (ITwitterItem* self, gboolean value);
};

struct _UserListEntry {
	GtkListBoxRow parent_instance;
	UserListEntryPrivate * priv;
};

struct _UserListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _UserListEntryPrivate {
	GtkLabel* name_label;
	GtkLabel* screen_name_label;
	GtkImage* avatar_image;
	gint64 _user_id;
};

typedef void (*TwitterAvatarDownloadedFunc) (GdkPixbuf* avatar, void* user_data);

static gpointer user_list_entry_parent_class = NULL;
static ITwitterItemIface* user_list_entry_itwitter_item_parent_iface = NULL;

GType itwitter_item_get_type (void) G_GNUC_CONST;
GType user_list_entry_get_type (void) G_GNUC_CONST;
#define USER_LIST_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_LIST_ENTRY, UserListEntryPrivate))
enum  {
	USER_LIST_ENTRY_DUMMY_PROPERTY,
	USER_LIST_ENTRY_NAME,
	USER_LIST_ENTRY_SCREEN_NAME,
	USER_LIST_ENTRY_AVATAR,
	USER_LIST_ENTRY_SEEN,
	USER_LIST_ENTRY_SORT_FACTOR,
	USER_LIST_ENTRY_USER_ID
};
static void user_list_entry_real_set_avatar (UserListEntry* self, const gchar* avatar_url);
GType twitter_get_type (void) G_GNUC_CONST;
Twitter* twitter_get (void);
GdkPixbuf* twitter_get_avatar (Twitter* self, const gchar* url, TwitterAvatarDownloadedFunc func, void* func_target, GDestroyNotify func_target_destroy_notify);
static void __lambda130_ (UserListEntry* self, GdkPixbuf* a);
static void ___lambda130__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self);
static gint user_list_entry_real_update_time_delta (ITwitterItem* base, GDateTime* now);
UserListEntry* user_list_entry_new (void);
UserListEntry* user_list_entry_construct (GType object_type);
void user_list_entry_set_name (UserListEntry* self, const gchar* value);
void user_list_entry_set_screen_name (UserListEntry* self, const gchar* value);
void user_list_entry_set_avatar (UserListEntry* self, const gchar* value);
gint64 user_list_entry_get_user_id (UserListEntry* self);
void user_list_entry_set_user_id (UserListEntry* self, gint64 value);
static void user_list_entry_finalize (GObject* obj);
gboolean itwitter_item_get_seen (ITwitterItem* self);
gint64 itwitter_item_get_sort_factor (ITwitterItem* self);
static void _vala_user_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
void itwitter_item_set_seen (ITwitterItem* self, gboolean value);
static void _vala_user_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void __lambda130_ (UserListEntry* self, GdkPixbuf* a) {
	GtkImage* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (GDK_IS_PIXBUF (a));
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp1_ = a;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_set (_tmp0_, "pixbuf", _tmp1_, NULL);
#line 134 "UserListEntry.c"
}


static void ___lambda130__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self) {
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	__lambda130_ (self, avatar);
#line 141 "UserListEntry.c"
}


static void user_list_entry_real_set_avatar (UserListEntry* self, const gchar* avatar_url) {
	GtkImage* _tmp0_ = NULL;
	Twitter* _tmp1_ = NULL;
	Twitter* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GdkPixbuf* _tmp5_ = NULL;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (IS_USER_LIST_ENTRY (self));
#line 52 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (avatar_url != NULL);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp1_ = twitter_get ();
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp2_ = _tmp1_;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp3_ = avatar_url;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp4_ = twitter_get_avatar (_tmp2_, _tmp3_, ___lambda130__twitter_avatar_downloaded_func, g_object_ref (self), g_object_unref);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp5_ = _tmp4_;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_set (_tmp0_, "pixbuf", _tmp5_, NULL);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_g_object_unref0 (_tmp5_);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_g_object_unref0 (_tmp2_);
#line 174 "UserListEntry.c"
}


static gint user_list_entry_real_update_time_delta (ITwitterItem* base, GDateTime* now) {
	UserListEntry * self;
	gint result = 0;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	result = 0;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	return result;
#line 187 "UserListEntry.c"
}


UserListEntry* user_list_entry_construct (GType object_type) {
	UserListEntry * self = NULL;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self = (UserListEntry*) g_object_new (object_type, NULL);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	return self;
#line 197 "UserListEntry.c"
}


UserListEntry* user_list_entry_new (void) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	return user_list_entry_construct (TYPE_USER_LIST_ENTRY);
#line 204 "UserListEntry.c"
}


void user_list_entry_set_name (UserListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (IS_USER_LIST_ENTRY (self));
#line 30 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp1_ = value;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_notify ((GObject *) self, "name");
#line 221 "UserListEntry.c"
}


void user_list_entry_set_screen_name (UserListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (IS_USER_LIST_ENTRY (self));
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp1_ = value;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_notify ((GObject *) self, "screen-name");
#line 238 "UserListEntry.c"
}


void user_list_entry_set_avatar (UserListEntry* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (IS_USER_LIST_ENTRY (self));
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = value;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	user_list_entry_real_set_avatar (self, _tmp0_);
#line 38 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_notify ((GObject *) self, "avatar");
#line 252 "UserListEntry.c"
}


static gboolean user_list_entry_real_get_seen (ITwitterItem* base) {
	gboolean result;
	UserListEntry* self;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	result = TRUE;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	return result;
#line 265 "UserListEntry.c"
}


static void user_list_entry_real_set_seen (ITwitterItem* base, gboolean value) {
	UserListEntry* self;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_notify ((GObject *) self, "seen");
#line 275 "UserListEntry.c"
}


static gint64 user_list_entry_real_get_sort_factor (ITwitterItem* base) {
	gint64 result;
	UserListEntry* self;
	gint64 _tmp0_ = 0LL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = G_MAXINT64;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	result = _tmp0_ - 1;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	return result;
#line 291 "UserListEntry.c"
}


gint64 user_list_entry_get_user_id (UserListEntry* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_val_if_fail (IS_USER_LIST_ENTRY (self), 0LL);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = self->priv->_user_id;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	result = _tmp0_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	return result;
#line 306 "UserListEntry.c"
}


void user_list_entry_set_user_id (UserListEntry* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_return_if_fail (IS_USER_LIST_ENTRY (self));
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_tmp0_ = value;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self->priv->_user_id = _tmp0_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_notify ((GObject *) self, "user-id");
#line 320 "UserListEntry.c"
}


static void user_list_entry_class_init (UserListEntryClass * klass) {
	gint UserListEntry_private_offset;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	user_list_entry_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_type_class_add_private (klass, sizeof (UserListEntryPrivate));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_user_list_entry_get_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_user_list_entry_set_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = user_list_entry_finalize;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_SCREEN_NAME, g_param_spec_string ("screen-name", "screen-name", "screen-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_AVATAR, g_param_spec_string ("avatar", "avatar", "avatar", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_SEEN, g_param_spec_boolean ("seen", "seen", "seen", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_SORT_FACTOR, g_param_spec_int64 ("sort-factor", "sort-factor", "sort-factor", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_USER_ID, g_param_spec_int64 ("user-id", "user-id", "user-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	UserListEntry_private_offset = g_type_class_get_instance_private_offset (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/user-list-entry.ui");
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_label", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, name_label));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "screen_name_label", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, screen_name_label));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "avatar_image", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, avatar_image));
#line 358 "UserListEntry.c"
}


static void user_list_entry_itwitter_item_interface_init (ITwitterItemIface * iface) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	user_list_entry_itwitter_item_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	iface->update_time_delta = (gint (*)(ITwitterItem*, GDateTime*)) user_list_entry_real_update_time_delta;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	iface->get_seen = user_list_entry_real_get_seen;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	iface->set_seen = user_list_entry_real_set_seen;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	iface->get_sort_factor = user_list_entry_real_get_sort_factor;
#line 373 "UserListEntry.c"
}


static void user_list_entry_instance_init (UserListEntry * self) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self->priv = USER_LIST_ENTRY_GET_PRIVATE (self);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 382 "UserListEntry.c"
}


static void user_list_entry_finalize (GObject* obj) {
	UserListEntry * self;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 23 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_g_object_unref0 (self->priv->name_label);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 27 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	_g_object_unref0 (self->priv->avatar_image);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	G_OBJECT_CLASS (user_list_entry_parent_class)->finalize (obj);
#line 398 "UserListEntry.c"
}


GType user_list_entry_get_type (void) {
	static volatile gsize user_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&user_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserListEntry), 0, (GInstanceInitFunc) user_list_entry_instance_init, NULL };
		static const GInterfaceInfo itwitter_item_info = { (GInterfaceInitFunc) user_list_entry_itwitter_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType user_list_entry_type_id;
		user_list_entry_type_id = g_type_register_static (GTK_TYPE_LIST_BOX_ROW, "UserListEntry", &g_define_type_info, 0);
		g_type_add_interface_static (user_list_entry_type_id, TYPE_ITWITTER_ITEM, &itwitter_item_info);
		g_once_init_leave (&user_list_entry_type_id__volatile, user_list_entry_type_id);
	}
	return user_list_entry_type_id__volatile;
}


static void _vala_user_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	UserListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SEEN:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		g_value_set_boolean (value, itwitter_item_get_seen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ITWITTER_ITEM, ITwitterItem)));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SORT_FACTOR:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		g_value_set_int64 (value, itwitter_item_get_sort_factor (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ITWITTER_ITEM, ITwitterItem)));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_USER_ID:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		g_value_set_int64 (value, user_list_entry_get_user_id (self));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 439 "UserListEntry.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 445 "UserListEntry.c"
	}
}


static void _vala_user_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UserListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_NAME:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		user_list_entry_set_name (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SCREEN_NAME:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		user_list_entry_set_screen_name (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_AVATAR:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		user_list_entry_set_avatar (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SEEN:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		itwitter_item_set_seen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ITWITTER_ITEM, ITwitterItem), g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_USER_ID:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		user_list_entry_set_user_id (self, g_value_get_int64 (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 485 "UserListEntry.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/list/UserListEntry.vala"
		break;
#line 491 "UserListEntry.c"
	}
}



