/* Database.c generated by valac 0.22.1, the Vala compiler
 * generated from Database.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gstdio.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>


#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;
typedef struct _SqlDatabasePrivate SqlDatabasePrivate;
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
typedef struct _Block78Data Block78Data;
#define _sql_database_unref0(var) ((var == NULL) ? NULL : (var = (sql_database_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define SQL_TYPE_INSERT_STATEMENT (sql_insert_statement_get_type ())
#define SQL_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatement))
#define SQL_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))
#define SQL_IS_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_INSERT_STATEMENT))
#define SQL_IS_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_INSERT_STATEMENT))
#define SQL_INSERT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))

typedef struct _SqlInsertStatement SqlInsertStatement;
typedef struct _SqlInsertStatementClass SqlInsertStatementClass;

#define SQL_TYPE_ISTATEMENT (sql_istatement_get_type ())
#define SQL_ISTATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_ISTATEMENT, SqlIStatement))
#define SQL_IS_ISTATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_ISTATEMENT))
#define SQL_ISTATEMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SQL_TYPE_ISTATEMENT, SqlIStatementIface))

typedef struct _SqlIStatement SqlIStatement;
typedef struct _SqlIStatementIface SqlIStatementIface;
#define _sql_insert_statement_unref0(var) ((var == NULL) ? NULL : (var = (sql_insert_statement_unref (var), NULL)))

#define SQL_TYPE_SELECT_STATEMENT (sql_select_statement_get_type ())
#define SQL_SELECT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatement))
#define SQL_SELECT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatementClass))
#define SQL_IS_SELECT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_SELECT_STATEMENT))
#define SQL_IS_SELECT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_SELECT_STATEMENT))
#define SQL_SELECT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatementClass))

typedef struct _SqlSelectStatement SqlSelectStatement;
typedef struct _SqlSelectStatementClass SqlSelectStatementClass;
#define _sql_select_statement_unref0(var) ((var == NULL) ? NULL : (var = (sql_select_statement_unref (var), NULL)))

#define SQL_TYPE_UPDATE_STATEMENT (sql_update_statement_get_type ())
#define SQL_UPDATE_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_UPDATE_STATEMENT, SqlUpdateStatement))
#define SQL_UPDATE_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_UPDATE_STATEMENT, SqlUpdateStatementClass))
#define SQL_IS_UPDATE_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_UPDATE_STATEMENT))
#define SQL_IS_UPDATE_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_UPDATE_STATEMENT))
#define SQL_UPDATE_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_UPDATE_STATEMENT, SqlUpdateStatementClass))

typedef struct _SqlUpdateStatement SqlUpdateStatement;
typedef struct _SqlUpdateStatementClass SqlUpdateStatementClass;
#define _sql_update_statement_unref0(var) ((var == NULL) ? NULL : (var = (sql_update_statement_unref (var), NULL)))
typedef struct _SqlParamSpecDatabase SqlParamSpecDatabase;

struct _SqlDatabase {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SqlDatabasePrivate * priv;
};

struct _SqlDatabaseClass {
	GTypeClass parent_class;
	void (*finalize) (SqlDatabase *self);
};

struct _SqlDatabasePrivate {
	sqlite3* db;
};

struct _Block78Data {
	int _ref_count_;
	SqlDatabase * self;
	gint user_version;
};

struct _SqlIStatementIface {
	GTypeInterface parent_iface;
	sqlite3* (*get_db) (SqlIStatement* self);
	void (*set_db) (SqlIStatement* self, sqlite3* value);
};

struct _SqlParamSpecDatabase {
	GParamSpec parent_instance;
};


static gpointer sql_database_parent_class = NULL;

#define DATADIR "/usr/share/corebird/"
#define SQL_COREBIRD_INIT_FILE DATADIR "/sql/init/Create.%d.sql"
#define SQL_ACCOUNTS_INIT_FILE DATADIR "/sql/accounts/Create.%d.sql"
#define SQL_STOP (-1)
#define SQL_CONTINUE 0
gpointer sql_database_ref (gpointer instance);
void sql_database_unref (gpointer instance);
GParamSpec* sql_param_spec_database (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_database (GValue* value, gpointer v_object);
void sql_value_take_database (GValue* value, gpointer v_object);
gpointer sql_value_get_database (const GValue* value);
GType sql_database_get_type (void) G_GNUC_CONST;
#define SQL_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SQL_TYPE_DATABASE, SqlDatabasePrivate))
enum  {
	SQL_DATABASE_DUMMY_PROPERTY
};
SqlDatabase* sql_database_new (const gchar* filename, const gchar* init_file);
SqlDatabase* sql_database_construct (GType object_type, const gchar* filename, const gchar* init_file);
static Block78Data* block78_data_ref (Block78Data* _data78_);
static void block78_data_unref (void * _userdata_);
void sql_database_exec (SqlDatabase* self, const gchar* sql, sqlite3_callback callback, void* callback_target);
static gint __lambda2_ (Block78Data* _data78_, gint n_cols, gchar** vals, int vals_length1);
static gint ___lambda2__sqlite3_callback (gpointer self, gint n_columns, gchar** values, gchar** column_names);
static gint ___lambda3_ (Block78Data* _data78_, gint n_cols, gchar** vals, int vals_length1);
static gint ____lambda3__sqlite3_callback (gpointer self, gint n_columns, gchar** values, gchar** column_names);
gint64 sql_database_exec_insert (SqlDatabase* self, const gchar* sql);
void sql_database_execf (SqlDatabase* self, const gchar* sql, const gchar* first_param, ...);
gpointer sql_insert_statement_ref (gpointer instance);
void sql_insert_statement_unref (gpointer instance);
GParamSpec* sql_param_spec_insert_statement (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_insert_statement (GValue* value, gpointer v_object);
void sql_value_take_insert_statement (GValue* value, gpointer v_object);
gpointer sql_value_get_insert_statement (const GValue* value);
GType sql_insert_statement_get_type (void) G_GNUC_CONST;
SqlInsertStatement* sql_database_insert (SqlDatabase* self, const gchar* table_name);
SqlInsertStatement* sql_insert_statement_new (const gchar* table_name, gboolean replace);
SqlInsertStatement* sql_insert_statement_construct (GType object_type, const gchar* table_name, gboolean replace);
GType sql_istatement_get_type (void) G_GNUC_CONST;
void sql_istatement_set_db (SqlIStatement* self, sqlite3* value);
SqlInsertStatement* sql_database_replace (SqlDatabase* self, const gchar* table_name);
gpointer sql_select_statement_ref (gpointer instance);
void sql_select_statement_unref (gpointer instance);
GParamSpec* sql_param_spec_select_statement (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_select_statement (GValue* value, gpointer v_object);
void sql_value_take_select_statement (GValue* value, gpointer v_object);
gpointer sql_value_get_select_statement (const GValue* value);
GType sql_select_statement_get_type (void) G_GNUC_CONST;
SqlSelectStatement* sql_database_select (SqlDatabase* self, const gchar* table_name);
SqlSelectStatement* sql_select_statement_new (const gchar* table_name);
SqlSelectStatement* sql_select_statement_construct (GType object_type, const gchar* table_name);
gpointer sql_update_statement_ref (gpointer instance);
void sql_update_statement_unref (gpointer instance);
GParamSpec* sql_param_spec_update_statement (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_update_statement (GValue* value, gpointer v_object);
void sql_value_take_update_statement (GValue* value, gpointer v_object);
gpointer sql_value_get_update_statement (const GValue* value);
GType sql_update_statement_get_type (void) G_GNUC_CONST;
SqlUpdateStatement* sql_database_update (SqlDatabase* self, const gchar* table_name);
SqlUpdateStatement* sql_update_statement_new (const gchar* table_name);
SqlUpdateStatement* sql_update_statement_construct (GType object_type, const gchar* table_name);
void sql_database_begin_transaction (SqlDatabase* self);
void sql_database_end_transaction (SqlDatabase* self);
static void sql_database_finalize (SqlDatabase* obj);


static Block78Data* block78_data_ref (Block78Data* _data78_) {
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_atomic_int_inc (&_data78_->_ref_count_);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return _data78_;
#line 194 "Database.c"
}


static void block78_data_unref (void * _userdata_) {
	Block78Data* _data78_;
	_data78_ = (Block78Data*) _userdata_;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (g_atomic_int_dec_and_test (&_data78_->_ref_count_)) {
#line 203 "Database.c"
		SqlDatabase * self;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		self = _data78_->self;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_sql_database_unref0 (self);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_slice_free (Block78Data, _data78_);
#line 211 "Database.c"
	}
}


static gint __lambda2_ (Block78Data* _data78_, gint n_cols, gchar** vals, int vals_length1) {
	SqlDatabase * self;
	gint result = 0;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self = _data78_->self;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = vals;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0__length1 = vals_length1;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = _tmp0_[0];
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = atoi (_tmp1_);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_->user_version = _tmp2_;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = SQL_STOP;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 239 "Database.c"
}


static gint ___lambda2__sqlite3_callback (gpointer self, gint n_columns, gchar** values, gchar** column_names) {
	gint result;
	result = __lambda2_ (self, n_columns, values, -1);
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 248 "Database.c"
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar** errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	sqlite3_callback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	const gchar* _tmp6_ = NULL;
#line 34 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	_tmp0_ = sql;
#line 36 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	_tmp1_ = callback;
#line 36 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	_tmp1__target = callback_target;
#line 36 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
#line 36 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	sqlite_errmsg = _tmp2_;
#line 36 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	ec = _tmp3_;
#line 37 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 281 "Database.c"
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 38 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
		_tmp4_ = sqlite_errmsg;
#line 38 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
		_tmp5_ = g_strdup (_tmp4_);
#line 38 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
		_vala_errmsg = _tmp5_;
#line 292 "Database.c"
	}
#line 40 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	_tmp6_ = sqlite_errmsg;
#line 40 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	sqlite3_free ((void*) _tmp6_);
#line 41 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	result = ec;
#line 41 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	if (errmsg) {
#line 41 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 304 "Database.c"
	} else {
#line 41 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 308 "Database.c"
	}
#line 41 "/usr/share/vala-0.22/vapi/sqlite3.vapi"
	return result;
#line 312 "Database.c"
}


static gint ___lambda3_ (Block78Data* _data78_, gint n_cols, gchar** vals, int vals_length1) {
	SqlDatabase * self;
	gint result = 0;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self = _data78_->self;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = vals;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0__length1 = vals_length1;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = _tmp0_[0];
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = atoi (_tmp1_);
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_->user_version = _tmp2_;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = SQL_STOP;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 339 "Database.c"
}


static gint ____lambda3__sqlite3_callback (gpointer self, gint n_columns, gchar** values, gchar** column_names) {
	gint result;
	result = ___lambda3_ (self, n_columns, values, -1);
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 348 "Database.c"
}


SqlDatabase* sql_database_construct (GType object_type, const gchar* filename, const gchar* init_file) {
	SqlDatabase* self = NULL;
	Block78Data* _data78_;
	gint err = 0;
	const gchar* _tmp0_ = NULL;
	sqlite3* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	const gchar* _tmp7_ = NULL;
	gchar* next_version_file = NULL;
	const gchar* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	GError * _inner_error_ = NULL;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self = (SqlDatabase*) g_type_create_instance (object_type);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_ = g_slice_new0 (Block78Data);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_->_ref_count_ = 1;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_->self = sql_database_ref (self);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = filename;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = sqlite3_open (_tmp0_, &_tmp1_);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 33 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self->priv->db = _tmp1_;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	err = _tmp2_;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp3_ = err;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (_tmp3_ == 1) {
#line 392 "Database.c"
		const gchar* _tmp4_ = NULL;
		sqlite3* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp4_ = filename;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp5_ = self->priv->db;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp6_ = sqlite3_errmsg (_tmp5_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_critical ("Database.vala:35: Error when opening the database '%s': %s", _tmp4_, _tmp6_);
#line 404 "Database.c"
	}
#line 38 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_database_exec (self, "PRAGMA journal_mode = MEMORY;", NULL, NULL);
#line 39 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp7_ = init_file;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (_tmp7_ == NULL) {
#line 40 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		block78_data_unref (_data78_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_data78_ = NULL;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		return self;
#line 418 "Database.c"
	}
#line 42 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_->user_version = -1;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_database_exec (self, "pragma user_version;", ___lambda2__sqlite3_callback, _data78_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp8_ = init_file;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp9_ = _data78_->user_version;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp10_ = g_strdup_printf (_tmp8_, _tmp9_ + 1);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	next_version_file = _tmp10_;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp11_ = filename;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp12_ = _data78_->user_version;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_debug ("Database.vala:45: %s User version: %d", _tmp11_, _tmp12_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	while (TRUE) {
#line 440 "Database.c"
		const gchar* _tmp13_ = NULL;
		gboolean _tmp14_ = FALSE;
		gchar* sql_content = NULL;
		sqlite3* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		gint _tmp25_ = 0;
		gchar* _tmp26_ = NULL;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp13_ = next_version_file;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp14_ = g_file_test (_tmp13_, G_FILE_TEST_EXISTS);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		if (!_tmp14_) {
#line 46 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			break;
#line 459 "Database.c"
		}
		{
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_tmp15_ = next_version_file;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			g_debug ("Database.vala:49: Applyling file '%s'", _tmp15_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_tmp16_ = next_version_file;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			g_file_get_contents (_tmp16_, &_tmp17_, NULL, &_inner_error_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_g_free0 (sql_content);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			sql_content = _tmp17_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			if (_inner_error_ != NULL) {
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				if (_inner_error_->domain == G_FILE_ERROR) {
#line 481 "Database.c"
					goto __catch113_g_file_error;
				}
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				_g_free0 (sql_content);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				_g_free0 (next_version_file);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				block78_data_unref (_data78_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				_data78_ = NULL;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				g_clear_error (&_inner_error_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
				return NULL;
#line 498 "Database.c"
			}
		}
		goto __finally113;
		__catch113_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			e = _inner_error_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_tmp18_ = e;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_tmp19_ = _tmp18_->message;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			g_critical ("Database.vala:52: %s", _tmp19_);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_g_error_free0 (e);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_g_free0 (sql_content);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_g_free0 (next_version_file);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			block78_data_unref (_data78_);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_data78_ = NULL;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			return self;
#line 529 "Database.c"
		}
		__finally113:
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		if (_inner_error_ != NULL) {
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_g_free0 (sql_content);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_g_free0 (next_version_file);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			block78_data_unref (_data78_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			_data78_ = NULL;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			g_clear_error (&_inner_error_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			return NULL;
#line 548 "Database.c"
		}
#line 55 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp20_ = self->priv->db;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp21_ = sql_content;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_sqlite3_exec (_tmp20_, _tmp21_, NULL, NULL, NULL);
#line 56 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp22_ = next_version_file;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp23_ = filename;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_debug ("Database.vala:56: Executed init file '%s' for database '%s'", _tmp22_, _tmp23_);
#line 57 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		sql_database_exec (self, "pragma user_version;", ____lambda3__sqlite3_callback, _data78_);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp24_ = init_file;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp25_ = _data78_->user_version;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_tmp26_ = g_strdup_printf (_tmp24_, _tmp25_ + 1);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_g_free0 (next_version_file);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		next_version_file = _tmp26_;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		_g_free0 (sql_content);
#line 576 "Database.c"
	}
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_g_free0 (next_version_file);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	block78_data_unref (_data78_);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_data78_ = NULL;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return self;
#line 586 "Database.c"
}


SqlDatabase* sql_database_new (const gchar* filename, const gchar* init_file) {
#line 32 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return sql_database_construct (SQL_TYPE_DATABASE, filename, init_file);
#line 593 "Database.c"
}


gint64 sql_database_exec_insert (SqlDatabase* self, const gchar* sql) {
	gint64 result = 0LL;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	sqlite3* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
#line 62 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (SQL_IS_DATABASE (self), 0LL);
#line 62 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (sql != NULL, 0LL);
#line 63 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = self->priv->db;
#line 63 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql;
#line 63 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_exec (_tmp0_, _tmp1_, NULL, NULL, NULL);
#line 64 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = self->priv->db;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp3_ = sqlite3_last_insert_rowid (_tmp2_);
#line 64 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = _tmp3_;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 621 "Database.c"
}


void sql_database_exec (SqlDatabase* self, const gchar* sql, sqlite3_callback callback, void* callback_target) {
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	sqlite3_callback _tmp2_ = NULL;
	void* _tmp2__target = NULL;
#line 67 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (SQL_IS_DATABASE (self));
#line 67 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (sql != NULL);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = self->priv->db;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = callback;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2__target = callback_target;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_exec (_tmp0_, _tmp1_, _tmp2_, _tmp2__target, NULL);
#line 644 "Database.c"
}


void sql_database_execf (SqlDatabase* self, const gchar* sql, const gchar* first_param, ...) {
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	va_list _tmp3_ = {0};
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (SQL_IS_DATABASE (self));
#line 78 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (sql != NULL);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (first_param != NULL);
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = self->priv->db;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = first_param;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	va_start (_tmp3_, first_param);
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp4_ = g_strdup_printf (_tmp1_, _tmp2_, _tmp3_);
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp5_ = _tmp4_;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_exec (_tmp0_, _tmp5_, NULL, NULL, NULL);
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_g_free0 (_tmp5_);
#line 79 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	va_end (_tmp3_);
#line 679 "Database.c"
}


SqlInsertStatement* sql_database_insert (SqlDatabase* self, const gchar* table_name) {
	SqlInsertStatement* result = NULL;
	SqlInsertStatement* stmt = NULL;
	const gchar* _tmp0_ = NULL;
	SqlInsertStatement* _tmp1_ = NULL;
	sqlite3* _tmp2_ = NULL;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (SQL_IS_DATABASE (self), NULL);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (table_name != NULL, NULL);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = table_name;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql_insert_statement_new (_tmp0_, FALSE);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	stmt = _tmp1_;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = self->priv->db;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_istatement_set_db (G_TYPE_CHECK_INSTANCE_CAST (stmt, SQL_TYPE_ISTATEMENT, SqlIStatement), _tmp2_);
#line 85 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = stmt;
#line 85 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 707 "Database.c"
}


SqlInsertStatement* sql_database_replace (SqlDatabase* self, const gchar* table_name) {
	SqlInsertStatement* result = NULL;
	SqlInsertStatement* stmt = NULL;
	const gchar* _tmp0_ = NULL;
	SqlInsertStatement* _tmp1_ = NULL;
	sqlite3* _tmp2_ = NULL;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (SQL_IS_DATABASE (self), NULL);
#line 88 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (table_name != NULL, NULL);
#line 89 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = table_name;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql_insert_statement_new (_tmp0_, TRUE);
#line 89 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	stmt = _tmp1_;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = self->priv->db;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_istatement_set_db (G_TYPE_CHECK_INSTANCE_CAST (stmt, SQL_TYPE_ISTATEMENT, SqlIStatement), _tmp2_);
#line 91 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = stmt;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 735 "Database.c"
}


SqlSelectStatement* sql_database_select (SqlDatabase* self, const gchar* table_name) {
	SqlSelectStatement* result = NULL;
	SqlSelectStatement* stmt = NULL;
	const gchar* _tmp0_ = NULL;
	SqlSelectStatement* _tmp1_ = NULL;
	sqlite3* _tmp2_ = NULL;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (SQL_IS_DATABASE (self), NULL);
#line 95 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (table_name != NULL, NULL);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = table_name;
#line 96 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql_select_statement_new (_tmp0_);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	stmt = _tmp1_;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = self->priv->db;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_istatement_set_db (G_TYPE_CHECK_INSTANCE_CAST (stmt, SQL_TYPE_ISTATEMENT, SqlIStatement), _tmp2_);
#line 98 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = stmt;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 763 "Database.c"
}


SqlUpdateStatement* sql_database_update (SqlDatabase* self, const gchar* table_name) {
	SqlUpdateStatement* result = NULL;
	SqlUpdateStatement* stmt = NULL;
	const gchar* _tmp0_ = NULL;
	SqlUpdateStatement* _tmp1_ = NULL;
	sqlite3* _tmp2_ = NULL;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (SQL_IS_DATABASE (self), NULL);
#line 101 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (table_name != NULL, NULL);
#line 102 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = table_name;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp1_ = sql_update_statement_new (_tmp0_);
#line 102 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	stmt = _tmp1_;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp2_ = self->priv->db;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_istatement_set_db (G_TYPE_CHECK_INSTANCE_CAST (stmt, SQL_TYPE_ISTATEMENT, SqlIStatement), _tmp2_);
#line 104 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	result = stmt;
#line 104 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return result;
#line 791 "Database.c"
}


void sql_database_begin_transaction (SqlDatabase* self) {
	sqlite3* _tmp0_ = NULL;
#line 107 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (SQL_IS_DATABASE (self));
#line 108 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = self->priv->db;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_exec (_tmp0_, "BEGIN TRANSACTION;", NULL, NULL, NULL);
#line 803 "Database.c"
}


void sql_database_end_transaction (SqlDatabase* self) {
	sqlite3* _tmp0_ = NULL;
#line 111 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (SQL_IS_DATABASE (self));
#line 112 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_tmp0_ = self->priv->db;
#line 112 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_exec (_tmp0_, "END TRANSACTION;", NULL, NULL, NULL);
#line 815 "Database.c"
}


static void sql_value_database_init (GValue* value) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	value->data[0].v_pointer = NULL;
#line 822 "Database.c"
}


static void sql_value_database_free_value (GValue* value) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		sql_database_unref (value->data[0].v_pointer);
#line 831 "Database.c"
	}
}


static void sql_value_database_copy_value (const GValue* src_value, GValue* dest_value) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		dest_value->data[0].v_pointer = sql_database_ref (src_value->data[0].v_pointer);
#line 841 "Database.c"
	} else {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		dest_value->data[0].v_pointer = NULL;
#line 845 "Database.c"
	}
}


static gpointer sql_value_database_peek_pointer (const GValue* value) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return value->data[0].v_pointer;
#line 853 "Database.c"
}


static gchar* sql_value_database_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (collect_values[0].v_pointer) {
#line 860 "Database.c"
		SqlDatabase* object;
		object = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 867 "Database.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 871 "Database.c"
		}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		value->data[0].v_pointer = sql_database_ref (object);
#line 875 "Database.c"
	} else {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		value->data[0].v_pointer = NULL;
#line 879 "Database.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return NULL;
#line 883 "Database.c"
}


static gchar* sql_value_database_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SqlDatabase** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (!object_p) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 894 "Database.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (!value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		*object_p = NULL;
#line 900 "Database.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		*object_p = value->data[0].v_pointer;
#line 904 "Database.c"
	} else {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		*object_p = sql_database_ref (value->data[0].v_pointer);
#line 908 "Database.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return NULL;
#line 912 "Database.c"
}


GParamSpec* sql_param_spec_database (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	SqlParamSpecDatabase* spec;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SQL_TYPE_DATABASE), NULL);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return G_PARAM_SPEC (spec);
#line 926 "Database.c"
}


gpointer sql_value_get_database (const GValue* value) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SQL_TYPE_DATABASE), NULL);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return value->data[0].v_pointer;
#line 935 "Database.c"
}


void sql_value_set_database (GValue* value, gpointer v_object) {
	SqlDatabase* old;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SQL_TYPE_DATABASE));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SQL_TYPE_DATABASE));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		value->data[0].v_pointer = v_object;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		sql_database_ref (value->data[0].v_pointer);
#line 955 "Database.c"
	} else {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		value->data[0].v_pointer = NULL;
#line 959 "Database.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		sql_database_unref (old);
#line 965 "Database.c"
	}
}


void sql_value_take_database (GValue* value, gpointer v_object) {
	SqlDatabase* old;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SQL_TYPE_DATABASE));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SQL_TYPE_DATABASE));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		value->data[0].v_pointer = v_object;
#line 984 "Database.c"
	} else {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		value->data[0].v_pointer = NULL;
#line 988 "Database.c"
	}
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		sql_database_unref (old);
#line 994 "Database.c"
	}
}


static void sql_database_class_init (SqlDatabaseClass * klass) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	sql_database_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	SQL_DATABASE_CLASS (klass)->finalize = sql_database_finalize;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_type_class_add_private (klass, sizeof (SqlDatabasePrivate));
#line 1006 "Database.c"
}


static void sql_database_instance_init (SqlDatabase * self) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self->priv = SQL_DATABASE_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self->ref_count = 1;
#line 1015 "Database.c"
}


static void sql_database_finalize (SqlDatabase* obj) {
	SqlDatabase * self;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_DATABASE, SqlDatabase);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	_sqlite3_close0 (self->priv->db);
#line 1025 "Database.c"
}


GType sql_database_get_type (void) {
	static volatile gsize sql_database_type_id__volatile = 0;
	if (g_once_init_enter (&sql_database_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { sql_value_database_init, sql_value_database_free_value, sql_value_database_copy_value, sql_value_database_peek_pointer, "p", sql_value_database_collect_value, "p", sql_value_database_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SqlDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sql_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SqlDatabase), 0, (GInstanceInitFunc) sql_database_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType sql_database_type_id;
		sql_database_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SqlDatabase", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&sql_database_type_id__volatile, sql_database_type_id);
	}
	return sql_database_type_id__volatile;
}


gpointer sql_database_ref (gpointer instance) {
	SqlDatabase* self;
	self = instance;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	return instance;
#line 1050 "Database.c"
}


void sql_database_unref (gpointer instance) {
	SqlDatabase* self;
	self = instance;
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		SQL_DATABASE_GET_CLASS (self)->finalize (self);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/sql/Database.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1063 "Database.c"
	}
}



