/* AccountCreateWidget.c generated by valac 0.22.1, the Vala compiler
 * generated from AccountCreateWidget.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <rest/oauth-proxy.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <rest/rest-proxy-call.h>
#include <rest/rest-proxy.h>
#include <json-glib/json-glib.h>


#define TYPE_ACCOUNT_CREATE_WIDGET (account_create_widget_get_type ())
#define ACCOUNT_CREATE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT_CREATE_WIDGET, AccountCreateWidget))
#define ACCOUNT_CREATE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT_CREATE_WIDGET, AccountCreateWidgetClass))
#define IS_ACCOUNT_CREATE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT_CREATE_WIDGET))
#define IS_ACCOUNT_CREATE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT_CREATE_WIDGET))
#define ACCOUNT_CREATE_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT_CREATE_WIDGET, AccountCreateWidgetClass))

typedef struct _AccountCreateWidget AccountCreateWidget;
typedef struct _AccountCreateWidgetClass AccountCreateWidgetClass;
typedef struct _AccountCreateWidgetPrivate AccountCreateWidgetPrivate;

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block46Data Block46Data;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define SQL_TYPE_INSERT_STATEMENT (sql_insert_statement_get_type ())
#define SQL_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatement))
#define SQL_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))
#define SQL_IS_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_INSERT_STATEMENT))
#define SQL_IS_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_INSERT_STATEMENT))
#define SQL_INSERT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))

typedef struct _SqlInsertStatement SqlInsertStatement;
typedef struct _SqlInsertStatementClass SqlInsertStatementClass;
#define _sql_insert_statement_unref0(var) ((var == NULL) ? NULL : (var = (sql_insert_statement_unref (var), NULL)))

struct _AccountCreateWidget {
	GtkBox parent_instance;
	AccountCreateWidgetPrivate * priv;
};

struct _AccountCreateWidgetClass {
	GtkBoxClass parent_class;
};

struct _AccountCreateWidgetPrivate {
	GtkEntry* pin_entry;
	GtkSpinner* progress_spinner;
	GtkLabel* error_label;
	GtkInfoBar* error_bar;
	Account* acc;
};

struct _Block46Data {
	int _ref_count_;
	AccountCreateWidget * self;
	RestProxyCall* call;
};


static gpointer account_create_widget_parent_class = NULL;

GType account_create_widget_get_type (void) G_GNUC_CONST;
GType account_get_type (void) G_GNUC_CONST;
#define ACCOUNT_CREATE_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ACCOUNT_CREATE_WIDGET, AccountCreateWidgetPrivate))
enum  {
	ACCOUNT_CREATE_WIDGET_DUMMY_PROPERTY
};
AccountCreateWidget* account_create_widget_new (Account* acc);
AccountCreateWidget* account_create_widget_construct (GType object_type, Account* acc);
void account_create_widget_open_pin_request_site (AccountCreateWidget* self);
void account_init_proxy (Account* self, gboolean load_secrets, gboolean force);
OAuthProxy* account_get_proxy (Account* self);
void utils_show_error_dialog (const gchar* message);
static void account_create_widget_confirm_button_clicked (AccountCreateWidget* self);
static Block46Data* block46_data_ref (Block46Data* _data46_);
static void block46_data_unref (void * _userdata_);
static void __lambda169_ (Block46Data* _data46_, GObject* obj, GAsyncResult* res);
GSList* account_list_accounts (void);
const gchar* account_get_screen_name (Account* self);
void account_query_user_info_by_scren_name (Account* self, const gchar* screen_name, GAsyncReadyCallback _callback_, gpointer _user_data_);
void account_query_user_info_by_scren_name_finish (Account* self, GAsyncResult* _res_);
static void __lambda170_ (AccountCreateWidget* self, GObject* obj, GAsyncResult* res);
void account_init_database (Account* self);
void account_save_info (Account* self);
gpointer sql_database_ref (gpointer instance);
void sql_database_unref (gpointer instance);
GParamSpec* sql_param_spec_database (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_database (GValue* value, gpointer v_object);
void sql_value_take_database (GValue* value, gpointer v_object);
gpointer sql_value_get_database (const GValue* value);
GType sql_database_get_type (void) G_GNUC_CONST;
SqlDatabase* account_get_db (Account* self);
gpointer sql_insert_statement_ref (gpointer instance);
void sql_insert_statement_unref (gpointer instance);
GParamSpec* sql_param_spec_insert_statement (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_insert_statement (GValue* value, gpointer v_object);
void sql_value_take_insert_statement (GValue* value, gpointer v_object);
gpointer sql_value_get_insert_statement (const GValue* value);
GType sql_insert_statement_get_type (void) G_GNUC_CONST;
SqlInsertStatement* sql_database_insert (SqlDatabase* self, const gchar* table_name);
SqlInsertStatement* sql_insert_statement_val (SqlInsertStatement* self, const gchar* col_name, const gchar* col_value);
gint64 sql_insert_statement_run (SqlInsertStatement* self);
static void ___lambda170__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void ___lambda169__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void _account_create_widget_confirm_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void account_create_widget_finalize (GObject* obj);


AccountCreateWidget* account_create_widget_construct (GType object_type, Account* acc) {
	AccountCreateWidget * self = NULL;
	Account* _tmp0_ = NULL;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_val_if_fail (IS_ACCOUNT (acc), NULL);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	self = (AccountCreateWidget*) g_object_new (object_type, NULL);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp0_ = acc;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	self->priv->acc = _tmp0_;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	return self;
#line 169 "AccountCreateWidget.c"
}


AccountCreateWidget* account_create_widget_new (Account* acc) {
#line 34 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	return account_create_widget_construct (TYPE_ACCOUNT_CREATE_WIDGET, acc);
#line 176 "AccountCreateWidget.c"
}


void account_create_widget_open_pin_request_site (AccountCreateWidget* self) {
	Account* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail (IS_ACCOUNT_CREATE_WIDGET (self));
#line 39 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp0_ = self->priv->acc;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_init_proxy (_tmp0_, FALSE, FALSE);
#line 189 "AccountCreateWidget.c"
	{
		Account* _tmp1_ = NULL;
		OAuthProxy* _tmp2_ = NULL;
		OAuthProxy* _tmp3_ = NULL;
		gchar* uri = NULL;
		Account* _tmp4_ = NULL;
		OAuthProxy* _tmp5_ = NULL;
		OAuthProxy* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp1_ = self->priv->acc;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp2_ = account_get_proxy (_tmp1_);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp3_ = _tmp2_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		oauth_proxy_request_token (_tmp3_, "oauth/request_token", "oob", &_inner_error_);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		if (_inner_error_ != NULL) {
#line 212 "AccountCreateWidget.c"
			goto __catch76_g_error;
		}
#line 42 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp4_ = self->priv->acc;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp5_ = account_get_proxy (_tmp4_);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp6_ = _tmp5_;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp7_ = oauth_proxy_get_token (_tmp6_);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp8_ = g_strconcat ("http://twitter.com/oauth/authorize?oauth_token=", _tmp7_, NULL);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		uri = _tmp8_;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp9_ = uri;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_message ("AccountCreateWidget.vala:43: Trying to open %s", _tmp9_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp10_ = uri;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_app_info_launch_default_for_uri (_tmp10_, NULL, &_inner_error_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		if (_inner_error_ != NULL) {
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			_g_free0 (uri);
#line 239 "AccountCreateWidget.c"
			goto __catch76_g_error;
		}
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_free0 (uri);
#line 244 "AccountCreateWidget.c"
	}
	goto __finally76;
	__catch76_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gboolean _tmp15_ = FALSE;
		GError* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		e = _inner_error_;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp11_ = e;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp12_ = _tmp11_->message;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) (-1));
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp14_ = _tmp13_;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp15_ = g_strcmp0 (_tmp14_, "unauthorized") == 0;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_free0 (_tmp14_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		if (_tmp15_) {
#line 275 "AccountCreateWidget.c"
			const gchar* _tmp16_ = NULL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			_tmp16_ = _ ("Unauthorized. Most of the time, this means that there's something wron" \
"g with the Twitter servers and you should try again later");
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			utils_show_error_dialog (_tmp16_);
#line 281 "AccountCreateWidget.c"
		} else {
			GError* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			_tmp17_ = e;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			_tmp18_ = _tmp17_->message;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			utils_show_error_dialog (_tmp18_);
#line 291 "AccountCreateWidget.c"
		}
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp19_ = e;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp20_ = _tmp19_->message;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_critical ("AccountCreateWidget.vala:50: %s", _tmp20_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_error_free0 (e);
#line 301 "AccountCreateWidget.c"
	}
	__finally76:
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	if (_inner_error_ != NULL) {
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_clear_error (&_inner_error_);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		return;
#line 312 "AccountCreateWidget.c"
	}
}


static Block46Data* block46_data_ref (Block46Data* _data46_) {
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_atomic_int_inc (&_data46_->_ref_count_);
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	return _data46_;
#line 322 "AccountCreateWidget.c"
}


static void block46_data_unref (void * _userdata_) {
	Block46Data* _data46_;
	_data46_ = (Block46Data*) _userdata_;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	if (g_atomic_int_dec_and_test (&_data46_->_ref_count_)) {
#line 331 "AccountCreateWidget.c"
		AccountCreateWidget * self;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		self = _data46_->self;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_object_unref0 (_data46_->call);
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_object_unref0 (self);
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_slice_free (Block46Data, _data46_);
#line 341 "AccountCreateWidget.c"
	}
}


static gpointer _json_object_ref0 (gpointer self) {
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	return self ? json_object_ref (self) : NULL;
#line 349 "AccountCreateWidget.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 356 "AccountCreateWidget.c"
}


static void __lambda170_ (AccountCreateWidget* self, GObject* obj, GAsyncResult* res) {
	Account* _tmp0_ = NULL;
	GAsyncResult* _tmp1_ = NULL;
	Account* _tmp2_ = NULL;
	Account* _tmp3_ = NULL;
	Account* _tmp4_ = NULL;
	SqlDatabase* _tmp5_ = NULL;
	SqlDatabase* _tmp6_ = NULL;
	SqlInsertStatement* _tmp7_ = NULL;
	SqlInsertStatement* _tmp8_ = NULL;
	Account* _tmp9_ = NULL;
	OAuthProxy* _tmp10_ = NULL;
	OAuthProxy* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	SqlInsertStatement* _tmp14_ = NULL;
	SqlInsertStatement* _tmp15_ = NULL;
	Account* _tmp16_ = NULL;
	OAuthProxy* _tmp17_ = NULL;
	OAuthProxy* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	SqlInsertStatement* _tmp21_ = NULL;
	SqlInsertStatement* _tmp22_ = NULL;
	Account* _tmp23_ = NULL;
	GtkSpinner* _tmp24_ = NULL;
	Account* _tmp25_ = NULL;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 95 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp0_ = self->priv->acc;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp1_ = res;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_query_user_info_by_scren_name_finish (_tmp0_, _tmp1_);
#line 96 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_message ("AccountCreateWidget.vala:96: user info call");
#line 97 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp2_ = self->priv->acc;
#line 97 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_init_database (_tmp2_);
#line 98 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp3_ = self->priv->acc;
#line 98 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_save_info (_tmp3_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp4_ = self->priv->acc;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp5_ = account_get_db (_tmp4_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp6_ = _tmp5_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp7_ = sql_database_insert (_tmp6_, "common");
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp8_ = _tmp7_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp9_ = self->priv->acc;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp10_ = account_get_proxy (_tmp9_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp11_ = _tmp10_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp12_ = oauth_proxy_get_token (_tmp11_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp13_ = _tmp12_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp14_ = sql_insert_statement_val (_tmp8_, "token", _tmp13_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp15_ = _tmp14_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp16_ = self->priv->acc;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp17_ = account_get_proxy (_tmp16_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp18_ = _tmp17_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp19_ = oauth_proxy_get_token_secret (_tmp18_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp20_ = _tmp19_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp21_ = sql_insert_statement_val (_tmp15_, "token_secret", _tmp20_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp22_ = _tmp21_;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	sql_insert_statement_run (_tmp22_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_sql_insert_statement_unref0 (_tmp22_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_sql_insert_statement_unref0 (_tmp15_);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_sql_insert_statement_unref0 (_tmp8_);
#line 103 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp23_ = self->priv->acc;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_init_proxy (_tmp23_, TRUE, TRUE);
#line 105 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp24_ = self->priv->progress_spinner;
#line 105 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GTK_TYPE_WIDGET, GtkWidget));
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp25_ = self->priv->acc;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_signal_emit_by_name (self, "result-received", TRUE, _tmp25_);
#line 465 "AccountCreateWidget.c"
}


static void ___lambda170__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	__lambda170_ (self, source_object, res);
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_object_unref (self);
#line 474 "AccountCreateWidget.c"
}


static void __lambda169_ (Block46Data* _data46_, GObject* obj, GAsyncResult* res) {
	AccountCreateWidget * self;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_ = NULL;
	JsonObject* root = NULL;
	JsonNode* _tmp7_ = NULL;
	JsonObject* _tmp8_ = NULL;
	JsonObject* _tmp9_ = NULL;
	gchar* screen_name = NULL;
	JsonObject* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	GSList* current_accounts = NULL;
	GSList* _tmp14_ = NULL;
	GSList* _tmp15_ = NULL;
	Account* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	GError * _inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	self = _data46_->self;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_message ("AccountCreateWidget.vala:75: settings call");
#line 76 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp0_ = json_parser_new ();
#line 76 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	parser = _tmp0_;
#line 509 "AccountCreateWidget.c"
	{
		RestProxyCall* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp1_ = _data46_->call;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp2_ = rest_proxy_call_get_payload (_tmp1_);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		json_parser_load_from_data (parser, _tmp2_, (gssize) (-1), &_inner_error_);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		if (_inner_error_ != NULL) {
#line 521 "AccountCreateWidget.c"
			goto __catch78_g_error;
		}
	}
	goto __finally78;
	__catch78_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		RestProxyCall* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		e = _inner_error_;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_inner_error_ = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp3_ = e;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp4_ = _tmp3_->message;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp5_ = _data46_->call;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp6_ = rest_proxy_call_get_payload (_tmp5_);
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_critical ("AccountCreateWidget.vala:80: Problem with JSON Data: %s\n%s", _tmp4_, _tmp6_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_error_free0 (e);
#line 549 "AccountCreateWidget.c"
	}
	__finally78:
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	if (_inner_error_ != NULL) {
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_object_unref0 (parser);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		return;
#line 562 "AccountCreateWidget.c"
	}
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp7_ = json_parser_get_root (parser);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp8_ = json_node_get_object (_tmp7_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp9_ = _json_object_ref0 (_tmp8_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	root = _tmp9_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp10_ = root;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp11_ = json_object_get_string_member (_tmp10_, "screen_name");
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	screen_name = _tmp12_;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp13_ = screen_name;
#line 84 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_message ("AccountCreateWidget.vala:84: Checking for %s", _tmp13_);
#line 85 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp14_ = account_list_accounts ();
#line 85 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	current_accounts = _tmp14_;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp15_ = current_accounts;
#line 590 "AccountCreateWidget.c"
	{
		GSList* a_collection = NULL;
		GSList* a_it = NULL;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		a_collection = _tmp15_;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		for (a_it = a_collection; a_it != NULL; a_it = a_it->next) {
#line 598 "AccountCreateWidget.c"
			Account* _tmp16_ = NULL;
			Account* a = NULL;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			_tmp16_ = _g_object_ref0 ((Account*) a_it->data);
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
			a = _tmp16_;
#line 605 "AccountCreateWidget.c"
			{
				Account* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
				const gchar* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
				_tmp17_ = a;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
				_tmp18_ = account_get_screen_name (_tmp17_);
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
				_tmp19_ = _tmp18_;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
				_tmp20_ = screen_name;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
				if (g_strcmp0 (_tmp19_, _tmp20_) == 0) {
#line 621 "AccountCreateWidget.c"
					Account* _tmp21_ = NULL;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					_tmp21_ = a;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					g_signal_emit_by_name (self, "result-received", FALSE, _tmp21_);
#line 89 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					g_critical ("AccountCreateWidget.vala:89: Account is already in use");
#line 90 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					_g_object_unref0 (a);
#line 90 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					_g_free0 (screen_name);
#line 90 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					_json_object_unref0 (root);
#line 90 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					_g_object_unref0 (parser);
#line 90 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
					return;
#line 639 "AccountCreateWidget.c"
				}
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
				_g_object_unref0 (a);
#line 643 "AccountCreateWidget.c"
			}
		}
	}
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp22_ = self->priv->acc;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp23_ = screen_name;
#line 94 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_query_user_info_by_scren_name (_tmp22_, _tmp23_, ___lambda170__gasync_ready_callback, g_object_ref (self));
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_g_free0 (screen_name);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_json_object_unref0 (root);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_g_object_unref0 (parser);
#line 659 "AccountCreateWidget.c"
}


static void ___lambda169__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	__lambda169_ (self, source_object, res);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	block46_data_unref (self);
#line 668 "AccountCreateWidget.c"
}


static void account_create_widget_confirm_button_clicked (AccountCreateWidget* self) {
	Block46Data* _data46_;
	GtkSpinner* _tmp0_ = NULL;
	GtkSpinner* _tmp1_ = NULL;
	Account* _tmp13_ = NULL;
	OAuthProxy* _tmp14_ = NULL;
	OAuthProxy* _tmp15_ = NULL;
	RestProxyCall* _tmp16_ = NULL;
	RestProxyCall* _tmp17_ = NULL;
	RestProxyCall* _tmp18_ = NULL;
	RestProxyCall* _tmp19_ = NULL;
	GError * _inner_error_ = NULL;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail (IS_ACCOUNT_CREATE_WIDGET (self));
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_data46_ = g_slice_new0 (Block46Data);
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_data46_->_ref_count_ = 1;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_data46_->self = g_object_ref (self);
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp0_ = self->priv->progress_spinner;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WIDGET, GtkWidget));
#line 57 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp1_ = self->priv->progress_spinner;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_spinner_start (_tmp1_);
#line 700 "AccountCreateWidget.c"
	{
		Account* _tmp2_ = NULL;
		OAuthProxy* _tmp3_ = NULL;
		OAuthProxy* _tmp4_ = NULL;
		GtkEntry* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp2_ = self->priv->acc;
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp3_ = account_get_proxy (_tmp2_);
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp4_ = _tmp3_;
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp5_ = self->priv->pin_entry;
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		oauth_proxy_access_token (_tmp4_, "oauth/access_token", _tmp6_, &_inner_error_);
#line 59 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		if (_inner_error_ != NULL) {
#line 721 "AccountCreateWidget.c"
			goto __catch77_g_error;
		}
	}
	goto __finally77;
	__catch77_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GtkSpinner* _tmp9_ = NULL;
		GtkLabel* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		GtkInfoBar* _tmp12_ = NULL;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		e = _inner_error_;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_inner_error_ = NULL;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp7_ = e;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp8_ = _tmp7_->message;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_critical ("AccountCreateWidget.vala:61: %s", _tmp8_);
#line 63 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp9_ = self->priv->progress_spinner;
#line 63 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GTK_TYPE_WIDGET, GtkWidget));
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp10_ = self->priv->error_label;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp11_ = _ ("Wrong PIN");
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		gtk_label_set_label (_tmp10_, _tmp11_);
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_tmp12_ = self->priv->error_bar;
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GTK_TYPE_WIDGET, GtkWidget));
#line 66 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_g_error_free0 (e);
#line 66 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		block46_data_unref (_data46_);
#line 66 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_data46_ = NULL;
#line 66 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		return;
#line 767 "AccountCreateWidget.c"
	}
	__finally77:
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	if (_inner_error_ != NULL) {
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		block46_data_unref (_data46_);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		_data46_ = NULL;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		g_clear_error (&_inner_error_);
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		return;
#line 782 "AccountCreateWidget.c"
	}
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp13_ = self->priv->acc;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp14_ = account_get_proxy (_tmp13_);
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp15_ = _tmp14_;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp16_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, rest_proxy_get_type (), RestProxy));
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_data46_->call = _tmp16_;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp17_ = _data46_->call;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	rest_proxy_call_set_function (_tmp17_, "1.1/account/settings.json");
#line 73 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp18_ = _data46_->call;
#line 73 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	rest_proxy_call_set_method (_tmp18_, "GET");
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_tmp19_ = _data46_->call;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	rest_proxy_call_invoke_async (_tmp19_, NULL, ___lambda169__gasync_ready_callback, block46_data_ref (_data46_));
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	block46_data_unref (_data46_);
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_data46_ = NULL;
#line 810 "AccountCreateWidget.c"
}


static void _account_create_widget_confirm_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_create_widget_confirm_button_clicked (self);
#line 817 "AccountCreateWidget.c"
}


static void g_cclosure_user_marshal_VOID__BOOLEAN_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOOLEAN_OBJECT) (gpointer data1, gboolean arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_return_if_fail (n_param_values == 3);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		data1 = closure->data;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		data2 = param_values->data[0].v_pointer;
#line 836 "AccountCreateWidget.c"
	} else {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		data1 = param_values->data[0].v_pointer;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
		data2 = closure->data;
#line 842 "AccountCreateWidget.c"
	}
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 848 "AccountCreateWidget.c"
}


static void account_create_widget_class_init (AccountCreateWidgetClass * klass) {
	gint AccountCreateWidget_private_offset;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	account_create_widget_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_type_class_add_private (klass, sizeof (AccountCreateWidgetPrivate));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = account_create_widget_finalize;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	AccountCreateWidget_private_offset = g_type_class_get_instance_private_offset (klass);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/account-create-widget.ui");
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	g_signal_new ("result_received", TYPE_ACCOUNT_CREATE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_OBJECT, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, TYPE_ACCOUNT);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pin_entry", FALSE, AccountCreateWidget_private_offset + G_STRUCT_OFFSET (AccountCreateWidgetPrivate, pin_entry));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "progress_spinner", FALSE, AccountCreateWidget_private_offset + G_STRUCT_OFFSET (AccountCreateWidgetPrivate, progress_spinner));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_label", FALSE, AccountCreateWidget_private_offset + G_STRUCT_OFFSET (AccountCreateWidgetPrivate, error_label));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_bar", FALSE, AccountCreateWidget_private_offset + G_STRUCT_OFFSET (AccountCreateWidgetPrivate, error_bar));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "confirm_button_clicked", G_CALLBACK(_account_create_widget_confirm_button_clicked_gtk_button_clicked));
#line 876 "AccountCreateWidget.c"
}


static void account_create_widget_instance_init (AccountCreateWidget * self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	self->priv = ACCOUNT_CREATE_WIDGET_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 885 "AccountCreateWidget.c"
}


static void account_create_widget_finalize (GObject* obj) {
	AccountCreateWidget * self;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACCOUNT_CREATE_WIDGET, AccountCreateWidget);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_g_object_unref0 (self->priv->pin_entry);
#line 26 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_g_object_unref0 (self->priv->progress_spinner);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_g_object_unref0 (self->priv->error_label);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	_g_object_unref0 (self->priv->error_bar);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/AccountCreateWidget.vala"
	G_OBJECT_CLASS (account_create_widget_parent_class)->finalize (obj);
#line 903 "AccountCreateWidget.c"
}


GType account_create_widget_get_type (void) {
	static volatile gsize account_create_widget_type_id__volatile = 0;
	if (g_once_init_enter (&account_create_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountCreateWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) account_create_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountCreateWidget), 0, (GInstanceInitFunc) account_create_widget_instance_init, NULL };
		GType account_create_widget_type_id;
		account_create_widget_type_id = g_type_register_static (GTK_TYPE_BOX, "AccountCreateWidget", &g_define_type_info, 0);
		g_once_init_leave (&account_create_widget_type_id__volatile, account_create_widget_type_id);
	}
	return account_create_widget_type_id__volatile;
}



