/* ImageOverlay.c generated by valac 0.22.1, the Vala compiler
 * generated from ImageOverlay.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_IMAGE_OVERLAY (image_overlay_get_type ())
#define IMAGE_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_OVERLAY, ImageOverlay))
#define IMAGE_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_OVERLAY, ImageOverlayClass))
#define IS_IMAGE_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_OVERLAY))
#define IS_IMAGE_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_OVERLAY))
#define IMAGE_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_OVERLAY, ImageOverlayClass))

typedef struct _ImageOverlay ImageOverlay;
typedef struct _ImageOverlayClass ImageOverlayClass;
typedef struct _ImageOverlayPrivate ImageOverlayPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ImageOverlay {
	GtkImage parent_instance;
	ImageOverlayPrivate * priv;
};

struct _ImageOverlayClass {
	GtkImageClass parent_class;
};

struct _ImageOverlayPrivate {
	GdkPixbuf* _overlay_image;
};


static gpointer image_overlay_parent_class = NULL;

GType image_overlay_get_type (void) G_GNUC_CONST;
#define IMAGE_OVERLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMAGE_OVERLAY, ImageOverlayPrivate))
enum  {
	IMAGE_OVERLAY_DUMMY_PROPERTY,
	IMAGE_OVERLAY_OVERLAY_IMAGE
};
ImageOverlay* image_overlay_new (void);
ImageOverlay* image_overlay_construct (GType object_type);
static gboolean image_overlay_real_draw (GtkWidget* base, cairo_t* c);
GdkPixbuf* image_overlay_get_overlay_image (ImageOverlay* self);
static void image_overlay_real_get_preferred_width (GtkWidget* base, gint* minimum, gint* natural);
static void image_overlay_real_get_preferred_height (GtkWidget* base, gint* minimum, gint* natural);
void image_overlay_set_overlay_image (ImageOverlay* self, GdkPixbuf* value);
static void image_overlay_finalize (GObject* obj);
static void _vala_image_overlay_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_image_overlay_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ImageOverlay* image_overlay_construct (GType object_type) {
	ImageOverlay * self = NULL;
	GtkStyleContext* _tmp0_ = NULL;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self = (ImageOverlay*) g_object_new (object_type, NULL);
#line 25 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 25 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	gtk_style_context_add_class (_tmp0_, "image-overlay");
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	return self;
#line 88 "ImageOverlay.c"
}


ImageOverlay* image_overlay_new (void) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	return image_overlay_construct (TYPE_IMAGE_OVERLAY);
#line 95 "ImageOverlay.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	return self ? g_object_ref (self) : NULL;
#line 102 "ImageOverlay.c"
}


static gboolean image_overlay_real_draw (GtkWidget* base, cairo_t* c) {
	ImageOverlay * self;
	gboolean result = FALSE;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_ = NULL;
	GtkStyleContext* _tmp1_ = NULL;
	GtkBorder padding = {0};
	GtkStyleContext* _tmp2_ = NULL;
	GtkStateFlags _tmp3_ = 0;
	GtkBorder _tmp4_ = {0};
	cairo_t* _tmp5_ = NULL;
	GtkBorder _tmp6_ = {0};
	gint16 _tmp7_ = 0;
	cairo_t* _tmp8_ = NULL;
	GdkPixbuf* _tmp9_ = NULL;
#line 30 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_OVERLAY, ImageOverlay);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	style_context = _tmp1_;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp2_ = style_context;
#line 32 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp3_ = gtk_widget_get_state_flags (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 32 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	gtk_style_context_get_padding (_tmp2_, _tmp3_, &_tmp4_);
#line 32 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	padding = _tmp4_;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp5_ = c;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp6_ = padding;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp7_ = _tmp6_.top;
#line 33 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	cairo_translate (_tmp5_, (gdouble) 0, (gdouble) _tmp7_);
#line 34 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp8_ = c;
#line 34 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	GTK_WIDGET_CLASS (image_overlay_parent_class)->draw (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_IMAGE, GtkImage), GTK_TYPE_WIDGET, GtkWidget), _tmp8_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp9_ = self->priv->_overlay_image;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	if (_tmp9_ != NULL) {
#line 155 "ImageOverlay.c"
		GtkStyleContext* _tmp10_ = NULL;
		cairo_t* _tmp11_ = NULL;
		GdkPixbuf* _tmp12_ = NULL;
		gint _tmp13_ = 0;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		_tmp10_ = style_context;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		_tmp11_ = c;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		_tmp12_ = self->priv->_overlay_image;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		_tmp13_ = gtk_widget_get_allocated_width (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		gtk_render_icon (_tmp10_, _tmp11_, _tmp12_, (gdouble) (_tmp13_ - 16), (gdouble) 0);
#line 170 "ImageOverlay.c"
	}
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	result = FALSE;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_g_object_unref0 (style_context);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	return result;
#line 178 "ImageOverlay.c"
}


static void image_overlay_real_get_preferred_width (GtkWidget* base, gint* minimum, gint* natural) {
	ImageOverlay * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint m = 0;
	gint n = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GtkBorder padding = {0};
	GtkStyleContext* _tmp2_ = NULL;
	GtkStateFlags _tmp3_ = 0;
	GtkBorder _tmp4_ = {0};
	GtkBorder _tmp5_ = {0};
	gint16 _tmp6_ = 0;
	GtkBorder _tmp7_ = {0};
	gint16 _tmp8_ = 0;
	GtkBorder _tmp9_ = {0};
	gint16 _tmp10_ = 0;
	GtkBorder _tmp11_ = {0};
	gint16 _tmp12_ = 0;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_OVERLAY, ImageOverlay);
#line 45 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	GTK_WIDGET_CLASS (image_overlay_parent_class)->get_preferred_width (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_IMAGE, GtkImage), GTK_TYPE_WIDGET, GtkWidget), &_tmp0_, &_tmp1_);
#line 45 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	m = _tmp0_;
#line 45 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	n = _tmp1_;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp3_ = gtk_widget_get_state_flags (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	gtk_style_context_get_padding (_tmp2_, _tmp3_, &_tmp4_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	padding = _tmp4_;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp5_ = padding;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp6_ = _tmp5_.left;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp7_ = padding;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp8_ = _tmp7_.right;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_vala_minimum = (m + _tmp6_) + _tmp8_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp9_ = padding;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp10_ = _tmp9_.left;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp11_ = padding;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp12_ = _tmp11_.right;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_vala_natural = (n + _tmp10_) + _tmp12_;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	if (minimum) {
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		*minimum = _vala_minimum;
#line 242 "ImageOverlay.c"
	}
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	if (natural) {
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		*natural = _vala_natural;
#line 248 "ImageOverlay.c"
	}
}


static void image_overlay_real_get_preferred_height (GtkWidget* base, gint* minimum, gint* natural) {
	ImageOverlay * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint m = 0;
	gint n = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GtkBorder padding = {0};
	GtkStyleContext* _tmp2_ = NULL;
	GtkStateFlags _tmp3_ = 0;
	GtkBorder _tmp4_ = {0};
	GtkBorder _tmp5_ = {0};
	gint16 _tmp6_ = 0;
	GtkBorder _tmp7_ = {0};
	gint16 _tmp8_ = 0;
	GtkBorder _tmp9_ = {0};
	gint16 _tmp10_ = 0;
	GtkBorder _tmp11_ = {0};
	gint16 _tmp12_ = 0;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_OVERLAY, ImageOverlay);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	GTK_WIDGET_CLASS (image_overlay_parent_class)->get_preferred_height (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_IMAGE, GtkImage), GTK_TYPE_WIDGET, GtkWidget), &_tmp0_, &_tmp1_);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	m = _tmp0_;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	n = _tmp1_;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 54 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp3_ = gtk_widget_get_state_flags (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 54 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	gtk_style_context_get_padding (_tmp2_, _tmp3_, &_tmp4_);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	padding = _tmp4_;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp5_ = padding;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp6_ = _tmp5_.top;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp7_ = padding;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp8_ = _tmp7_.bottom;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_vala_minimum = (m + _tmp6_) + _tmp8_;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp9_ = padding;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp10_ = _tmp9_.top;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp11_ = padding;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp12_ = _tmp11_.bottom;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_vala_natural = (n + _tmp10_) + _tmp12_;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	if (minimum) {
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		*minimum = _vala_minimum;
#line 313 "ImageOverlay.c"
	}
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	if (natural) {
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		*natural = _vala_natural;
#line 319 "ImageOverlay.c"
	}
}


GdkPixbuf* image_overlay_get_overlay_image (ImageOverlay* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	g_return_val_if_fail (IS_IMAGE_OVERLAY (self), NULL);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp0_ = self->priv->_overlay_image;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	return result;
#line 335 "ImageOverlay.c"
}


void image_overlay_set_overlay_image (ImageOverlay* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	g_return_if_fail (IS_IMAGE_OVERLAY (self));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp0_ = value;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_g_object_unref0 (self->priv->_overlay_image);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self->priv->_overlay_image = _tmp1_;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	g_object_notify ((GObject *) self, "overlay-image");
#line 354 "ImageOverlay.c"
}


static void image_overlay_class_init (ImageOverlayClass * klass) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	image_overlay_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	g_type_class_add_private (klass, sizeof (ImageOverlayPrivate));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	GTK_WIDGET_CLASS (klass)->draw = image_overlay_real_draw;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	GTK_WIDGET_CLASS (klass)->get_preferred_width = image_overlay_real_get_preferred_width;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	GTK_WIDGET_CLASS (klass)->get_preferred_height = image_overlay_real_get_preferred_height;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_image_overlay_get_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_image_overlay_set_property;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	G_OBJECT_CLASS (klass)->finalize = image_overlay_finalize;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGE_OVERLAY_OVERLAY_IMAGE, g_param_spec_object ("overlay-image", "overlay-image", "overlay-image", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 377 "ImageOverlay.c"
}


static void image_overlay_instance_init (ImageOverlay * self) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self->priv = IMAGE_OVERLAY_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self->priv->_overlay_image = NULL;
#line 386 "ImageOverlay.c"
}


static void image_overlay_finalize (GObject* obj) {
	ImageOverlay * self;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_OVERLAY, ImageOverlay);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	_g_object_unref0 (self->priv->_overlay_image);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	G_OBJECT_CLASS (image_overlay_parent_class)->finalize (obj);
#line 398 "ImageOverlay.c"
}


GType image_overlay_get_type (void) {
	static volatile gsize image_overlay_type_id__volatile = 0;
	if (g_once_init_enter (&image_overlay_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageOverlayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_overlay_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageOverlay), 0, (GInstanceInitFunc) image_overlay_instance_init, NULL };
		GType image_overlay_type_id;
		image_overlay_type_id = g_type_register_static (GTK_TYPE_IMAGE, "ImageOverlay", &g_define_type_info, 0);
		g_once_init_leave (&image_overlay_type_id__volatile, image_overlay_type_id);
	}
	return image_overlay_type_id__volatile;
}


static void _vala_image_overlay_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ImageOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMAGE_OVERLAY, ImageOverlay);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		case IMAGE_OVERLAY_OVERLAY_IMAGE:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		g_value_set_object (value, image_overlay_get_overlay_image (self));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		break;
#line 425 "ImageOverlay.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		break;
#line 431 "ImageOverlay.c"
	}
}


static void _vala_image_overlay_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ImageOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMAGE_OVERLAY, ImageOverlay);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		case IMAGE_OVERLAY_OVERLAY_IMAGE:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		image_overlay_set_overlay_image (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		break;
#line 447 "ImageOverlay.c"
		default:
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/ImageOverlay.vala"
		break;
#line 453 "ImageOverlay.c"
	}
}



