/* ScrollWidget.c generated by valac 0.22.1, the Vala compiler
 * generated from ScrollWidget.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define TYPE_SCROLL_WIDGET (scroll_widget_get_type ())
#define SCROLL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCROLL_WIDGET, ScrollWidget))
#define SCROLL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCROLL_WIDGET, ScrollWidgetClass))
#define IS_SCROLL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCROLL_WIDGET))
#define IS_SCROLL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCROLL_WIDGET))
#define SCROLL_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCROLL_WIDGET, ScrollWidgetClass))

typedef struct _ScrollWidget ScrollWidget;
typedef struct _ScrollWidgetClass ScrollWidgetClass;
typedef struct _ScrollWidgetPrivate ScrollWidgetPrivate;
typedef struct _Block44Data Block44Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block45Data Block45Data;

struct _ScrollWidget {
	GtkScrolledWindow parent_instance;
	ScrollWidgetPrivate * priv;
};

struct _ScrollWidgetClass {
	GtkScrolledWindowClass parent_class;
};

struct _ScrollWidgetPrivate {
	gdouble upper_cache;
	gdouble value_cache;
	gint balance;
	gdouble _end_diff;
	gulong scroll_down_id;
	gulong scroll_up_id;
	gint64 start_time;
	gint64 end_time;
	gdouble transition_diff;
	gdouble transition_start_value;
};

struct _Block44Data {
	int _ref_count_;
	ScrollWidget * self;
	gboolean animate;
};

struct _Block45Data {
	int _ref_count_;
	ScrollWidget * self;
	gboolean animate;
};


static gpointer scroll_widget_parent_class = NULL;

#define TOP 1
#define BOTTOM 2
#define NONE 0
GType scroll_widget_get_type (void) G_GNUC_CONST;
#define SCROLL_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SCROLL_WIDGET, ScrollWidgetPrivate))
enum  {
	SCROLL_WIDGET_DUMMY_PROPERTY,
	SCROLL_WIDGET_END_DIFF,
	SCROLL_WIDGET_SCROLLED_DOWN,
	SCROLL_WIDGET_SCROLLED_UP
};
#define SCROLL_WIDGET_TRANSITION_DURATION ((gint64) 300)
static void scroll_widget_keep_upper_func (ScrollWidget* self);
static void scroll_widget_keep_value_func (ScrollWidget* self);
gdouble scroll_widget_get_end_diff (ScrollWidget* self);
void scroll_widget_balance_next_upper_change (ScrollWidget* self, gint mode);
void scroll_widget_scroll_up_next (ScrollWidget* self, gboolean animate, gboolean force_wait, gboolean force_start);
static Block44Data* block44_data_ref (Block44Data* _data44_);
static void block44_data_unref (void * _userdata_);
static gboolean scroll_widget_scroll_up_tick_cb (ScrollWidget* self, GtkWidget* widget, GdkFrameClock* frame_clock);
static gboolean _scroll_widget_scroll_up_tick_cb_gtk_tick_callback (GtkWidget* widget, GdkFrameClock* frame_clock, gpointer self);
static void ___lambda50_ (Block44Data* _data44_);
static void ____lambda50__gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
void scroll_widget_scroll_down_next (ScrollWidget* self, gboolean animate, gboolean force_wait);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
static void __lambda51_ (Block45Data* _data45_);
static void ___lambda51__gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
static gdouble scroll_widget_ease_out_cubic (ScrollWidget* self, gdouble t);
ScrollWidget* scroll_widget_new (void);
ScrollWidget* scroll_widget_construct (GType object_type);
void scroll_widget_set_end_diff (ScrollWidget* self, gdouble value);
gboolean scroll_widget_get_scrolled_down (ScrollWidget* self);
gboolean scroll_widget_get_scrolled_up (ScrollWidget* self);
static GObject * scroll_widget_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _scroll_widget_keep_upper_func_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _scroll_widget_keep_value_func_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void scroll_widget_finalize (GObject* obj);
static void _vala_scroll_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_scroll_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void scroll_widget_keep_upper_func (ScrollWidget* self) {
	gdouble upper = 0.0;
	GtkAdjustment* _tmp0_ = NULL;
	GtkAdjustment* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	GtkAdjustment* _tmp16_ = NULL;
	GtkAdjustment* _tmp17_ = NULL;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	GtkAdjustment* _tmp20_ = NULL;
	GtkAdjustment* _tmp21_ = NULL;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_if_fail (IS_SCROLL_WIDGET (self));
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_upper (_tmp1_);
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 56 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	upper = _tmp3_;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp4_ = self->priv->balance;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp4_ == TOP) {
#line 154 "ScrollWidget.c"
		gdouble inc = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		GtkAdjustment* _tmp7_ = NULL;
		GtkAdjustment* _tmp8_ = NULL;
		GtkAdjustment* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		GtkAdjustment* _tmp14_ = NULL;
		GtkAdjustment* _tmp15_ = NULL;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp5_ = upper;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp6_ = self->priv->upper_cache;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		inc = _tmp5_ - _tmp6_;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp7_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp8_ = _tmp7_;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_adjustment_get_value (_tmp10_);
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp12_ = _tmp11_;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp13_ = inc;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp10_, _tmp12_ + _tmp13_);
#line 61 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp14_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 61 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp15_ = _tmp14_;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_value_changed (_tmp15_);
#line 62 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->balance = NONE;
#line 197 "ScrollWidget.c"
	}
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp16_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp17_ = _tmp16_;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp18_ = gtk_adjustment_get_upper (_tmp17_);
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp19_ = _tmp18_;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->upper_cache = _tmp19_;
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp20_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp21_ = _tmp20_;
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp22_ = gtk_adjustment_get_value (_tmp21_);
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp23_ = _tmp22_;
#line 65 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->value_cache = _tmp23_;
#line 219 "ScrollWidget.c"
}


static void scroll_widget_keep_value_func (ScrollWidget* self) {
	GtkAdjustment* _tmp0_ = NULL;
	GtkAdjustment* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble max = 0.0;
	GtkAdjustment* _tmp8_ = NULL;
	GtkAdjustment* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	GtkAdjustment* _tmp12_ = NULL;
	GtkAdjustment* _tmp13_ = NULL;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	GtkAdjustment* _tmp16_ = NULL;
	GtkAdjustment* _tmp17_ = NULL;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp22_ = NULL;
	GtkAdjustment* _tmp23_ = NULL;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gint _tmp26_ = 0;
	GtkAdjustment* _tmp38_ = NULL;
	GtkAdjustment* _tmp39_ = NULL;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_ = 0.0;
	GtkAdjustment* _tmp42_ = NULL;
	GtkAdjustment* _tmp43_ = NULL;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
#line 68 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_if_fail (IS_SCROLL_WIDGET (self));
#line 70 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 70 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
#line 70 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 70 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp3_ < 10.0) {
#line 269 "ScrollWidget.c"
		GtkAdjustment* _tmp4_ = NULL;
		GtkAdjustment* _tmp5_ = NULL;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp4_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp5_ = _tmp4_;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp6_ = gtk_adjustment_get_value (_tmp5_);
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp7_ = _tmp6_;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_signal_emit_by_name (self, "scrolled-to-start", _tmp7_);
#line 284 "ScrollWidget.c"
	}
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp8_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp9_ = _tmp8_;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp10_ = gtk_adjustment_get_upper (_tmp9_);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp11_ = _tmp10_;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp12_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp13_ = _tmp12_;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp14_ = gtk_adjustment_get_page_size (_tmp13_);
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp15_ = _tmp14_;
#line 74 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	max = _tmp11_ - _tmp15_;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp16_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp17_ = _tmp16_;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp18_ = gtk_adjustment_get_value (_tmp17_);
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp19_ = _tmp18_;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp20_ = max;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp21_ = self->priv->_end_diff;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp19_ >= (_tmp20_ - _tmp21_)) {
#line 76 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_signal_emit_by_name (self, "scrolled-to-end");
#line 320 "ScrollWidget.c"
	}
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp22_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp23_ = _tmp22_;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp24_ = gtk_adjustment_get_upper (_tmp23_);
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp25_ = _tmp24_;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	upper = _tmp25_;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp26_ = self->priv->balance;
#line 79 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp26_ == BOTTOM) {
#line 336 "ScrollWidget.c"
		gdouble inc = 0.0;
		gdouble _tmp27_ = 0.0;
		gdouble _tmp28_ = 0.0;
		GtkAdjustment* _tmp29_ = NULL;
		GtkAdjustment* _tmp30_ = NULL;
		GtkAdjustment* _tmp31_ = NULL;
		GtkAdjustment* _tmp32_ = NULL;
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_ = 0.0;
		GtkAdjustment* _tmp36_ = NULL;
		GtkAdjustment* _tmp37_ = NULL;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp27_ = upper;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp28_ = self->priv->upper_cache;
#line 80 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		inc = _tmp27_ - _tmp28_;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp29_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp30_ = _tmp29_;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp31_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp32_ = _tmp31_;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp33_ = gtk_adjustment_get_value (_tmp32_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp34_ = _tmp33_;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp35_ = inc;
#line 82 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp32_, _tmp34_ - _tmp35_);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp36_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp37_ = _tmp36_;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_value_changed (_tmp37_);
#line 84 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->balance = NONE;
#line 379 "ScrollWidget.c"
	}
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp38_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp39_ = _tmp38_;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp40_ = gtk_adjustment_get_upper (_tmp39_);
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp41_ = _tmp40_;
#line 86 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->upper_cache = _tmp41_;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp42_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp43_ = _tmp42_;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp44_ = gtk_adjustment_get_value (_tmp43_);
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp45_ = _tmp44_;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->value_cache = _tmp45_;
#line 401 "ScrollWidget.c"
}


void scroll_widget_balance_next_upper_change (ScrollWidget* self, gint mode) {
	gint _tmp0_ = 0;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_if_fail (IS_SCROLL_WIDGET (self));
#line 91 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = mode;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->balance = _tmp0_;
#line 413 "ScrollWidget.c"
}


/**
   * TODO: Update scroll_down_next
   * Scroll to the very top of the scrolled window once the next
   * size_allocate occurs.
   * This will use a transition if the correct Gtk+ settings is set
   * to true.
   *
   * @param animate    Whether to animate/transition the change or not (default: true)
   * @param force_wait If this is set to true, we will wait for the next size_allocate
   *                   event, even if the widget is unmapped (default: false).
   */
static Block44Data* block44_data_ref (Block44Data* _data44_) {
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_atomic_int_inc (&_data44_->_ref_count_);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return _data44_;
#line 433 "ScrollWidget.c"
}


static void block44_data_unref (void * _userdata_) {
	Block44Data* _data44_;
	_data44_ = (Block44Data*) _userdata_;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (g_atomic_int_dec_and_test (&_data44_->_ref_count_)) {
#line 442 "ScrollWidget.c"
		ScrollWidget * self;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self = _data44_->self;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_g_object_unref0 (self);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_slice_free (Block44Data, _data44_);
#line 450 "ScrollWidget.c"
	}
}


static gboolean _scroll_widget_scroll_up_tick_cb_gtk_tick_callback (GtkWidget* widget, GdkFrameClock* frame_clock, gpointer self) {
	gboolean result;
	result = scroll_widget_scroll_up_tick_cb (self, widget, frame_clock);
#line 121 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return result;
#line 460 "ScrollWidget.c"
}


static void ___lambda50_ (Block44Data* _data44_) {
	ScrollWidget * self;
	gboolean _tmp0_ = FALSE;
	GtkSettings* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gulong _tmp21_ = 0UL;
#line 132 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self = _data44_->self;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = gtk_settings_get_default ();
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_object_get (_tmp1_, "gtk-enable-animations", &_tmp2_, NULL);
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp3_) {
#line 482 "ScrollWidget.c"
		gboolean _tmp4_ = FALSE;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp4_ = _data44_->animate;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp0_ = _tmp4_;
#line 488 "ScrollWidget.c"
	} else {
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp0_ = FALSE;
#line 492 "ScrollWidget.c"
	}
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp5_ = _tmp0_;
#line 133 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp5_) {
#line 498 "ScrollWidget.c"
		GdkFrameClock* _tmp6_ = NULL;
		gint64 _tmp7_ = 0LL;
		gint64 _tmp8_ = 0LL;
		GtkAdjustment* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		GtkAdjustment* _tmp13_ = NULL;
		GtkAdjustment* _tmp14_ = NULL;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
#line 134 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp6_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 134 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp7_ = gdk_frame_clock_get_frame_time (_tmp6_);
#line 134 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->start_time = _tmp7_;
#line 135 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp8_ = self->priv->start_time;
#line 135 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->end_time = _tmp8_ + (SCROLL_WIDGET_TRANSITION_DURATION * 1000);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 136 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_adjustment_get_value (_tmp10_);
#line 136 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp12_ = _tmp11_;
#line 136 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->transition_diff = -_tmp12_;
#line 137 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp13_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 137 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp14_ = _tmp13_;
#line 137 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp15_ = gtk_adjustment_get_value (_tmp14_);
#line 137 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp16_ = _tmp15_;
#line 137 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->transition_start_value = _tmp16_;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 542 "ScrollWidget.c"
	} else {
		GtkAdjustment* _tmp17_ = NULL;
		GtkAdjustment* _tmp18_ = NULL;
		GtkAdjustment* _tmp19_ = NULL;
		GtkAdjustment* _tmp20_ = NULL;
#line 140 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp17_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 140 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp18_ = _tmp17_;
#line 140 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp18_, (gdouble) 0);
#line 141 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp19_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 141 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp20_ = _tmp19_;
#line 141 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_value_changed (_tmp20_);
#line 560 "ScrollWidget.c"
	}
#line 143 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp21_ = self->priv->scroll_up_id;
#line 143 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp21_);
#line 144 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->scroll_up_id = (gulong) 0;
#line 568 "ScrollWidget.c"
}


static void ____lambda50__gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
#line 132 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	___lambda50_ (self);
#line 575 "ScrollWidget.c"
}


void scroll_widget_scroll_up_next (ScrollWidget* self, gboolean animate, gboolean force_wait, gboolean force_start) {
	Block44Data* _data44_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp9_ = FALSE;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_if_fail (IS_SCROLL_WIDGET (self));
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data44_ = g_slice_new0 (Block44Data);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data44_->_ref_count_ = 1;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data44_->self = g_object_ref (self);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = animate;
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data44_->animate = _tmp0_;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_widget_get_mapped (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (!_tmp2_) {
#line 602 "ScrollWidget.c"
		gboolean _tmp3_ = FALSE;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp3_ = force_wait;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp1_ = !_tmp3_;
#line 608 "ScrollWidget.c"
	} else {
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp1_ = FALSE;
#line 612 "ScrollWidget.c"
	}
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp4_ = _tmp1_;
#line 108 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp4_) {
#line 618 "ScrollWidget.c"
		GtkAdjustment* _tmp5_ = NULL;
		GtkAdjustment* _tmp6_ = NULL;
		GtkAdjustment* _tmp7_ = NULL;
		GtkAdjustment* _tmp8_ = NULL;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp5_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 109 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp6_ = _tmp5_;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp6_, (gdouble) 0);
#line 110 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp7_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 110 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp8_ = _tmp7_;
#line 110 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_value_changed (_tmp8_);
#line 111 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		block44_data_unref (_data44_);
#line 111 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_data44_ = NULL;
#line 111 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		return;
#line 641 "ScrollWidget.c"
	}
#line 115 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp9_ = force_start;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp9_) {
#line 647 "ScrollWidget.c"
		gboolean _tmp10_ = FALSE;
		GtkSettings* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp15_ = FALSE;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_settings_get_default ();
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_object_get (_tmp11_, "gtk-enable-animations", &_tmp12_, NULL);
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp13_ = _tmp12_;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		if (_tmp13_) {
#line 661 "ScrollWidget.c"
			gboolean _tmp14_ = FALSE;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp14_ = _data44_->animate;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp10_ = _tmp14_;
#line 667 "ScrollWidget.c"
		} else {
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp10_ = FALSE;
#line 671 "ScrollWidget.c"
		}
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp15_ = _tmp10_;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		if (_tmp15_) {
#line 677 "ScrollWidget.c"
			GdkFrameClock* _tmp16_ = NULL;
			gint64 _tmp17_ = 0LL;
			gint64 _tmp18_ = 0LL;
			GtkAdjustment* _tmp19_ = NULL;
			GtkAdjustment* _tmp20_ = NULL;
			gdouble _tmp21_ = 0.0;
			gdouble _tmp22_ = 0.0;
			GtkAdjustment* _tmp23_ = NULL;
			GtkAdjustment* _tmp24_ = NULL;
			gdouble _tmp25_ = 0.0;
			gdouble _tmp26_ = 0.0;
#line 117 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp16_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 117 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp17_ = gdk_frame_clock_get_frame_time (_tmp16_);
#line 117 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			self->priv->start_time = _tmp17_;
#line 118 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp18_ = self->priv->start_time;
#line 118 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			self->priv->end_time = _tmp18_ + (SCROLL_WIDGET_TRANSITION_DURATION * 1000);
#line 119 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp19_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 119 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp20_ = _tmp19_;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp21_ = gtk_adjustment_get_value (_tmp20_);
#line 119 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp22_ = _tmp21_;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			self->priv->transition_diff = -_tmp22_;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp23_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 120 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp24_ = _tmp23_;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp25_ = gtk_adjustment_get_value (_tmp24_);
#line 120 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp26_ = _tmp25_;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			self->priv->transition_start_value = _tmp26_;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 721 "ScrollWidget.c"
		} else {
			GtkAdjustment* _tmp27_ = NULL;
			GtkAdjustment* _tmp28_ = NULL;
			GtkAdjustment* _tmp29_ = NULL;
			GtkAdjustment* _tmp30_ = NULL;
#line 123 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp27_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 123 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp28_ = _tmp27_;
#line 123 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			gtk_adjustment_set_value (_tmp28_, (gdouble) 0);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp29_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 124 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp30_ = _tmp29_;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			gtk_adjustment_value_changed (_tmp30_);
#line 739 "ScrollWidget.c"
		}
	} else {
		gulong _tmp31_ = 0UL;
		gulong _tmp40_ = 0UL;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp31_ = self->priv->scroll_up_id;
#line 127 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		if (_tmp31_ != ((gulong) 0)) {
#line 748 "ScrollWidget.c"
			GtkAdjustment* _tmp32_ = NULL;
			GtkAdjustment* _tmp33_ = NULL;
			gdouble _tmp34_ = 0.0;
			gdouble _tmp35_ = 0.0;
			GtkAdjustment* _tmp36_ = NULL;
			GtkAdjustment* _tmp37_ = NULL;
			gdouble _tmp38_ = 0.0;
			gdouble _tmp39_ = 0.0;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp32_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 128 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp33_ = _tmp32_;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp34_ = gtk_adjustment_get_value (_tmp33_);
#line 128 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp35_ = _tmp34_;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			self->priv->transition_diff = -_tmp35_;
#line 129 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp36_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 129 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp37_ = _tmp36_;
#line 129 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp38_ = gtk_adjustment_get_value (_tmp37_);
#line 129 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_tmp39_ = _tmp38_;
#line 129 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			self->priv->transition_start_value = _tmp39_;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			block44_data_unref (_data44_);
#line 130 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			_data44_ = NULL;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
			return;
#line 783 "ScrollWidget.c"
		}
#line 132 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp40_ = g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), "size-allocate", (GCallback) ____lambda50__gtk_widget_size_allocate, block44_data_ref (_data44_), (GClosureNotify) block44_data_unref, 0);
#line 132 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->scroll_up_id = _tmp40_;
#line 789 "ScrollWidget.c"
	}
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	block44_data_unref (_data44_);
#line 106 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data44_ = NULL;
#line 795 "ScrollWidget.c"
}


/**
   * Scroll to the very end of the scrolled window once the next
   * size_alocate occurs.
   * This will use a transition if the correct Gtk+ settings is set
   * to true
   *
   * @param animate Whether to animate/transition the change or not (default: true)
   * @param force_wait If this is set to true, we will wait for the next size_allocate
   *                   event, even if the widget is unmapped (default: false).
   */
static Block45Data* block45_data_ref (Block45Data* _data45_) {
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_atomic_int_inc (&_data45_->_ref_count_);
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return _data45_;
#line 814 "ScrollWidget.c"
}


static void block45_data_unref (void * _userdata_) {
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
#line 823 "ScrollWidget.c"
		ScrollWidget * self;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self = _data45_->self;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_g_object_unref0 (self);
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_slice_free (Block45Data, _data45_);
#line 831 "ScrollWidget.c"
	}
}


static void __lambda51_ (Block45Data* _data45_) {
	ScrollWidget * self;
	gboolean _tmp0_ = FALSE;
	GtkSettings* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gulong _tmp37_ = 0UL;
#line 166 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self = _data45_->self;
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = gtk_settings_get_default ();
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_object_get (_tmp1_, "gtk-enable-animations", &_tmp2_, NULL);
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp3_) {
#line 854 "ScrollWidget.c"
		gboolean _tmp4_ = FALSE;
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp4_ = _data45_->animate;
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp0_ = _tmp4_;
#line 860 "ScrollWidget.c"
	} else {
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp0_ = FALSE;
#line 864 "ScrollWidget.c"
	}
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp5_ = _tmp0_;
#line 167 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp5_) {
#line 870 "ScrollWidget.c"
		GdkFrameClock* _tmp6_ = NULL;
		gint64 _tmp7_ = 0LL;
		gint64 _tmp8_ = 0LL;
		GtkAdjustment* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		GtkAdjustment* _tmp13_ = NULL;
		GtkAdjustment* _tmp14_ = NULL;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		GtkAdjustment* _tmp17_ = NULL;
		GtkAdjustment* _tmp18_ = NULL;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		GtkAdjustment* _tmp21_ = NULL;
		GtkAdjustment* _tmp22_ = NULL;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
#line 168 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp6_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 168 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp7_ = gdk_frame_clock_get_frame_time (_tmp6_);
#line 168 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->start_time = _tmp7_;
#line 169 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp8_ = self->priv->start_time;
#line 169 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->end_time = _tmp8_ + (SCROLL_WIDGET_TRANSITION_DURATION * 1000);
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_adjustment_get_upper (_tmp10_);
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp12_ = _tmp11_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp13_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp14_ = _tmp13_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp15_ = gtk_adjustment_get_page_size (_tmp14_);
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp16_ = _tmp15_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp17_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp18_ = _tmp17_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp19_ = gtk_adjustment_get_value (_tmp18_);
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp20_ = _tmp19_;
#line 170 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->transition_diff = (_tmp12_ - _tmp16_) - _tmp20_;
#line 171 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp21_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 171 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp22_ = _tmp21_;
#line 171 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 171 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp24_ = _tmp23_;
#line 171 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		self->priv->transition_start_value = _tmp24_;
#line 172 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 938 "ScrollWidget.c"
	} else {
		GtkAdjustment* _tmp25_ = NULL;
		GtkAdjustment* _tmp26_ = NULL;
		GtkAdjustment* _tmp27_ = NULL;
		GtkAdjustment* _tmp28_ = NULL;
		gdouble _tmp29_ = 0.0;
		gdouble _tmp30_ = 0.0;
		GtkAdjustment* _tmp31_ = NULL;
		GtkAdjustment* _tmp32_ = NULL;
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		GtkAdjustment* _tmp35_ = NULL;
		GtkAdjustment* _tmp36_ = NULL;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp25_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp26_ = _tmp25_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp27_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp28_ = _tmp27_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp29_ = gtk_adjustment_get_upper (_tmp28_);
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp30_ = _tmp29_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp31_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp32_ = _tmp31_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp33_ = gtk_adjustment_get_page_size (_tmp32_);
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp34_ = _tmp33_;
#line 174 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp26_, _tmp30_ - _tmp34_);
#line 175 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp35_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 175 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp36_ = _tmp35_;
#line 175 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_value_changed (_tmp36_);
#line 980 "ScrollWidget.c"
	}
#line 177 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp37_ = self->priv->scroll_down_id;
#line 177 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp37_);
#line 986 "ScrollWidget.c"
}


static void ___lambda51__gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
#line 166 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	__lambda51_ (self);
#line 993 "ScrollWidget.c"
}


void scroll_widget_scroll_down_next (ScrollWidget* self, gboolean animate, gboolean force_wait) {
	Block45Data* _data45_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gulong _tmp17_ = 0UL;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_if_fail (IS_SCROLL_WIDGET (self));
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data45_ = g_slice_new0 (Block45Data);
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data45_->_ref_count_ = 1;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data45_->self = g_object_ref (self);
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = animate;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data45_->animate = _tmp0_;
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_widget_get_mapped (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (!_tmp2_) {
#line 1020 "ScrollWidget.c"
		gboolean _tmp3_ = FALSE;
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp3_ = force_wait;
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp1_ = !_tmp3_;
#line 1026 "ScrollWidget.c"
	} else {
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp1_ = FALSE;
#line 1030 "ScrollWidget.c"
	}
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp4_ = _tmp1_;
#line 160 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp4_) {
#line 1036 "ScrollWidget.c"
		GtkAdjustment* _tmp5_ = NULL;
		GtkAdjustment* _tmp6_ = NULL;
		GtkAdjustment* _tmp7_ = NULL;
		GtkAdjustment* _tmp8_ = NULL;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		GtkAdjustment* _tmp11_ = NULL;
		GtkAdjustment* _tmp12_ = NULL;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		GtkAdjustment* _tmp15_ = NULL;
		GtkAdjustment* _tmp16_ = NULL;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp5_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp6_ = _tmp5_;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp7_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp8_ = _tmp7_;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_adjustment_get_upper (_tmp8_);
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp12_ = _tmp11_;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp13_ = gtk_adjustment_get_page_size (_tmp12_);
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp14_ = _tmp13_;
#line 161 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp6_, _tmp10_ - _tmp14_);
#line 162 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp15_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 162 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp16_ = _tmp15_;
#line 162 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_value_changed (_tmp16_);
#line 163 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		block45_data_unref (_data45_);
#line 163 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_data45_ = NULL;
#line 163 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		return;
#line 1083 "ScrollWidget.c"
	}
#line 166 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp17_ = g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), "size-allocate", (GCallback) ___lambda51__gtk_widget_size_allocate, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
#line 166 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->scroll_down_id = _tmp17_;
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	block45_data_unref (_data45_);
#line 159 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_data45_ = NULL;
#line 1093 "ScrollWidget.c"
}


static gboolean scroll_widget_scroll_up_tick_cb (ScrollWidget* self, GtkWidget* widget, GdkFrameClock* frame_clock) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint64 now = 0LL;
	GdkFrameClock* _tmp5_ = NULL;
	gint64 _tmp6_ = 0LL;
	gdouble t = 0.0;
	gint64 _tmp7_ = 0LL;
	gint64 _tmp8_ = 0LL;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	GtkAdjustment* _tmp15_ = NULL;
	GtkAdjustment* _tmp16_ = NULL;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gboolean _tmp20_ = FALSE;
	GtkAdjustment* _tmp21_ = NULL;
	GtkAdjustment* _tmp22_ = NULL;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	gboolean _tmp27_ = FALSE;
#line 184 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), FALSE);
#line 184 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (GTK_IS_WIDGET (widget), FALSE);
#line 184 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (GDK_IS_FRAME_CLOCK (frame_clock), FALSE);
#line 185 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_widget_get_mapped (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 185 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (!_tmp0_) {
#line 1129 "ScrollWidget.c"
		GtkAdjustment* _tmp1_ = NULL;
		GtkAdjustment* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
#line 186 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp1_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 186 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp2_ = _tmp1_;
#line 186 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp3_ = self->priv->transition_start_value;
#line 186 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp4_ = self->priv->transition_diff;
#line 186 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp2_, _tmp3_ + _tmp4_);
#line 187 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		result = FALSE;
#line 187 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		return result;
#line 1148 "ScrollWidget.c"
	}
#line 190 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp5_ = frame_clock;
#line 190 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp6_ = gdk_frame_clock_get_frame_time (_tmp5_);
#line 190 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	now = _tmp6_;
#line 192 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	t = 1.0;
#line 193 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp7_ = now;
#line 193 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp8_ = self->priv->end_time;
#line 193 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp7_ < _tmp8_) {
#line 1164 "ScrollWidget.c"
		gint64 _tmp9_ = 0LL;
		gint64 _tmp10_ = 0LL;
		gint64 _tmp11_ = 0LL;
		gint64 _tmp12_ = 0LL;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp9_ = now;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp10_ = self->priv->start_time;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp11_ = self->priv->end_time;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp12_ = self->priv->start_time;
#line 194 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		t = (_tmp9_ - _tmp10_) / ((gdouble) (_tmp11_ - _tmp12_));
#line 1179 "ScrollWidget.c"
	}
#line 196 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp13_ = t;
#line 196 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp14_ = scroll_widget_ease_out_cubic (self, _tmp13_);
#line 196 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	t = _tmp14_;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp15_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 198 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp16_ = _tmp15_;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp17_ = self->priv->transition_start_value;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp18_ = t;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp19_ = self->priv->transition_diff;
#line 198 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	gtk_adjustment_set_value (_tmp16_, _tmp17_ + (_tmp18_ * _tmp19_));
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp21_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp22_ = _tmp21_;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp24_ = _tmp23_;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp24_ <= ((gdouble) 0)) {
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp20_ = TRUE;
#line 1211 "ScrollWidget.c"
	} else {
		gint64 _tmp25_ = 0LL;
		gint64 _tmp26_ = 0LL;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp25_ = now;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp26_ = self->priv->end_time;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		_tmp20_ = _tmp25_ >= _tmp26_;
#line 1221 "ScrollWidget.c"
	}
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp27_ = _tmp20_;
#line 199 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	if (_tmp27_) {
#line 200 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		result = FALSE;
#line 200 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		return result;
#line 1231 "ScrollWidget.c"
	}
#line 202 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	result = TRUE;
#line 202 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return result;
#line 1237 "ScrollWidget.c"
}


static gdouble scroll_widget_ease_out_cubic (ScrollWidget* self, gdouble t) {
	gdouble result = 0.0;
	gdouble p = 0.0;
	gdouble _tmp0_ = 0.0;
#line 205 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), 0.0);
#line 206 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = t;
#line 206 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	p = _tmp0_ - 1;
#line 207 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	result = ((p * p) * p) + 1;
#line 207 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return result;
#line 1255 "ScrollWidget.c"
}


ScrollWidget* scroll_widget_construct (GType object_type) {
	ScrollWidget * self = NULL;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self = (ScrollWidget*) g_object_new (object_type, NULL);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return self;
#line 1265 "ScrollWidget.c"
}


ScrollWidget* scroll_widget_new (void) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return scroll_widget_construct (TYPE_SCROLL_WIDGET);
#line 1272 "ScrollWidget.c"
}


gdouble scroll_widget_get_end_diff (ScrollWidget* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), 0.0);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = self->priv->_end_diff;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return result;
#line 1287 "ScrollWidget.c"
}


void scroll_widget_set_end_diff (ScrollWidget* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_if_fail (IS_SCROLL_WIDGET (self));
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->_end_diff = _tmp0_;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_object_notify ((GObject *) self, "end-diff");
#line 1301 "ScrollWidget.c"
}


gboolean scroll_widget_get_scrolled_down (ScrollWidget* self) {
	gboolean result;
	GtkAdjustment* _tmp0_ = NULL;
	GtkAdjustment* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	GtkAdjustment* _tmp4_ = NULL;
	GtkAdjustment* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	GtkAdjustment* _tmp8_ = NULL;
	GtkAdjustment* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), FALSE);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp4_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp5_ = _tmp4_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp6_ = gtk_adjustment_get_upper (_tmp5_);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp7_ = _tmp6_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp8_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp9_ = _tmp8_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp10_ = gtk_adjustment_get_page_size (_tmp9_);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp11_ = _tmp10_;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	result = _tmp3_ >= ((_tmp7_ - _tmp11_) - 5);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return result;
#line 1349 "ScrollWidget.c"
}


gboolean scroll_widget_get_scrolled_up (ScrollWidget* self) {
	gboolean result;
	GtkAdjustment* _tmp0_ = NULL;
	GtkAdjustment* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), FALSE);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	result = _tmp3_ <= ((gdouble) 5);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return result;
#line 1373 "ScrollWidget.c"
}


static void _scroll_widget_keep_upper_func_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	scroll_widget_keep_upper_func (self);
#line 1380 "ScrollWidget.c"
}


static void _scroll_widget_keep_value_func_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 52 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	scroll_widget_keep_value_func (self);
#line 1387 "ScrollWidget.c"
}


static GObject * scroll_widget_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ScrollWidget * self;
	GtkAdjustment* _tmp0_ = NULL;
	GtkAdjustment* _tmp1_ = NULL;
	GtkAdjustment* _tmp2_ = NULL;
	GtkAdjustment* _tmp3_ = NULL;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	parent_class = G_OBJECT_CLASS (scroll_widget_parent_class);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 51 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_OBJECT, GObject), "notify::upper", (GCallback) _scroll_widget_keep_upper_func_g_object_notify, self, 0);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindow));
#line 52 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, G_TYPE_OBJECT, GObject), "notify::value", (GCallback) _scroll_widget_keep_value_func_g_object_notify, self, 0);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	return obj;
#line 1419 "ScrollWidget.c"
}


static void scroll_widget_class_init (ScrollWidgetClass * klass) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	scroll_widget_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_type_class_add_private (klass, sizeof (ScrollWidgetPrivate));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scroll_widget_get_property;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scroll_widget_set_property;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = scroll_widget_constructor;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = scroll_widget_finalize;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_END_DIFF, g_param_spec_double ("end-diff", "end-diff", "end-diff", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 150, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_SCROLLED_DOWN, g_param_spec_boolean ("scrolled-down", "scrolled-down", "scrolled-down", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_SCROLLED_UP, g_param_spec_boolean ("scrolled-up", "scrolled-up", "scrolled-up", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_signal_new ("scrolled_to_start", TYPE_SCROLL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	g_signal_new ("scrolled_to_end", TYPE_SCROLL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1446 "ScrollWidget.c"
}


static void scroll_widget_instance_init (ScrollWidget * self) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv = SCROLL_WIDGET_GET_PRIVATE (self);
#line 30 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->balance = NONE;
#line 31 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self->priv->_end_diff = (gdouble) 150;
#line 1457 "ScrollWidget.c"
}


static void scroll_widget_finalize (GObject* obj) {
	ScrollWidget * self;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (scroll_widget_parent_class)->finalize (obj);
#line 1467 "ScrollWidget.c"
}


GType scroll_widget_get_type (void) {
	static volatile gsize scroll_widget_type_id__volatile = 0;
	if (g_once_init_enter (&scroll_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ScrollWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scroll_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScrollWidget), 0, (GInstanceInitFunc) scroll_widget_instance_init, NULL };
		GType scroll_widget_type_id;
		scroll_widget_type_id = g_type_register_static (GTK_TYPE_SCROLLED_WINDOW, "ScrollWidget", &g_define_type_info, 0);
		g_once_init_leave (&scroll_widget_type_id__volatile, scroll_widget_type_id);
	}
	return scroll_widget_type_id__volatile;
}


static void _vala_scroll_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	switch (property_id) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_END_DIFF:
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_value_set_double (value, scroll_widget_get_end_diff (self));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		break;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_SCROLLED_DOWN:
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_value_set_boolean (value, scroll_widget_get_scrolled_down (self));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		break;
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_SCROLLED_UP:
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		g_value_set_boolean (value, scroll_widget_get_scrolled_up (self));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		break;
#line 1506 "ScrollWidget.c"
		default:
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		break;
#line 1512 "ScrollWidget.c"
	}
}


static void _vala_scroll_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
	switch (property_id) {
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_END_DIFF:
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		scroll_widget_set_end_diff (self, g_value_get_double (value));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		break;
#line 1528 "ScrollWidget.c"
		default:
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/ScrollWidget.vala"
		break;
#line 1534 "ScrollWidget.c"
	}
}



