/* TextButton.c generated by valac 0.22.1, the Vala compiler
 * generated from TextButton.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_TEXT_BUTTON (text_button_get_type ())
#define TEXT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_BUTTON, TextButton))
#define TEXT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_BUTTON, TextButtonClass))
#define IS_TEXT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_BUTTON))
#define IS_TEXT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_BUTTON))
#define TEXT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_BUTTON, TextButtonClass))

typedef struct _TextButton TextButton;
typedef struct _TextButtonClass TextButtonClass;
typedef struct _TextButtonPrivate TextButtonPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TextButton {
	GtkButton parent_instance;
	TextButtonPrivate * priv;
};

struct _TextButtonClass {
	GtkButtonClass parent_class;
};


static gpointer text_button_parent_class = NULL;

GType text_button_get_type (void) G_GNUC_CONST;
enum  {
	TEXT_BUTTON_DUMMY_PROPERTY
};
TextButton* text_button_new (const gchar* label);
TextButton* text_button_construct (GType object_type, const gchar* label);
void text_button_set_markup (TextButton* self, const gchar* text);


TextButton* text_button_construct (GType object_type, const gchar* label) {
	TextButton * self = NULL;
	const gchar* _tmp0_ = NULL;
	GtkStyleContext* _tmp2_ = NULL;
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	self = (TextButton*) g_object_new (object_type, NULL);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp0_ = label;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 74 "TextButton.c"
		const gchar* _tmp1_ = NULL;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		_tmp1_ = label;
#line 23 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BUTTON, GtkButton), _tmp1_);
#line 80 "TextButton.c"
	}
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 24 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	gtk_style_context_add_class (_tmp2_, "text-only-button");
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	return self;
#line 88 "TextButton.c"
}


TextButton* text_button_new (const gchar* label) {
#line 21 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	return text_button_construct (TYPE_TEXT_BUTTON, label);
#line 95 "TextButton.c"
}


/**
   * Adds a GtkLabel to the Button using the given text as markup.
   * If the button already contains another child, that will either be replaced if it's
   * no instance of GtkLabel, or - if it's a GtkLabel already - be reused.
   *
   * @param text The markup to use(see pango markup)
   */
static gpointer _g_object_ref0 (gpointer self) {
#line 37 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 109 "TextButton.c"
}


void text_button_set_markup (TextButton* self, const gchar* text) {
	GtkLabel* label = NULL;
	GtkWidget* child = NULL;
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	GtkLabel* _tmp13_ = NULL;
	GtkLabel* _tmp14_ = NULL;
	GtkLabel* _tmp15_ = NULL;
	GtkLabel* _tmp16_ = NULL;
	GtkContainer* _tmp17_ = NULL;
	GtkContainer* _tmp18_ = NULL;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	g_return_if_fail (IS_TEXT_BUTTON (self));
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	g_return_if_fail (text != NULL);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	label = NULL;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp0_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BIN, GtkBin));
#line 37 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	child = _tmp1_;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp2_ = child;
#line 38 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	if (_tmp2_ != NULL) {
#line 141 "TextButton.c"
		GtkWidget* _tmp3_ = NULL;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		_tmp3_ = child;
#line 39 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GTK_TYPE_LABEL)) {
#line 147 "TextButton.c"
			GtkWidget* _tmp4_ = NULL;
			GtkLabel* _tmp5_ = NULL;
			GtkLabel* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp4_ = child;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GTK_TYPE_LABEL, GtkLabel));
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_g_object_unref0 (label);
#line 40 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			label = _tmp5_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp6_ = label;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp7_ = text;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			gtk_label_set_markup (_tmp6_, _tmp7_);
#line 166 "TextButton.c"
		} else {
			GtkWidget* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			GtkLabel* _tmp10_ = NULL;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp8_ = child;
#line 43 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_CONTAINER, GtkContainer), _tmp8_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp9_ = text;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_tmp10_ = (GtkLabel*) gtk_label_new (_tmp9_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			g_object_ref_sink (_tmp10_);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			_g_object_unref0 (label);
#line 44 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
			label = _tmp10_;
#line 185 "TextButton.c"
		}
	} else {
		const gchar* _tmp11_ = NULL;
		GtkLabel* _tmp12_ = NULL;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		_tmp11_ = text;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		_tmp12_ = (GtkLabel*) gtk_label_new (_tmp11_);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		g_object_ref_sink (_tmp12_);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		_g_object_unref0 (label);
#line 47 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		label = _tmp12_;
#line 200 "TextButton.c"
	}
#line 49 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp13_ = label;
#line 49 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	gtk_label_set_use_markup (_tmp13_, TRUE);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp14_ = label;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	gtk_label_set_justify (_tmp14_, GTK_JUSTIFY_CENTER);
#line 52 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp15_ = label;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp16_ = label;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp17_ = gtk_widget_get_parent (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GTK_TYPE_WIDGET, GtkWidget));
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_tmp18_ = _tmp17_;
#line 53 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	if (_tmp18_ == NULL) {
#line 222 "TextButton.c"
		GtkLabel* _tmp19_ = NULL;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		_tmp19_ = label;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_CONTAINER, GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GTK_TYPE_WIDGET, GtkWidget));
#line 228 "TextButton.c"
	}
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_g_object_unref0 (child);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	_g_object_unref0 (label);
#line 234 "TextButton.c"
}


static void text_button_class_init (TextButtonClass * klass) {
#line 19 "/builddir/build/BUILD/corebird-0.7/src/widgets/TextButton.vala"
	text_button_parent_class = g_type_class_peek_parent (klass);
#line 241 "TextButton.c"
}


static void text_button_instance_init (TextButton * self) {
}


GType text_button_get_type (void) {
	static volatile gsize text_button_type_id__volatile = 0;
	if (g_once_init_enter (&text_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TextButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextButton), 0, (GInstanceInitFunc) text_button_instance_init, NULL };
		GType text_button_type_id;
		text_button_type_id = g_type_register_static (GTK_TYPE_BUTTON, "TextButton", &g_define_type_info, 0);
		g_once_init_leave (&text_button_type_id__volatile, text_button_type_id);
	}
	return text_button_type_id__volatile;
}



