/* ImageDialog.c generated by valac 0.22.1, the Vala compiler
 * generated from ImageDialog.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define TYPE_IMAGE_DIALOG (image_dialog_get_type ())
#define IMAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_DIALOG, ImageDialog))
#define IMAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_DIALOG, ImageDialogClass))
#define IS_IMAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_DIALOG))
#define IS_IMAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_DIALOG))
#define IMAGE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_DIALOG, ImageDialogClass))

typedef struct _ImageDialog ImageDialog;
typedef struct _ImageDialogClass ImageDialogClass;
typedef struct _ImageDialogPrivate ImageDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ImageDialog {
	GtkWindow parent_instance;
	ImageDialogPrivate * priv;
};

struct _ImageDialogClass {
	GtkWindowClass parent_class;
};

struct _ImageDialogPrivate {
	GtkScrolledWindow* scroller;
	GtkImage* image;
	GtkMenu* image_context_menu;
	GtkWindow* parent;
	gchar* path;
	gdouble dnd_x;
	gdouble dnd_y;
};


static gpointer image_dialog_parent_class = NULL;

GType image_dialog_get_type (void) G_GNUC_CONST;
#define IMAGE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMAGE_DIALOG, ImageDialogPrivate))
enum  {
	IMAGE_DIALOG_DUMMY_PROPERTY
};
ImageDialog* image_dialog_new (GtkWindow* parent, const gchar* path);
ImageDialog* image_dialog_construct (GType object_type, GtkWindow* parent, const gchar* path);
static gboolean image_dialog_event_box_motion_notify_cb (ImageDialog* self, GdkEventMotion* evt);
static gboolean _image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean image_dialog_event_box_button_press_cb (ImageDialog* self, GdkEventButton* evt);
static gboolean _image_dialog_event_box_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void image_dialog_save_item_activated_cb (ImageDialog* self);
gchar* utils_get_file_name (const gchar* path);
static void _image_dialog_save_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static gboolean image_dialog_button_press_event_cb (ImageDialog* self, GdkEventButton* evt);
static gboolean _image_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean image_dialog_key_press_event_cb (ImageDialog* self);
static gboolean _image_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static void image_dialog_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 37 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 95 "ImageDialog.c"
}


ImageDialog* image_dialog_construct (GType object_type, GtkWindow* parent, const gchar* path) {
	ImageDialog * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GtkWindow* _tmp2_ = NULL;
	GtkWindow* _tmp3_ = NULL;
	GdkPixbuf* pixbuf = NULL;
	gint img_width = 0;
	GdkPixbuf* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint img_height = 0;
	GdkPixbuf* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gint win_width = 0;
	gint win_height = 0;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gboolean _tmp35_ = FALSE;
	gint _tmp36_ = 0;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gint _tmp45_ = 0;
	gboolean _tmp47_ = FALSE;
	GtkScrolledWindow* _tmp53_ = NULL;
	gint _tmp54_ = 0;
	gint _tmp55_ = 0;
	GtkWindow* _tmp56_ = NULL;
	GError * _inner_error_ = NULL;
#line 35 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (GTK_IS_WINDOW (parent), NULL);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	self = (ImageDialog*) g_object_new (object_type, NULL);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp0_ = path;
#line 36 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_free0 (self->priv->path);
#line 36 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	self->priv->path = _tmp1_;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp2_ = parent;
#line 37 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->parent);
#line 37 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	self->priv->parent = _tmp3_;
#line 40 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	pixbuf = NULL;
#line 153 "ImageDialog.c"
	{
		GdkPixbuf* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		GdkPixbuf* _tmp6_ = NULL;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp5_ = path;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp6_ = gdk_pixbuf_new_from_file (_tmp5_, &_inner_error_);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp4_ = _tmp6_;
#line 42 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		if (_inner_error_ != NULL) {
#line 166 "ImageDialog.c"
			goto __catch90_g_error;
		}
#line 42 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_object_unref0 (pixbuf);
#line 42 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		pixbuf = _tmp4_;
#line 173 "ImageDialog.c"
	}
	goto __finally90;
	__catch90_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		e = _inner_error_;
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp7_ = e;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp8_ = _tmp7_->message;
#line 44 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_critical ("ImageDialog.vala:44: %s", _tmp8_);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_error_free0 (e);
#line 193 "ImageDialog.c"
	}
	__finally90:
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_inner_error_ != NULL) {
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_object_unref0 (pixbuf);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_clear_error (&_inner_error_);
#line 41 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		return NULL;
#line 206 "ImageDialog.c"
	}
	{
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp9_ = path;
#line 47 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp10_ = g_str_has_suffix (_tmp9_, "gif");
#line 47 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		if (_tmp10_) {
#line 217 "ImageDialog.c"
			GdkPixbufAnimation* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			GdkPixbufAnimation* _tmp13_ = NULL;
			GtkImage* _tmp14_ = NULL;
			GdkPixbufAnimation* _tmp15_ = NULL;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp12_ = path;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp13_ = gdk_pixbuf_animation_new_from_file (_tmp12_, &_inner_error_);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp11_ = _tmp13_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			if (_inner_error_ != NULL) {
#line 231 "ImageDialog.c"
				goto __catch91_g_error;
			}
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp14_ = self->priv->image;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp15_ = _tmp11_;
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			g_object_set (_tmp14_, "pixbuf-animation", _tmp15_, NULL);
#line 48 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_object_unref0 (_tmp15_);
#line 242 "ImageDialog.c"
		} else {
			GdkPixbuf* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			GdkPixbuf* _tmp18_ = NULL;
			GtkImage* _tmp19_ = NULL;
			GdkPixbuf* _tmp20_ = NULL;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp17_ = path;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp18_ = gdk_pixbuf_new_from_file (_tmp17_, &_inner_error_);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp16_ = _tmp18_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			if (_inner_error_ != NULL) {
#line 257 "ImageDialog.c"
				goto __catch91_g_error;
			}
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp19_ = self->priv->image;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp20_ = _tmp16_;
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			g_object_set (_tmp19_, "pixbuf", _tmp20_, NULL);
#line 50 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_object_unref0 (_tmp20_);
#line 268 "ImageDialog.c"
		}
	}
	goto __finally91;
	__catch91_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		e = _inner_error_;
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp21_ = e;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp22_ = _tmp21_->message;
#line 52 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_critical ("ImageDialog.vala:52: %s", _tmp22_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_error_free0 (e);
#line 289 "ImageDialog.c"
	}
	__finally91:
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_inner_error_ != NULL) {
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_object_unref0 (pixbuf);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_clear_error (&_inner_error_);
#line 46 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		return NULL;
#line 302 "ImageDialog.c"
	}
#line 54 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp23_ = pixbuf;
#line 54 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp24_ = gdk_pixbuf_get_width (_tmp23_);
#line 54 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	img_width = _tmp24_;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp25_ = pixbuf;
#line 55 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp26_ = gdk_pixbuf_get_height (_tmp25_);
#line 55 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	img_height = _tmp26_;
#line 57 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	win_width = 800;
#line 58 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	win_height = 600;
#line 59 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp27_ = img_width;
#line 59 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp28_ = gdk_screen_width ();
#line 59 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (((gdouble) _tmp27_) <= (_tmp28_ * 0.7)) {
#line 326 "ImageDialog.c"
		gint _tmp29_ = 0;
		GtkScrolledWindow* _tmp30_ = NULL;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp29_ = img_width;
#line 60 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		win_width = _tmp29_;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp30_ = self->priv->scroller;
#line 61 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_object_set (_tmp30_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 337 "ImageDialog.c"
	}
#line 64 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp31_ = img_height;
#line 64 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp32_ = gdk_screen_height ();
#line 64 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (((gdouble) _tmp31_) <= (_tmp32_ * 0.7)) {
#line 345 "ImageDialog.c"
		gint _tmp33_ = 0;
		GtkScrolledWindow* _tmp34_ = NULL;
#line 65 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp33_ = img_height;
#line 65 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		win_height = _tmp33_;
#line 66 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp34_ = self->priv->scroller;
#line 66 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_object_set (_tmp34_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 356 "ImageDialog.c"
	}
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp36_ = win_width;
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp36_ < 800) {
#line 362 "ImageDialog.c"
		gint _tmp37_ = 0;
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp37_ = win_height;
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp35_ = _tmp37_ == 600;
#line 368 "ImageDialog.c"
	} else {
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp35_ = FALSE;
#line 372 "ImageDialog.c"
	}
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp38_ = _tmp35_;
#line 69 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp38_) {
#line 378 "ImageDialog.c"
		gint add_width = 0;
		GtkScrolledWindow* _tmp39_ = NULL;
		GtkWidget* _tmp40_ = NULL;
		gint _tmp41_ = 0;
		gint _tmp42_ = 0;
		gint _tmp43_ = 0;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp39_ = self->priv->scroller;
#line 71 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp40_ = gtk_scrolled_window_get_vscrollbar (_tmp39_);
#line 71 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_widget_get_preferred_width (_tmp40_, NULL, &_tmp41_);
#line 71 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		add_width = _tmp41_;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp42_ = win_width;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp43_ = add_width;
#line 72 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		win_width = _tmp42_ + _tmp43_;
#line 399 "ImageDialog.c"
	}
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp45_ = win_width;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp45_ == 800) {
#line 405 "ImageDialog.c"
		gint _tmp46_ = 0;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp46_ = win_height;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp44_ = _tmp46_ < 600;
#line 411 "ImageDialog.c"
	} else {
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp44_ = FALSE;
#line 415 "ImageDialog.c"
	}
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp47_ = _tmp44_;
#line 75 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp47_) {
#line 421 "ImageDialog.c"
		gint add_height = 0;
		GtkScrolledWindow* _tmp48_ = NULL;
		GtkWidget* _tmp49_ = NULL;
		gint _tmp50_ = 0;
		gint _tmp51_ = 0;
		gint _tmp52_ = 0;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp48_ = self->priv->scroller;
#line 77 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp49_ = gtk_scrolled_window_get_hscrollbar (_tmp48_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_widget_get_preferred_width (_tmp49_, NULL, &_tmp50_);
#line 77 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		add_height = _tmp50_;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp51_ = win_height;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp52_ = add_height;
#line 78 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		win_height = _tmp51_ + _tmp52_;
#line 442 "ImageDialog.c"
	}
#line 81 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp53_ = self->priv->scroller;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp54_ = win_width;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp55_ = win_height;
#line 81 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GTK_TYPE_WIDGET, GtkWidget), _tmp54_, _tmp55_);
#line 82 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_window_set_modal (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), TRUE);
#line 83 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp56_ = parent;
#line 83 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), _tmp56_);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (pixbuf);
#line 35 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return self;
#line 462 "ImageDialog.c"
}


ImageDialog* image_dialog_new (GtkWindow* parent, const gchar* path) {
#line 35 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return image_dialog_construct (TYPE_IMAGE_DIALOG, parent, path);
#line 469 "ImageDialog.c"
}


static gboolean image_dialog_event_box_motion_notify_cb (ImageDialog* self, GdkEventMotion* evt) {
	gboolean result = FALSE;
	GdkEventMotion _tmp0_ = {0};
	GdkModifierType _tmp1_ = 0;
#line 87 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 87 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 88 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp0_ = *evt;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp1_ = _tmp0_.state;
#line 88 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if ((_tmp1_ & GDK_MODIFIER_MASK) >= GDK_BUTTON2_MASK) {
#line 487 "ImageDialog.c"
		gdouble diff_x = 0.0;
		gdouble _tmp2_ = 0.0;
		GdkEventMotion _tmp3_ = {0};
		gdouble _tmp4_ = 0.0;
		gdouble diff_y = 0.0;
		gdouble _tmp5_ = 0.0;
		GdkEventMotion _tmp6_ = {0};
		gdouble _tmp7_ = 0.0;
		GtkScrolledWindow* _tmp8_ = NULL;
		GtkAdjustment* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		GtkScrolledWindow* _tmp11_ = NULL;
		GtkAdjustment* _tmp12_ = NULL;
		GtkAdjustment* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		GtkScrolledWindow* _tmp17_ = NULL;
		GtkAdjustment* _tmp18_ = NULL;
		GtkAdjustment* _tmp19_ = NULL;
		GtkScrolledWindow* _tmp20_ = NULL;
		GtkAdjustment* _tmp21_ = NULL;
		GtkAdjustment* _tmp22_ = NULL;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_ = 0.0;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp2_ = self->priv->dnd_x;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp3_ = *evt;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp4_ = _tmp3_.x;
#line 89 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		diff_x = _tmp2_ - _tmp4_;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp5_ = self->priv->dnd_y;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp6_ = *evt;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp7_ = _tmp6_.y;
#line 90 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		diff_y = _tmp5_ - _tmp7_;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp8_ = self->priv->scroller;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment (_tmp8_);
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp10_ = _tmp9_;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp11_ = self->priv->scroller;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp12_ = gtk_scrolled_window_get_vadjustment (_tmp11_);
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp13_ = _tmp12_;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp14_ = gtk_adjustment_get_value (_tmp13_);
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp15_ = _tmp14_;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp16_ = diff_y;
#line 91 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_adjustment_set_value (_tmp13_, _tmp15_ + _tmp16_);
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp17_ = self->priv->scroller;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp18_ = gtk_scrolled_window_get_hadjustment (_tmp17_);
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp19_ = _tmp18_;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp20_ = self->priv->scroller;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp21_ = gtk_scrolled_window_get_hadjustment (_tmp20_);
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp22_ = _tmp21_;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp24_ = _tmp23_;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp25_ = diff_x;
#line 92 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_adjustment_set_value (_tmp22_, _tmp24_ + _tmp25_);
#line 93 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		result = TRUE;
#line 93 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		return result;
#line 574 "ImageDialog.c"
	}
#line 95 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	result = FALSE;
#line 95 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 580 "ImageDialog.c"
}


static gboolean _image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = image_dialog_event_box_motion_notify_cb (self, event);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 589 "ImageDialog.c"
}


static gboolean image_dialog_event_box_button_press_cb (ImageDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton _tmp0_ = {0};
	guint _tmp1_ = 0U;
#line 99 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 99 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 100 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp0_ = *evt;
#line 100 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp1_ = _tmp0_.button;
#line 100 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp1_ == ((guint) 2)) {
#line 607 "ImageDialog.c"
		GdkEventButton _tmp2_ = {0};
		gdouble _tmp3_ = 0.0;
		GdkEventButton _tmp4_ = {0};
		gdouble _tmp5_ = 0.0;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp2_ = *evt;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp3_ = _tmp2_.x;
#line 101 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		self->priv->dnd_x = _tmp3_;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp4_ = *evt;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp5_ = _tmp4_.y;
#line 102 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		self->priv->dnd_y = _tmp5_;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		result = TRUE;
#line 103 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		return result;
#line 628 "ImageDialog.c"
	}
#line 105 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	result = FALSE;
#line 105 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 634 "ImageDialog.c"
}


static gboolean _image_dialog_event_box_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = image_dialog_event_box_button_press_cb (self, event);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 643 "ImageDialog.c"
}


static void image_dialog_save_item_activated_cb (ImageDialog* self) {
	GtkFileChooserDialog* file_dialog = NULL;
	const gchar* _tmp0_ = NULL;
	GtkWindow* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkFileChooserDialog* _tmp4_ = NULL;
	gchar* filename = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GtkFileChooserDialog* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	GtkFileChooserDialog* _tmp9_ = NULL;
	gint response = 0;
	GtkFileChooserDialog* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GError * _inner_error_ = NULL;
#line 109 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_if_fail (IS_IMAGE_DIALOG (self));
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp0_ = _ ("Save image");
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp1_ = self->priv->parent;
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp2_ = _ ("Cancel");
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp3_ = _ ("Save");
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp4_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_tmp0_, _tmp1_, GTK_FILE_CHOOSER_ACTION_SAVE, _tmp2_, GTK_RESPONSE_CANCEL, _tmp3_, GTK_RESPONSE_ACCEPT, NULL);
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_object_ref_sink (_tmp4_);
#line 110 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	file_dialog = _tmp4_;
#line 114 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp5_ = self->priv->path;
#line 114 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp6_ = utils_get_file_name (_tmp5_);
#line 114 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	filename = _tmp6_;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp7_ = file_dialog;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp8_ = filename;
#line 115 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_file_chooser_set_current_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), _tmp8_);
#line 116 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp9_ = file_dialog;
#line 116 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GTK_TYPE_WINDOW, GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow));
#line 119 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp10_ = file_dialog;
#line 119 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp11_ = gtk_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GTK_TYPE_DIALOG, GtkDialog));
#line 119 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	response = _tmp11_;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp12_ = response;
#line 120 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp12_ == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 707 "ImageDialog.c"
		GFile* dest = NULL;
		GtkFileChooserDialog* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		GFile* _tmp16_ = NULL;
		GFile* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		GtkFileChooserDialog* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		GFile* source = NULL;
		const gchar* _tmp22_ = NULL;
		GFile* _tmp23_ = NULL;
		GtkFileChooserDialog* _tmp28_ = NULL;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp13_ = file_dialog;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp14_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp15_ = _tmp14_;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp16_ = g_file_new_for_uri (_tmp15_);
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp17_ = _tmp16_;
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_free0 (_tmp15_);
#line 121 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		dest = _tmp17_;
#line 122 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp18_ = self->priv->path;
#line 122 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_debug ("ImageDialog.vala:122: Source: %s", _tmp18_);
#line 123 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp19_ = file_dialog;
#line 123 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp20_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 123 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp21_ = _tmp20_;
#line 123 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		g_debug ("ImageDialog.vala:123: Destin: %s", _tmp21_);
#line 123 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_free0 (_tmp21_);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp22_ = self->priv->path;
#line 124 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp23_ = g_file_new_for_path (_tmp22_);
#line 124 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		source = _tmp23_;
#line 756 "ImageDialog.c"
		{
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_ = NULL;
#line 126 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp24_ = source;
#line 126 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp25_ = dest;
#line 126 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			g_file_copy (_tmp24_, _tmp25_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 126 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			if (_inner_error_ != NULL) {
#line 768 "ImageDialog.c"
				goto __catch92_g_error;
			}
		}
		goto __finally92;
		__catch92_g_error:
		{
			GError* e = NULL;
			GError* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			e = _inner_error_;
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_inner_error_ = NULL;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp26_ = e;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp27_ = _tmp26_->message;
#line 128 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			g_critical ("ImageDialog.vala:128: %s", _tmp27_);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_error_free0 (e);
#line 790 "ImageDialog.c"
		}
		__finally92:
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		if (_inner_error_ != NULL) {
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_object_unref0 (source);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_object_unref0 (dest);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_free0 (filename);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_g_object_unref0 (file_dialog);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			return;
#line 809 "ImageDialog.c"
		}
#line 130 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp28_ = file_dialog;
#line 130 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GTK_TYPE_WIDGET, GtkWidget));
#line 120 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_object_unref0 (source);
#line 120 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_g_object_unref0 (dest);
#line 819 "ImageDialog.c"
	} else {
		gint _tmp29_ = 0;
#line 131 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp29_ = response;
#line 131 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		if (_tmp29_ == ((gint) GTK_RESPONSE_CANCEL)) {
#line 826 "ImageDialog.c"
			GtkFileChooserDialog* _tmp30_ = NULL;
#line 132 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			_tmp30_ = file_dialog;
#line 132 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
			gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GTK_TYPE_WIDGET, GtkWidget));
#line 832 "ImageDialog.c"
		}
	}
#line 109 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_free0 (filename);
#line 109 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (file_dialog);
#line 839 "ImageDialog.c"
}


static void _image_dialog_save_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	image_dialog_save_item_activated_cb (self);
#line 846 "ImageDialog.c"
}


static gboolean image_dialog_button_press_event_cb (ImageDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton _tmp0_ = {0};
	guint _tmp1_ = 0U;
#line 137 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 137 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 138 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp0_ = *evt;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_tmp1_ = _tmp0_.button;
#line 138 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	if (_tmp1_ == ((guint) 3)) {
#line 864 "ImageDialog.c"
		GtkMenu* _tmp2_ = NULL;
		GdkEventButton _tmp3_ = {0};
		guint _tmp4_ = 0U;
		GdkEventButton _tmp5_ = {0};
		guint32 _tmp6_ = 0U;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp2_ = self->priv->image_context_menu;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp3_ = *evt;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp4_ = _tmp3_.button;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp5_ = *evt;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		_tmp6_ = _tmp5_.time;
#line 139 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_menu_popup (_tmp2_, NULL, NULL, NULL, NULL, _tmp4_, _tmp6_);
#line 882 "ImageDialog.c"
	} else {
#line 141 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 886 "ImageDialog.c"
	}
#line 143 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	result = TRUE;
#line 143 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 892 "ImageDialog.c"
}


static gboolean _image_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = image_dialog_button_press_event_cb (self, event);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 901 "ImageDialog.c"
}


static gboolean image_dialog_key_press_event_cb (ImageDialog* self) {
	gboolean result = FALSE;
#line 147 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 148 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 149 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	result = TRUE;
#line 149 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 915 "ImageDialog.c"
}


static gboolean _image_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = image_dialog_key_press_event_cb (self);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	return result;
#line 924 "ImageDialog.c"
}


static void image_dialog_class_init (ImageDialogClass * klass) {
	gint ImageDialog_private_offset;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	image_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	g_type_class_add_private (klass, sizeof (ImageDialogPrivate));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = image_dialog_finalize;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	ImageDialog_private_offset = g_type_class_get_instance_private_offset (klass);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/image-dialog.ui");
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scroller", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, scroller));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, image));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image_context_menu", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, image_context_menu));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "event_box_motion_notify_cb", G_CALLBACK(_image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "event_box_button_press_cb", G_CALLBACK(_image_dialog_event_box_button_press_cb_gtk_widget_button_press_event));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "save_item_activated_cb", G_CALLBACK(_image_dialog_save_item_activated_cb_gtk_menu_item_activate));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_press_event_cb", G_CALLBACK(_image_dialog_button_press_event_cb_gtk_widget_button_press_event));
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_image_dialog_key_press_event_cb_gtk_widget_key_press_event));
#line 956 "ImageDialog.c"
}


static void image_dialog_instance_init (ImageDialog * self) {
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	self->priv = IMAGE_DIALOG_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 965 "ImageDialog.c"
}


static void image_dialog_finalize (GObject* obj) {
	ImageDialog * self;
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_DIALOG, ImageDialog);
#line 24 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->scroller);
#line 26 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->image);
#line 28 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->image_context_menu);
#line 29 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->parent);
#line 31 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	_g_free0 (self->priv->path);
#line 22 "/builddir/build/BUILD/corebird-0.7/src/window/ImageDialog.vala"
	G_OBJECT_CLASS (image_dialog_parent_class)->finalize (obj);
#line 985 "ImageDialog.c"
}


GType image_dialog_get_type (void) {
	static volatile gsize image_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&image_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageDialog), 0, (GInstanceInitFunc) image_dialog_instance_init, NULL };
		GType image_dialog_type_id;
		image_dialog_type_id = g_type_register_static (GTK_TYPE_WINDOW, "ImageDialog", &g_define_type_info, 0);
		g_once_init_leave (&image_dialog_type_id__volatile, image_dialog_type_id);
	}
	return image_dialog_type_id__volatile;
}



